<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Directory
  {

   function __construct() { }

   public static function getDirectoryFieldsArray()
    {
     return array('directoryID','name','description','directory_type','enabled','languageID','parentID','icon','ts');
    }

   public static function getDirectoryItemFieldsArray()
    {
     return array('directory_itemID','title','render_mode','description','userID','source',
	              'pageID','hits','home_url','download_url',
				  'enabled','languageID','icon','directoryID','votes_counts','votes_sum','votes_average','directory_item_ts','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_DIRECTORY_ITEM:
        {
		 if(wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID','both'),false) &&
		    wm3Directory::canAddDirectoryItem($w3))
          return wm3Directory::addDirectoryItem($w3,0,true);
		 else
		   return wm3Directory::getDirectoryList($w3,0,false,false);
         break;
        }
       case WM3_cACTION_SAVE_DIRECTORY_ITEM:
        {
		 if(wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID','both'),false) &&
		    wm3Directory::canAddDirectoryItem($w3))
		  {
		   wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $error = wm3Directory::checkDirectoryItemError($w3);
           if(!$error) {
                        $lastID = wm3Directory::saveDirectoryItem($w3,true);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Directory::getDirectoryItemList($w3,$lastID,false);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Directory::addDirectoryItem($w3,$error,true);
				       }
		  }
		 else
		  {
		   return wm3Directory::getDirectoryList($w3,0,false,false);
	      }
         break;
        }

       /*case WM3_cACTION_EDIT_DIRECTORY_ITEM:
        {
         return wm3Directory::editDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DIRECTORY_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
         $error = wm3Directory::checkDirectoryItemError($w3);
         if(!$error) {
                      $lastID = wm3Directory::updateDirectoryItem($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Directory::getDirectoryItemList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Directory::editDirectoryItem($w3,$error);
					 }
         break;
        }*/
       case WM3_cACTION_SHOW_DIRECTORY_ITEM:
        {
         return wm3Directory::getDirectoryItemList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM:
        {
         wm3Directory::hitDirectoryItem($w3);
         return wm3Directory::renderDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_RATE_DIRECTORY_ITEM:
        {
         wm3Directory::rateDirectoryItem($w3);
         return wm3Directory::renderDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING:
        {
         return wm3Directory::renderDirectoryItemTopRating($w3,"ORDER BY votes_average DESC",1219,true,false,false)."<br><br>".
		        wm3Directory::renderDirectoryItemTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true,false)."<br><br>".
				wm3Directory::renderDirectoryItemTopRating($w3,"ORDER BY votes_counts DESC" ,1221,false,false,true);
         break;
        }
       case WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED:
        {
         return wm3Directory::renderDirectoryItemLastInserted($w3,"ORDER BY ts DESC",1218,30);
         break;
        }
       default:
        {
         return wm3Directory::getDirectoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_DIRECTORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");
         wm3Directory::disableDirectory($w3->getVariable('directoryID','get'));
		 wm3Sql::sqlQuery("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,$w3->getVariable('directoryID','get'),true,false);
         break;
        }
       case WM3_cACTION_ENABLE_DIRECTORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");
         wm3Directory::enableDirectory($w3->getVariable('directoryID','get'));
		 wm3Sql::sqlQuery("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,$w3->getVariable('directoryID','get'),true,false);
         break;
        }
       case WM3_cACTION_DELETE_DIRECTORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
         wm3Directory::enableDirectory($w3->getVariable('directoryID','get'));
         wm3Directory::deleteDirectory($w3->getVariable('directoryID','get'));
		 wm3Sql::sqlQuery("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,0,true,false);
         break;
        }
       case WM3_cACTION_ADD_DIRECTORY:
        {
         return wm3Directory::addDirectory($w3);
         break;
        }
       case WM3_cACTION_SAVE_DIRECTORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");			
         $error = wm3Directory::checkDirectoryError($w3);
         if(!$error) {
                      $lastID = wm3Directory::saveDirectory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Directory::getDirectoryList($w3,$lastID,true,false);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Directory::addDirectory($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_EDIT_DIRECTORY:
        {
         return wm3Directory::editDirectory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DIRECTORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");
         $error = wm3Directory::checkDirectoryError($w3,true);
         if(!$error) {
                      $lastID = wm3Directory::updateDirectory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Directory::getDirectoryList($w3,$lastID,true,false);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Directory::editDirectory($w3,$error);
		             }
         break;
        }
       /*case WM3_cACTION_DUPLICATE_DIRECTORY:
        {//TODO LOCK TABLE
         $lastID = wm3Directory::duplicateDirectory($w3);
         // $msg= message duplicated... //TODO
         return wm3Directory::getDirectoryList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_DISABLE_DIRECTORY_ITEM:
        {
         wm3Directory::disableDirectoryItem($w3->getVariable('directory_itemID','get'));
         return wm3Directory::getDirectoryItemList($w3,$w3->getVariable('directory_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DIRECTORY_ITEM:
        {
         wm3Directory::enableDirectoryItem($w3->getVariable('directory_itemID','get'));
         return wm3Directory::getDirectoryItemList($w3,$w3->getVariable('directory_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DIRECTORY_ITEM:
        {
         wm3Directory::deleteDirectoryItem($w3->getVariable('directory_itemID','get'));
         return wm3Directory::getDirectoryItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_DIRECTORY_ITEM:
        {
		 if(wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID','both')))
          return wm3Directory::addDirectoryItem($w3);
		 else
		  return wm3Directory::getDirectoryList($w3,0,true,false);
         break;
        }
       case WM3_cACTION_SAVE_DIRECTORY_ITEM:
        {
		 if(!wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID','both')))
		  {
		   return wm3Directory::getDirectoryList($w3,0,true,false);
	      }
		 else
		  {
		   wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
           $error = wm3Directory::checkDirectoryItemError($w3,true);
           if(!$error) {
                        $lastID = wm3Directory::saveDirectoryItem($w3);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Directory::getDirectoryItemList($w3,$lastID);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Directory::addDirectoryItem($w3,$error);
				       }
		  }
         break;
        }
       case WM3_cACTION_EDIT_DIRECTORY_ITEM:
        {
         return wm3Directory::editDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DIRECTORY_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
         $error = wm3Directory::checkDirectoryItemError($w3,true);
         if(!$error) {
                      $lastID = wm3Directory::updateDirectoryItem($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Directory::getDirectoryItemList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Directory::editDirectoryItem($w3,$error);
				     }
         break;
        }
       /*case WM3_cACTION_DUPLICATE_DIRECTORY_ITEM:
        {//TODO LOCK TABLE
         $lastID = wm3Directory::duplicateDirectoryItem($w3);
         // $msg= message duplicated... //TODO
         return wm3Directory::getDirectoryItemList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_SHOW_DIRECTORY_ITEM:
        {
         return wm3Directory::getDirectoryItemList($w3);
         break;
        }
       default:
        {
         return wm3Directory::getDirectoryList($w3);
        }
      }
    }

   public static function getDirectoryList($w3,$currentID = 0,$admin = true,$flag_directory = true)
    {
     // Get current directory subfolder list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $use_colors = false;
     if($admin) $items_per_row = 1; else $items_per_row = 4;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     // Fix directory delete bug
	 if($flag_directory) $directoryID = $w3->getVariable('directoryID','both');
	 else                $directoryID = $w3->getVariable('parentID','both');
     $pg = $w3->getVariable('pg','both');
     $filter       = $w3->getVariable('filter','both'); // Search fields
	 $filter_check = $w3->getVariable('filter_check','both');
     $query_filter = " WHERE parentID='$directoryID'";
     if($admin)
      {
       $width_name = 70;
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM;
       $columns = 8; $buttons = 6;
      }
     else
      {
       $pageID = $w3->getVariable('pageID','get');
       $page_link  = "&pageID=$pageID";
       $width_name = 25;
	   $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
       $query_filter .= " AND enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
       //if($allowed)
	    { $columns = 4; $buttons = 0; } //else { $columns = 1; $buttons = 0; } // Will be displayed 4 directories in a row 
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY name DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'directoryID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_directory_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(1160));
	 if($admin) {
		         array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY,"action_add.png","","",$w3->getWord(1163),0,16,16));
	             array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png","","",$w3->getWord(648),0,16,16));
				 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png","","",$w3->getWord(836),0,16,16));
				}
	 else       {
		         array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
				 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
			    }
     if($admin) array_push($_CONTENTS,"<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link,$admin));
	 else       array_push($_CONTENTS,"<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link.$page_link,$admin));
     array_push($_CONTENTS,"<br><i>".wm3Directory::getDirectoryDescription($directoryID)."</i>");
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_name,30,0),array(1156,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     if($admin) $pic_folder = "<img src=\"".WM3_cPATH_DATA."misc_folder.png\" width=\"16\" height=\"16\" border=\"0\" align=\"absmiddle\"> ";
	 else       $pic_folder = "<img src=\"".WM3_cPATH_DATA."misc_folder.png\" width=\"36\" height=\"36\" border=\"0\" align=\"absmiddle\"> ";
	 $pic_total_folders = "<img src=\"".WM3_cPATH_DATA."misc_folder_mini.png\" width=\"10\" height=\"8\" border=\"0\" align=\"absmiddle\">";
	 $pic_total_files   = "<img src=\"".WM3_cPATH_DATA."misc_file_mini.png\" width=\"7\" height=\"9\" border=\"0\" align=\"absmiddle\">";

     $_CONTENTS = array(); $_WIDTHS = array();
     while($row = mysql_fetch_object($rs))
      {
       $link = $base_link.$id_link.$extra_link."&directoryID=$row->directoryID";
       if($allowed) $allowed_link = $base_allowed_link."&directoryID=$row->directoryID";

       $total_folders = wm3Directory::countDirectoryFolders($w3,$row->directoryID);
       $total_files   = wm3Directory::countDirectoryFiles($w3,$row->directoryID);
       if($admin) $name = "<a href=\"$link\">$pic_folder$row->name</a><br><i>$row->description</i>";
	   else       {
                   if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DIRECTORY,"action_edit.png",$w3->getWord(178)); else $button = "";
			       $picture_content     = "<a href=\"$link$page_link\">".$pic_folder."</a>";
				   $button_show = wm3Util::actionButton("$link$page_link&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png",$w3->getWord(648),"","",0,16,16);
				   if($row->directory_type == WM3_cDIRECTORY_FILE &&
	                  wm3Directory::canAddDirectoryItem($w3))
                    $button_add = wm3Util::actionButton("$link$page_link&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png",$w3->getWord(836),"","",0,16,16); else $button_add = "";
				   $title_content       = "<nobr><a href=\"$link$page_link\">$row->name</a> $button_show $button_add $button</nobr><br><nobr>($pic_total_folders=$total_folders, $pic_total_files=$total_files)</nobr>";
				   $description_content = wm3Directory::renderDirectorySubfoldersPreview($w3,$row->directoryID,$base_link.$id_link.$extra_link.$page_link);
                   ob_start();
                   require($w3->getSkinObj()->getFrameDirectory());
                   $item_content = ob_get_contents();
                   ob_end_clean();
                   array_push($_CONTENTS,$item_content);
				  }
       if($admin) {
		           array_push($_CONTENTS,$name); array_push($_WIDTHS,$width_name);
                   $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
                   $info = $lang_flag." ($pic_total_folders=$total_folders, $pic_total_files=$total_files)<br>";
		           if($row->directory_type == WM3_cDIRECTORY_FILE) $info .= $w3->getWord(1165); else $info .= $w3->getWord(1166);
                   array_push($_CONTENTS,$info); array_push($_WIDTHS,30);

                   // Buttons
                   if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&parentID=$row->parentID&action=".WM3_cACTION_DISABLE_DIRECTORY,"action_disable.png",$w3->getWord(180)));
                   else              array_push($_CONTENTS,wm3Util::actionButton("$link&parentID=$row->parentID&action=".WM3_cACTION_ENABLE_DIRECTORY,"action_enable.png",$w3->getWord(181)));
                   array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_DIRECTORY,"action_add_directory.png",$w3->getWord(1163)));
                   array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show_file.png",$w3->getWord(648)));
                   if($row->directory_type == WM3_cDIRECTORY_FILE) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add_file.png",$w3->getWord(836)));
				   else                                            array_push($_CONTENTS,wm3Util::renderImg("action_add_file_inactive.png",'',24,24));
                   array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_DIRECTORY,"action_edit.png",$w3->getWord(178)));
                   array_push($_CONTENTS,wm3Util::actionButton("$link&parentID=$row->parentID&action=".WM3_cACTION_DELETE_DIRECTORY,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));

				   array_push($_WIDTHS,0,$width_name);
                  }
       else       {
		           //if($filter) array_push($_WIDTHS,0,100,0);
		           //else
		           array_push($_WIDTHS,25);
		          }
       $aux = ($p+1)%$items_per_row;
       if($aux == 0 || ($p+1+$pg*12) == $total_items)
        {
         if($admin) { $c = $p; $test = $row->directoryID==$currentID; } else { if($use_colors) $c = $p; else $c = 0; $test = false; }
         if($aux != 0) // Incomplete row 
          for($i = $aux; $i < $items_per_row; $i++) 
           array_push($_CONTENTS,"");
         $str .= wm3Section::makeItemList($w3,$c,$_WIDTHS,$_CONTENTS,$test);
         $_CONTENTS = array(); $_WIDTHS = array();
        }
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link);
	   else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link.$id_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getDirectoryItemList($w3,$currentID = 0,$admin = true)
    {
     // Get current directory items list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
	 $directoryID = $w3->getVariable('directoryID','both');
     $pg = $w3->getVariable('pg','both');
     $filter       = $w3->getVariable('filter','both'); // Search fields
	 $filter_check = $w3->getVariable('filter_check','both');
     $query_filter = " WHERE directoryID='$directoryID'";
     if($filter)
      {
       $search_link   = "&filter=$filter";
	   if($filter_check) 
	    {
		 $search_link .= "&filter_check=$filter_check";
		 $query_filter = "WHERE 1=1";
		}
       $query_filter .= " AND title LIKE '%$filter%'";
      }
     else { $search_link = ""; }
     if($admin)
      {
       $width_title = 70;
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM;
       $columns = 6; $buttons = 4;
      }
     else
      {
       $width_title = 80;
       $pageID = $w3->getVariable('pageID','get');
       $page_link  = "&pageID=$pageID";	   
       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
       $query_filter .= " AND enabled='".WM3_cENABLED."' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')";
       if($allowed) { $columns = 4; $buttons = 1; } else { $columns = 3; $buttons = 0; }
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $id_link = ""; //"&directoryID=$directoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY title DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'directory_itemID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_directory_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(1160));
	 if($admin) {
		         array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY,"action_add.png","","",$w3->getWord(1163),0,16,16));
	             array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png","","",$w3->getWord(648),0,16,16));
				 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png","","",$w3->getWord(836),0,16,16));
				}
	 else       {
                 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
				 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
				}
     if($admin) array_push($_CONTENTS,"<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link,$admin));
	 else       array_push($_CONTENTS,"<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link.$page_link,$admin));
     array_push($_CONTENTS,"<br><i>".wm3Directory::getDirectoryDescription($directoryID)."</i>");
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_title,30,0),array(228,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     $pic_download = "<img src=\"".WM3_cPATH_DATA."misc_download.png\" width=\"16\" height=\"16\" border=\"0\" align=\"absmiddle\">";

     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID";
       if($allowed) $allowed_link = $base_allowed_link."&directory_itemID=$row->directory_itemID";
       if($admin)
        {
	     if($row->source == WM3_cFILE_INTERNAL) { $title = wm3Page::makePageLink($row->pageID,wm3Util::renderContent($w3,$row->title,$row->render_mode)); }
	     else                                   {
			                                     $title =  "<a href=\"$row->home_url\" target=\"_blank\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a>";
	                                             if($row->download_url) $title .= " <a href=\"$row->download_url\" target=\"_blank\">$pic_download</a>";
	                                            }
	     $hits = "($row->hits hits)";
	     $rating = "(Rating: $row->votes_average)";
	     $title = "$title $hits $rating";
	     if($filter && $filter_check)
	      {
		   // For the search in all categories
		   $title .= "<br>(Path:".wm3Directory::makeDirectoryPath($w3,$row->directoryID,$base_link,$admin).")";
		  }
         array_push($_CONTENTS,$title); array_push($_WIDTHS,$width_title);
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $info = $lang_flag."<br>";
		 if($row->source == WM3_cFILE_INTERNAL) $info .= $w3->getWord(1181); else $info .= $w3->getWord(1182);
		 $login = wm3User::getUserLogin($row->userID); if(!$login) $login = $w3->getWord(988);
		 $info .= " (".$w3->getWord(1194)." $login)";
         array_push($_CONTENTS,$info); array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_DIRECTORY_ITEM,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_DIRECTORY_ITEM,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM,"action_edit.png",$w3->getWord(178)));
		 array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_DIRECTORY_ITEM,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_DIRECTORY_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
        }
       else
        {
		 $published = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
		 $updated   = wm3Util::renderDate($w3,$row->directory_item_ts,$w3->getHomeLanguage());
		 $title  = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM."\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br><br>
		            <i>Published: $published</i><br><i>Last update: $updated</i><br>";
		 $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)." ($row->votes_average)</nobr>";
		 $hits   = "<nobr>$row->hits hits</nobr>";
		 array_push($_CONTENTS,$title,$rating,$hits); array_push($_WIDTHS,$width_title,15,5);
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->directory_itemID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkDirectoryError($w3,$update = false)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray());
     if(!$_FIELD['name']) return 1;
	 if($update) { if(!wm3Directory::existsDirectory($_FIELD['directoryID'])) return 2; }
	 else        { if(!wm3Directory::existsDirectory($_FIELD['parentID']))    return 2; }
     return 0;
    }

   public static function addDirectory($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Directory::getDirectoryFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Empty name 
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Invalid directory 
        {
         //$_STYLE['name']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid directory".$w3->getWord(-1);
         break;
        }
       default:
        {
         // Default values for the form
		 $_FIELD['parentID'] = $w3->getVariable('directoryID','get'); // Take parentID from get
         $_FIELD['enabled']  = WM3_cENABLED;
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1169);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_DIRECTORY;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_directory_form.inc");
     return $content;
    }

   public static function editDirectory($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                               WHERE directoryID = '".$w3->getVariable('directoryID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Directory::getDirectoryFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No message 
        {
         $_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid directory 
        {
         //$_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid directory".$w3->getWord(-1);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit message ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_DIRECTORY;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_directory_form.inc");
     return $content;
    }

   public static function saveDirectory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_directories',$_FIELD);
     return wm3Sql::getLastInsertID();		
    }

   public static function updateDirectory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories
                       SET   name           = '".$_FIELD['name']."',
					         description    = '".$_FIELD['description']."',
							 directory_type = '".$_FIELD['directory_type']."',
							 icon           = '".$_FIELD['icon']."',
                             enabled        = '".$_FIELD['enabled']."',
                             languageID     = '".$_FIELD['languageID']."'
                       WHERE directoryID    = '".$_FIELD['directoryID']."'");
     return $_FIELD['directoryID'];
    }

/*   public static function wm3Util::selectDirectory($name,$directoryID)
    {
     // Make message categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->directoryID == $directoryID) $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID,"selected");
       else                                  $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function duplicateDirectory($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE directoryID = '".$w3->getVariable('directoryID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryFieldsArray(),$row);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return wm3Sql::getLastInsertID();
      }
    }*/

   public static function disableDirectory($directoryID)
    {
	 // Disable recursively current directory and all the subdirectory in it
     $rs = wm3Sql::sqlQuery("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE parentID = '$directoryID'");
	 while($row = mysql_fetch_object($rs))
	  {
	   wm3Directory::disableDirectory($row->directoryID);
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cDISABLED."' WHERE directoryID = '$row->directoryID'");
      }
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cDISABLED."' WHERE directoryID = '$directoryID'");
	}


   public static function enableDirectory($directoryID)
    {
	 // Enable recursively current directory and all the subdirectory in it
     $rs = wm3Sql::sqlQuery("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE parentID = '$directoryID'");
	 while($row = mysql_fetch_object($rs))
	  {
	   wm3Directory::enableDirectory($row->directoryID);
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cENABLED."' WHERE directoryID = '$row->directoryID'");
	   
      }
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cENABLED."' WHERE directoryID = '$directoryID'");
	}

   
   public static function deleteDirectory($directoryID)
    {
	 // Delete recursively current directory, all the items in it, all the subdirecrory in it with all the items in the varius subdirecrories
     $rs = wm3Sql::sqlQuery("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE parentID = '$directoryID'");
	 while($row = mysql_fetch_object($rs))
	  {
	   wm3Directory::deleteDirectory($row->directoryID);
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items WHERE directoryID = '$row->directoryID'");
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories       WHERE directoryID = '$row->directoryID'");
      }
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items WHERE directoryID = '$directoryID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories       WHERE directoryID = '$directoryID'");
	}

   public static function checkDirectoryItemError($w3,$admin = false)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray());
     if(!$_FIELD['title']) return 1;
     if(!wm3Directory::existsDirectory($_FIELD['directoryID'])) return 2;
     if($admin)
      {
	   if($_FIELD['source'] == WM3_cFILE_EXTERNAL)
	    {
         if(!wm3Util::isUrlRelative($_FIELD['home_url']) &&
            !wm3Util::isUrl        ($_FIELD['home_url'])) return 3;
         if($_FIELD['download_url'])
          if(!wm3Util::isUrlRelative($_FIELD['download_url']) &&
             !wm3Util::isUrl        ($_FIELD['download_url'])) return 4;
	    }
	  }
     else
      {
       if(!wm3Util::isUrl($_FIELD['home_url'])) return 3;
       if($_FIELD['download_url'])
        if(!wm3Util::isUrl($_FIELD['download_url'])) return 4;
      }
     return 0;
    }

   public static function addDirectoryItem($w3,$error = 0,$user = false)
    {;
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Directory::getDirectoryItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";

     // Hide/Show correct field and error
	 if(!$user)
	  {
	   $_EXTRA_STYLE['pageID'] = $_EXTRA_STYLE['home_url'] = $_EXTRA_STYLE['download_url'] = "style=\"display:none\"";
       if($_FIELD['source'] == WM3_cFILE_INTERNAL) $_EXTRA_STYLE['pageID'] = "";
	   else                                        $_EXTRA_STYLE['home_url'] = $_EXTRA_STYLE['download_url'] = "";
	  }

     switch($error)
      {
       case 1: // Empty title 
        {
         $_STYLE['title']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Invalid directory 
        {
         //$_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid directory".$w3->getWord(-1);
         break;
        }
       case 3: // Invalid home url 
        {
         $_STYLE['home_url']  = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid home url".$w3->getWord(-1);
         break;
        }
       case 4: // Invalid download url 
        {
         $_STYLE['download_url'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']    = WM3_cSKIN_ERROR;
         $form_title = "Invalid download url".$w3->getWord(-1);
         break;
        }
       default:
        {
         // Default values for the form
		 $_FIELD['directoryID'] = $w3->getVariable('directoryID','get'); // Take directoryID from get
         $_FIELD['enabled']   = WM3_cENABLED;
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1175);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_DIRECTORY_ITEM;
     $next_action_label = $w3->getWord(191);
     if($user) {
		        $pageID = $w3->getVariable('pageID','both');
				require(WM3_cPATH_INCLUDE."home_directory_item_form.inc");
			   }
	 else      require(WM3_cPATH_INCLUDE."admin_directory_item_form.inc");
     return $content;
    }

   public static function editDirectoryItem($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items
                               WHERE directory_itemID = '".$w3->getVariable('directory_itemID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryItemFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Directory::getDirectoryItemFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');

     // Hide/Show correct field and error
	 $_EXTRA_STYLE['pageID'] = $_EXTRA_STYLE['home_url'] = $_EXTRA_STYLE['download_url'] = "style=\"display:none\"";
     if($_FIELD['source'] == WM3_cFILE_INTERNAL) $_EXTRA_STYLE['pageID'] = "";
	 else                                        $_EXTRA_STYLE['home_url'] = $_EXTRA_STYLE['download_url'] = "";

     switch($error)
      {
       case 1: // No title 
        {
         $_STYLE['title']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid directory 
        {
         //$_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid directory".$w3->getWord(-1);
         break;
        }
       case 3: // Invalid home url 
        {
         $_STYLE['home_url']  = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid home url".$w3->getWord(-1);
         break;
        }
       case 4: // Invalid download url 
        {
         $_STYLE['download_url'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']    = WM3_cSKIN_ERROR;
         $form_title = "Invalid download url".$w3->getWord(-1);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit item ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_DIRECTORY_ITEM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_directory_item_form.inc");
     return $content;
    }

   public static function saveDirectoryItem($w3,$user=false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['ts'] = time();
	 if($user)
	  {
       if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
        {
         wm3Session::protectAction($w3->getVariable('_ID','post'));
	     $userID = $w3->getAuthenticateAdminUserID();
         $_FIELD['userID']  = $userID;
		 $_FIELD['source']  = WM3_cFILE_EXTERNAL;
		 if($userID == WM3_cUSER_ANONYMOUS && !$w3->getPreferences('anonymous_enabled_directories')) $_FIELD['enabled'] = WM3_cDISABLED;
         else $_FIELD['enabled'] = WM3_cENABLED;
         if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	        $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	      $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
	     $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
         wm3Sql::saveAllTableFields('_directories_items',$_FIELD);
	     return wm3Sql::getLastInsertID();
        } 
       return 0;
	  }
     wm3Sql::saveAllTableFields('_directories_items',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateDirectoryItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       SET   userID           = '".$_FIELD['userID']."',
					         pageID           = '".$_FIELD['pageID']."',
					         title            = '".$_FIELD['title']."',
					         description      = '".$_FIELD['description']."',
							 render_mode      = '".$_FIELD['render_mode']."',
							 icon             = '".$_FIELD['icon']."',
							 home_url         = '".$_FIELD['home_url']."',
							 download_url     = '".$_FIELD['download_url']."',
							 source           = '".$_FIELD['source']."',
                             enabled          = '".$_FIELD['enabled']."',
                             languageID       = '".$_FIELD['languageID']."'
                       WHERE directory_itemID = '".$_FIELD['directory_itemID']."'");
     return $_FIELD['directory_itemID'];
    }

/*   public static function selectDirectoryItem($name,$directoryID)
    {
     // Make message categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->directoryID == $directoryID) $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID,"selected");
       else                                  $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID);
      }
     $str .= "</select>";
     return $str;
    }*/

   public static function duplicateDirectoryItem($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items
                             WHERE directory_itemID = '".$w3->getVariable('directory_itemID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryItemFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_directories_items',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableDirectoryItem($directory_itemID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items SET enabled = '".WM3_cDISABLED."' WHERE directory_itemID = '$directory_itemID'");
	}

   public static function enableDirectoryItem($directory_itemID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items SET enabled = '".WM3_cENABLED."' WHERE directory_itemID = '$directory_itemID'");
	}
   
   public static function deleteDirectoryItem($directory_itemID)
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items WHERE directory_itemID = '$directory_itemID'");
	}

   public static function selectDirectoryType($name,$value,$w3)
    {
     // Make directory type select
	 $_LABELS = array($w3->getWord(1165),$w3->getWord(1166));
	 $_VALUES = array(WM3_cDIRECTORY_FILE,WM3_cDIRECTORY_NO_FILE);
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function selectDirectoryItemSource($w3,$name,$source,$js = "")
    {
     // Make directory item source select
     return wm3Util::selectArray($name,
                        array($w3->getWord(1181),$w3->getWord(1182)),
                        array(WM3_cFILE_INTERNAL,WM3_cFILE_EXTERNAL),
                        $source,
                        $js);
    }

   public static function makeDirectoryPath($w3,$directoryID,$link,$admin)
    {
	 // Create path from current directory to root
	 $_PSEP = $w3->getSkinObj()->getPathSeparator();
	 $path = " ".wm3Util::actionButton($link."&directoryID=$directoryID&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png",$w3->getWord(648),'','',0,16,16);
	 if(wm3Directory::isDirectoryCanHaveFile($w3,$directoryID,$admin) &&
	    wm3Directory::canAddDirectoryItem($w3))
	  $path .= " ".wm3Util::actionButton($link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png",$w3->getWord(836),'','',0,16,16);
	 while($directoryID)
	  {
	   $rs = wm3Sql::sqlQuery("SELECT directoryID,parentID,name FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE directoryID = '$directoryID'");
	   if(mysql_num_rows($rs) == 1)
	    {
	     $row = mysql_fetch_object($rs);
	     $path = " ".$_PSEP." <a href=\"$link&directoryID=$directoryID\">".$row->name."</a>".$path;
	     $directoryID = $row->parentID;
	    }
	   else $directoryID = 0;
	  }
	 $path = " <a href=\"$link\">Root</a>".$path;
	 return $path;
	}

   public static function renderDirectoryItem($w3,$admin = false)
    {
     // Get single directory item (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     $directoryID      = $w3->getVariable('directoryID','both');
     $directory_itemID = $w3->getVariable('directory_itemID','both');
     //if($media_albumID && !$categoryID) // When make a search take only media_albumID (but need also categoryID)
     // $categoryID = wm3MediaAlbum::getMediaAlbumCategoryID($w3,$media_albumID);

     //if($directoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID = '$media_albumID'"; else $query_filter = "";
	 $query_filter = "";

     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
	 $filter_check = $w3->getVariable('filter_check','both');
     if($filter) $search_link   = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $pageID = $w3->getVariable('pageID','both');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
	 $query_filter .= " WHERE ".WM3_cCONFIG_DB_PREFIX."_directories_items.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".WM3_cLANGUAGE_ALL."') AND directoryID='$directoryID'";
     $columns = 2; $buttons = 0; 
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $id_link = "&directoryID=$directoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_directories_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter";
     $rs = wm3Sql::sqlQuery($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_directories_items.title DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_directories_items.directory_itemID = '$directory_itemID'");

     // Create list header
     $_CONTENTS = array();
     $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_directory_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(1160));
     array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
     /*if($media_albumID)
      {
	   $_SEP = $w3->getSkinObj()->getSeparator();
       array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }*/
	 array_push($_CONTENTS,"<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link.$page_link,$admin));
	 array_push($_CONTENTS,"<br><i>".wm3Directory::getDirectoryDescription($directoryID)."</i>");

     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create item
     $_CONTENTS = array(); $_WIDTHS = array();
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);
     $link = $base_link.$id_link.$search_link.$extra_link;
     if($allowed) $allowed_link = $base_allowed_link."&directory_itemID=$row->directory_itemID";

     require(WM3_cPATH_INCLUDE."home_directory_item_rate_form.inc");
     $rating = $row->votes_average;
	 if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM,"action_edit.png",$w3->getWord(178)); else $button = "";
	 $published = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
     $updated   = wm3Util::renderDate($w3,$row->directory_item_ts,$w3->getHomeLanguage());
     if($row->source == WM3_cFILE_INTERNAL) { $link_home = wm3Page::makePageLink($row->pageID,'',true); $link_download = ""; }
	 else                                   { $link_home = $row->home_url; $link_download = $row->download_url; }
	 $button_home = wm3Util::actionButton($link_home,"misc_home.png","","",$w3->getWord(1688),0,16,16);
	 if($link_download) $button_download = " $_SEP ".wm3Util::actionButton($link_download,"misc_download.png","","",$w3->getWord(1689),0,16,16); else $button_download = "";

     $title = "<b>".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</b> $button<br><br>$button_home$button_download";
	 $login = wm3User::getUserLogin($row->userID); if(!$login) $login = $w3->getWord(988);
     $info  = "<nobr>(Rating $rating ".wm3Util::makeStars($w3,$rating).") $row->votes_counts votes ($row->hits hits)</nobr><br><br>Published: $published<br>Last update: $updated<br>".$w3->getWord(232)." $login";
	 $description = "<br><i>".wm3Util::renderContent($w3,$row->description,$row->render_mode)."</i><br><br>$home_content";

	 array_push($_CONTENTS,$title,$info); array_push($_WIDTHS,60,50);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);
	 
	 $_CONTENTS = array(); $_WIDTHS = array();
	 array_push($_CONTENTS,$description); array_push($_WIDTHS,100);	 
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(2));

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM,$rs_aux,"directory_itemID",$row->directory_itemID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function rateDirectoryItem($w3)
    {
	 if(!$w3->getPreferences('anonymous_vote_directories') &&
	    !$w3->getAuthenticateAdminUserID()) return;
     $directory_itemID = $w3->getVariable('directory_itemID','post');
	 if(!wm3Session::directoryItemAllowed($directory_itemID,WM3_cSESSION_RATE)) return;
	 else wm3Session::directoryItemProtect($directory_itemID,WM3_cSESSION_RATE);
     $vote = $w3->getVariable('vote','post');
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       SET    votes_counts = votes_counts + 1,
                              votes_sum = votes_sum + $vote,
							  votes_average = votes_sum/votes_counts
                       WHERE  directory_itemID = '$directory_itemID'");
    }

   public static function hitDirectoryItem($w3)
    {
     $directory_itemID = $w3->getVariable('directory_itemID','get');
	 if(!wm3Session::directoryItemAllowed($directory_itemID,WM3_cSESSION_HIT)) return;
	 else wm3Session::directoryItemProtect($directory_itemID,WM3_cSESSION_HIT);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       SET    hits = hits + 1
                       WHERE  directory_itemID = '$directory_itemID'");
    }

   public static function renderDirectoryItemTopRating($w3,$order_by,$label,$by_rate,$by_hits,$by_votes,$max_items=15,$admin=false)
    {
     // Get media album top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     $filter = ""; $filter_check = 0; $directoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $query_filter = " WHERE ".WM3_cCONFIG_DB_PREFIX."_directories_items.enabled = '".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) { if($by_rate) $columns = 6; else $columns = 5; $buttons = 1; } else { if($by_rate) $columns = 5; else $columns = 4; $buttons = 0; }

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_directories_items.*
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     if($by_rate)
	  {
	   require(WM3_cPATH_INCLUDE."admin_directory_search_form.inc");
	   $_SEP = $w3->getSkinObj()->getSeparator();
       array_push($_CONTENTS,$w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(-1)."Root</a> $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
      }
	 else
	  {
	   $search_form = "";
	   array_push($_CONTENTS,$w3->getWord($label));
	  }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();      	
       $id_link = "";
       $link = $base_link.$page_link.$id_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM;
       $n      = ($p+1).".";
       $title  = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>(".wm3Directory::makeDirectoryPath($w3,$row->directoryID,$base_link.$page_link,$admin)." )";
       if($by_rate)
	    {
	     $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)."</nobr>";
         $value  = "<nobr>($row->votes_average)</nobr>";
	    }
	   else
	    {
         if($by_hits)  $value = "<nobr>$row->hits hits</nobr>";
		 if($by_votes) $value = "<nobr>$row->votes_counts votes</nobr>";
		}
       if($by_rate) array_push($_CONTENTS,$n,$title,$rating,$value);
	   else         array_push($_CONTENTS,$n,$title,$value);
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM;
         array_push($_CONTENTS,wm3Util::actionButton($allowed_link,"action_edit.png",$w3->getWord(178)));
        }
       if($by_rate)  array_push($_WIDTHS,0,85,10,5);
	   else          array_push($_WIDTHS,0,90,10);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function renderDirectoryItemLastInserted($w3,$order_by,$label,$max_items=15,$admin=false)
    {
     // Get media album top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     $filter = ""; $filter_check = 0; $directoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $query_filter = " WHERE ".WM3_cCONFIG_DB_PREFIX."_directories_items.enabled = '".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) { $columns = 6; $buttons = 1; } else { $columns = 5; $buttons = 0; }

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_directories_items.*
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_directory_search_form.inc");
     array_push($_CONTENTS,$w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(-1)."Root</a> $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();      	
       $id_link = "";
       $link = $base_link.$page_link.$id_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM;
       $n      = ($p+1).".";
	   $login = wm3User::getUserLogin($row->userID); if(!$login) $login = $w3->getWord(988);
       $title  = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>Published: $login<br>(".wm3Directory::makeDirectoryPath($w3,$row->directoryID,$base_link.$page_link,$admin)." )";
       $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)." ($row->votes_average $_SEP $row->votes_counts votes)</nobr>";
	   $value  = "<nobr>$row->hits hits</nobr>";
	   array_push($_CONTENTS,$n,$title,$rating,$value);
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM;
         array_push($_CONTENTS,wm3Util::actionButton($allowed_link,"action_edit.png",$w3->getWord(178)));
        }
       array_push($_WIDTHS,0,85,10,5);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function renderDirectorySubfoldersPreview($w3,$directoryID,$link,$n = 3)
    {
     // Render $n subfolders under $directoryID
	 $str = ""; $i = 0;
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE parentID='$directoryID'
			                 ORDER BY name");
     while($row = mysql_fetch_object($rs))
      {
	   $name = "<a href=\"$link&directoryID=$row->directoryID</a>\">$row->name</a>";
	   if($i == 0) { $str .= $name; }
	   else        { if($i == $n) { $str .= ", ..."; break; } else { $str .= ", $name"; } }
	   $i++;
	  }
	 return $str;
	}

   private function getDirectoryDescription($directoryID)
    {
     // Get description from a categoryID
     $rs = wm3Sql::sqlQuery("SELECT description FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE directoryID = '$directoryID'");
     if(mysql_num_rows($rs) == 0) return "";
     $row = mysql_fetch_object($rs);
     return $row->description;
    }

   private static function countDirectoryFolders($w3,$directoryID,$filter = "")
    {
     // Get the number of folders in a directory
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_directories","WHERE parentID = '$directoryID'$filter");
     return $total;
    }

   private static function countDirectoryFiles($w3,$directoryID,$filter = "")
    {
     // Get the number of files in a directory
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_directories_items","WHERE directoryID = '$directoryID'$filter");
     return $total;
    }

   private static function isDirectoryCanHaveFile($w3,$directoryID,$admin = true)
    {
     // Return true if the directory with directoryID can have files else return false
	 if($directoryID == 0) // 0 its root directory (only administrator can put file in the root)
	  {
	   if($admin) return true; else return false;
	  }
     $rs = wm3Sql::sqlQuery("SELECT directory_type FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE  directoryID = '$directoryID'");
     if(mysql_num_rows($rs) != 1) return false;
     $row = mysql_fetch_object($rs);
     if($row->directory_type == WM3_cDIRECTORY_FILE) return true;
	 else                                            return false;
	}

   private static function canAddDirectoryItem($w3)
    {
	 // Return true if user/anonymous can add an item into the directory
     if($w3->getAuthenticateAdminUserID() ||
		$w3->getAuthenticateAdminUserID() == WM3_cUSER_ANONYMOUS && $w3->getPreferences('anonymous_add_directories'))
	  return true;
	 else
	  return false;
	}

   private static function existsDirectory($directoryID)
    {
     // Return true if the directory with directoryID exists else return false
	 if($directoryID == 0) return true; // 0 its root directory and exists
     $rs = wm3Sql::sqlQuery("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE  directoryID = '$directoryID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
	}

  }

?>
