<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3MediaAlbum extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for media album section
     return array(
                  'allowed_section'            => WM3_cSECTION_MEDIA_ALBUMS,
                  'allow_category_description' => true,
                  'category_form'              => 'admin_media_album_category_form.inc',
                  'search_form'                => 'admin_media_album_search_form.inc',
                  'table_categories'           => '_media_albums_categories',
                  'table_subcategories'        => '_media_albums',
                  'table_subcategories_count'  => '_media_albums',
                  'table_items_count'          => '_media_albums_items',
                  'field_items_count'          => 'media_albumID',
                  'action_save_category'       => WM3_cACTION_SAVE_MEDIA_ALBUM_CATEGORY,
                  'action_update_category'     => WM3_cACTION_UPDATE_MEDIA_ALBUM_CATEGORY,
                  'action_show_subcategory'    => WM3_cACTION_SHOW_MEDIA_ALBUM,
                  'action_add_subcategory'     => WM3_cACTION_ADD_MEDIA_ALBUM,
                  'action_disable_category'    => WM3_cACTION_DISABLE_MEDIA_ALBUM_CATEGORY,
                  'action_enable_category'     => WM3_cACTION_ENABLE_MEDIA_ALBUM_CATEGORY,
                  'action_edit_category'       => WM3_cACTION_EDIT_MEDIA_ALBUM_CATEGORY,
                  'action_delete_category'     => WM3_cACTION_DELETE_MEDIA_ALBUM_CATEGORY,
                  'action_search'              => WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM,
                  'label_category_list_title'  => 364,
                  'label_subcategory_add'      => 1337,
                  'label_subcategories_count'  => 1348,
                  'label_items_count'          => 1683,
				  'extra_button_action'        => WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,
				  'extra_button_icon'          => 'action_up.png',
				  'extra_button_label'         => 1216);
    }

   public static function getMediaAlbumFieldsArray()
    {
     return array('media_albumID','title','categoryID','description','media_album_type','userID','enabled','languageID',
                  'group_read','users_read','visitors_read',
				  'ts','icon');
    }

   public static function getMediaAlbumItemFieldsArray()
    {
     return array('media_album_itemID','media_albumID','title','alt',
                  'source_media','media_from_local','media','media_from_remote','hits','media_from_external',
                  'source_thumbnail','thumbnail_from_local','thumbnail','thumbnail_from_remote','ts','thumbnail_from_external',
                  'enabled','languageID',
                  'votes_counts','votes_sum','votes_average');
    }

   public static function getMediaAlbumPermissionsArray($w3,$media_albumID = 0)
    {
     // Return media album permissions array
     $_PERMISSIONS = array(
                           'media_read' => false
                          );
     if($media_albumID == 0) $media_albumID = $w3->getVariable('media_albumID','both');
     $rs = wm3Sql::sqlQuery("SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
	                                ".WM3_cCONFIG_DB_PREFIX."_media_albums.*
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums,
							        ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."'
							   AND  ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID = '$media_albumID'");
     if(mysql_num_rows($rs) != 1) return $_PERMISSIONS;
     $row = mysql_fetch_object($rs); 

	 // Set visitors permissions (no user logged)
     $_PERMISSIONS['media_read'] = $row->visitors_read;

     // Set user or administrator permissions (user or administrator logged)
     if($w3->getAuthenticateAdminUserID())
      {
       $_PERMISSIONS['media_read'] = $row->users_read;

	   // If logged user/administrator group its the same of the owner group
       if(wm3User::getGroupID($w3->getAuthenticateAdminUserID()) == wm3User::getGroupID($row->userID))
	    {
         $_PERMISSIONS['media_read'] = $row->group_read;
	    }
	   // If logged user/administrator its owner
       if($w3->getAuthenticateAdminUserID() == $row->userID)
	    {
         $_PERMISSIONS['media_read'] = true;
	    }
	   // If administrator can manage media albums (and manage users ??? TODO poichè se gestisce gli utenti puo' mettersi il permesso di gestire il media album)
       if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS))
	    {
         $_PERMISSIONS['media_read'] = true;
		}
      }
     return $_PERMISSIONS;
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // MediaAlbum page content
     $_PERMISSIONS = wm3MediaAlbum::getMediaAlbumPermissionsArray($w3); // Get forum permissions
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::getMediaAlbumList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM:
        {
         if(!$w3->getVariable('media_albumID','both') || ($w3->getVariable('media_albumID','both') && $_PERMISSIONS['media_read']) )
		  return wm3MediaAlbum::getMediaAlbumItemList($w3,0,false,true);
		 else
		  return wm3MediaAlbum::renderMediaAlbumDenied($w3);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_MEDIA:
        {
		 if($_PERMISSIONS['media_read'])
		  {
		   wm3MediaAlbum::hitMediaAlbumItem($w3);
           return wm3MediaAlbum::renderSingleMediaAlbumItem($w3);
		  }
         else return wm3MediaAlbum::renderMediaAlbumDenied($w3);
         break;
        }
       case WM3_cACTION_RATE_MEDIA_ALBUM_ITEM:
        {
         if($_PERMISSIONS['media_read'])
          {
           wm3MediaAlbum::rateMediaAlbumItem($w3);
           return wm3MediaAlbum::renderSingleMediaAlbumItem($w3);
		  }
		 else return wm3MediaAlbum::renderMediaAlbumDenied($w3);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING:
        {
         return wm3MediaAlbum::renderMediaAlbumItemTopRating($w3,"ORDER BY votes_average DESC",1219,true, false,false)."<br><br>".
		        wm3MediaAlbum::renderMediaAlbumItemTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true, false)."<br><br>".
				wm3MediaAlbum::renderMediaAlbumItemTopRating($w3,"ORDER BY votes_counts DESC" ,1221,false,false,true);
         break;
        }
       default:
        {
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_MEDIA_ALBUM_CATEGORY:
        {
         return wm3MediaAlbum::addMediaAlbumCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_MEDIA_ALBUM_CATEGORY:
        {
         $error = wm3MediaAlbum::checkMediaAlbumCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3MediaAlbum::saveMediaAlbumCategory($w3);
           // $msg= message saved... //TODO
           return wm3MediaAlbum::getMediaAlbumCategoryList($w3,$lastID);
          }
         else return wm3MediaAlbum::addMediaAlbumCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_MEDIA_ALBUM_CATEGORY:
        {
         return wm3MediaAlbum::editMediaAlbumCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MEDIA_ALBUM_CATEGORY:
        {
         $error = wm3MediaAlbum::checkMediaAlbumCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3MediaAlbum::updateMediaAlbumCategory($w3);
           // $msg= message udated... //TODO
           return wm3MediaAlbum::getMediaAlbumCategoryList($w3,$lastID);
          }
         else return wm3MediaAlbum::editMediaAlbumCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_MEDIA_ALBUM_CATEGORY:
        {
         wm3MediaAlbum::disableMediaAlbumCategory($w3->getVariable('categoryID','get'));
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MEDIA_ALBUM_CATEGORY:
        {
         wm3MediaAlbum::enableMediaAlbumCategory($w3->getVariable('categoryID','get'));
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MEDIA_ALBUM_CATEGORY:
        {
         wm3MediaAlbum::deleteMediaAlbumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::addMediaAlbum($w3);
         break;
        }
       case WM3_cACTION_SAVE_MEDIA_ALBUM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
         $error = wm3MediaAlbum::checkMediaAlbumError($w3);
         if(!$error) {
                      $lastID = wm3MediaAlbum::saveMediaAlbum($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3MediaAlbum::getMediaAlbumList($w3,$lastID);
                     }
         else       {
			         wm3Sql::sqlQuery("UNLOCK TABLES");
			         return wm3MediaAlbum::addMediaAlbum($w3,$error);
				    }
         break;
        }
       case WM3_cACTION_EDIT_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::editMediaAlbum($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MEDIA_ALBUM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
         $error = wm3MediaAlbum::checkMediaAlbumError($w3);
         if(!$error) {
                      $lastID = wm3MediaAlbum::updateMediaAlbum($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3MediaAlbum::getMediaAlbumList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3MediaAlbum::editMediaAlbum($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_MEDIA_ALBUM:
        {
         wm3MediaAlbum::disableMediaAlbum($w3->getVariable('media_albumID','get'));
         return wm3MediaAlbum::getMediaAlbumList($w3,$w3->getVariable('media_albumID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MEDIA_ALBUM:
        {
         wm3MediaAlbum::enableMediaAlbum($w3->getVariable('media_albumID','get'));
         return wm3MediaAlbum::getMediaAlbumList($w3,$w3->getVariable('media_albumID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MEDIA_ALBUM:
        {
         wm3MediaAlbum::deleteMediaAlbum($w3,$w3->getVariable('media_albumID','get'));
         return wm3MediaAlbum::getMediaAlbumList($w3);
         break;
        }       
       case WM3_cACTION_ADD_MEDIA_ALBUM_ITEM:
        {
         return wm3MediaAlbum::addMediaAlbumItem($w3);
         break;
        }
       case WM3_cACTION_SAVE_MEDIA_ALBUM_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items      WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
         $media_album_type = wm3MediaAlbum::getMediaAlbumType($w3,$w3->getVariable('media_albumID','post'));
         $error = wm3MediaAlbum::checkMediaAlbumItemError($w3,$media_album_type);
         if(!$error) {
                      $lastID = wm3MediaAlbum::saveMediaAlbumItem($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3MediaAlbum::getMediaAlbumItemList($w3,$lastID);
                     }
         else       {
			         wm3Sql::sqlQuery("UNLOCK TABLES");
			         return wm3MediaAlbum::addMediaAlbumItem($w3,$error);
				    }
         break;
        }
       case WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM:
        {
         return wm3MediaAlbum::editMediaAlbumItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MEDIA_ALBUM_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items      WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
         $media_album_type = wm3MediaAlbum::getMediaAlbumType($w3,$w3->getVariable('media_albumID','post'));
         $error = wm3MediaAlbum::checkMediaAlbumItemError($w3,$media_album_type);
         if(!$error) {
                      $lastID = wm3MediaAlbum::updateMediaAlbumItem($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3MediaAlbum::getMediaAlbumItemList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3MediaAlbum::editMediaAlbumItem($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_DISABLE_MEDIA_ALBUM_ITEM:
        {
         wm3MediaAlbum::disableMediaAlbumItem($w3->getVariable('media_album_itemID','get'));
         return wm3MediaAlbum::getMediaAlbumItemList($w3,$w3->getVariable('media_album_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MEDIA_ALBUM_ITEM:
        {
         wm3MediaAlbum::enableMediaAlbumItem($w3->getVariable('media_album_itemID','get'));
         return wm3MediaAlbum::getMediaAlbumItemList($w3,$w3->getVariable('media_album_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MEDIA_ALBUM_ITEM:
        {
         wm3MediaAlbum::deleteMediaAlbumItem($w3->getVariable('media_album_itemID','get'));
         return wm3MediaAlbum::getMediaAlbumItemList($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_MEDIA_ALBUM_ITEM:
        {
         $lastID = wm3MediaAlbum::duplicateMediaAlbumItem($w3);
         return wm3MediaAlbum::getMediaAlbumItemList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM:
        {
         return wm3MediaAlbum::getMediaAlbumItemList($w3);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::getMediaAlbumList($w3);
         break;
        }
       case WM3_cACTION_MOVE_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::getMediaAlbumItemList($w3,0,true,false,true);
         break;
        }
       case WM3_cACTION_MOVE_MEDIA_ALBUM_ITEM:
        {
		 wm3MediaAlbum::moveMediaAlbumItem($w3);
         return wm3MediaAlbum::getMediaAlbumItemList($w3,0,true,false,true);
         break;
        }
       default:
        {
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3);
        }
      }     
    }

   public static function renderMediaAlbumDenied($w3)
    {
     // Give a denied access message (home side)

     // Prepare variables to create the content
     $media_albumID = $w3->getVariable('media_albumID','both');
	 $categoryID = $w3->getVariable('categoryID','both');
     $pg = $w3->getVariable('pg','both');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND media_albumID = '$media_albumID'";
     $columns = 1; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','both');
     $id_link   = "&media_albumID=$media_albumID";

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     if($media_albumID && $categoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                            ," $_PSEP ".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID));
      }
     array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // List items
     $_CONTENTS = array(); $_WIDTHS = array();
     $link = $base_link.$id_link.$page_link.$search_link.$extra_link;//."&postID=$row->postID";
     $message = "<div align=\"center\"><br><img src=\"".WM3_cPATH_DATA."misc_stop.png\" border=\"0\" width=\"40\" height=\"37\"><br><br><b>Access denied!</b><br><br>You can not see media in this media album.</div><br>";
     array_push($_CONTENTS,$message); array_push($_WIDTHS,100);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function getMediaAlbumCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function checkMediaAlbumCategoryError($w3)
    {
     return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addMediaAlbumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editMediaAlbumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveMediaAlbumCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateMediaAlbumCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableMediaAlbumCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableMediaAlbumCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteMediaAlbumCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($categoryID,'media_albumID');
    }

   public static function selectMediaAlbumCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getMediaAlbumCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function selectMediaAlbum($w3,$name,$media_albumID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$name,$media_albumID,$all,$admin,"title","media_albumID");
    }

   public static function getMediaAlbumList($w3,$currentID = 0,$admin = true)
    {
     // Get media album list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg)     $extra_link  = "&pg=$pg"; else $extra_link = "";
     if($admin) {
                 $width_title       = 40;
                 $width_permissions = 30;
                 $search_form_link  = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 7; $buttons = 4;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link         = "&pageID=$pageID";
                 $search_form_link  = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
                 $base_link         = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title       = 50;
                 $width_permissions = 50;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_media_albums.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,".WM3_cCONFIG_DB_PREFIX."_media_albums
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_media_albums.title DESC LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_media_album_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(364)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     if($categoryID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MEDIA_ALBUM,"action_add.png","","",$w3->getWord(365),0,16,16));
       else       array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_title,$width_permissions,40,0),array(194,-1,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();      	
       $link = $base_link.$id_link.$search_link.$extra_link."&media_albumID=$row->media_albumID";
       if($allowed) $allowed_link = $base_allowed_link."&media_albumID=$row->media_albumID";
       $moderator   = wm3User::getUserLogin($row->userID);
       $group       = wm3User::getGroupName(wm3User::getGroupID($row->userID));
       $icon        = wm3MediaAlbum::getMediaAlbumMimeIcons($row->media_album_type);
       $permissions = wm3MediaAlbum::getMediaAlbumPermissionsLegend($row);
       if($categoryID) {
                        if($admin) array_push($_CONTENTS,"<a href=\"$link&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a><br>".wm3MediaAlbum::makeCounterMediaAlbumItems($w3,$row->media_albumID)."<p><i>$row->description</i></p>");
                        else       array_push($_CONTENTS,"<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a> ".wm3MediaAlbum::makeCounterMediaAlbumItems($w3,$row->media_albumID,"AND enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'")."<p><i>$row->description</i></p>");
                       }
       else            {
       	                // For the search in all categories (TODO for the forums)
                        if($admin) array_push($_CONTENTS,"<a href=\"$link&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a><br>(".$w3->getWord(659)." <a href=\"".$link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$row->categoryID)."</a>)");
                        else       array_push($_CONTENTS,"<a href=\"$link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a><br>(".$w3->getWord(659)." <a href=\"".$link.$page_link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$row->categoryID)."</a>)");
                       }
       array_push($_CONTENTS,$icon."<br>".$permissions);
       array_push($_WIDTHS,$width_title,$width_permissions);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,"$lang_flag (".$w3->getWord(999)." $moderator, group $group)");
         array_push($_WIDTHS,30,30);
         // Buttons
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_MEDIA_ALBUM_ITEM,"action_add_from.png",$w3->getWord(1342)));
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_MEDIA_ALBUM,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_MEDIA_ALBUM,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_MEDIA_ALBUM,"action_delete.png",$w3->getWord(179),$w3->getWord(699)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->media_albumID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkMediaAlbumError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray());
     if(!$_FIELD['title']) return 1;
	 if(!$w3->getSectionObj()->existsCategory($_FIELD['categoryID'])) return 2;
     if(!$_FIELD['description']) return 3;
     return 0;
    }

   public static function addMediaAlbum($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3MediaAlbum::getMediaAlbumFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(166);
         break;
        }
       case 2: // Invalid category
        {
         $_STYLE['categoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = "Invalid category...".$w3->getWord(-1);
         break;
        }
       case 3: // No description
        {
         $_STYLE['description'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(82);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']     = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']        = WM3_cENABLED;
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1337);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_MEDIA_ALBUM;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_media_album_form.inc");
     return $content;
    }

   public static function editMediaAlbum($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums
                               WHERE media_albumID = '".$w3->getVariable('media_albumID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3MediaAlbum::getMediaAlbumFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid category
        {
         $_STYLE['categoryID']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid category...".$w3->getWord(-1);
         break;
        }
       case 3: // No description
        {
         $_STYLE['description']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(860);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1674);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_MEDIA_ALBUM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_media_album_form.inc");
     return $content;
    }

   public static function saveMediaAlbum($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_media_albums',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateMediaAlbum($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                       SET   title            = '".$_FIELD['title']."',
                             categoryID       = '".$_FIELD['categoryID']."',
                             description      = '".$_FIELD['description']."',
                             media_album_type = '".$_FIELD['media_album_type']."',
                             userID           = '".$_FIELD['userID']."',
                             users_read       = '".$_FIELD['users_read']."',
                             visitors_read    = '".$_FIELD['visitors_read']."',
                             group_read       = '".$_FIELD['group_read']."',
                             enabled          = '".$_FIELD['enabled']."',
                             languageID       = '".$_FIELD['languageID']."'
                       WHERE media_albumID    = '".$_FIELD['media_albumID']."'");
     return $_FIELD['media_albumID'];
    }

   public static function duplicateMediaAlbumItem($w3)
    {
     // Take fields from database and duplicate data creating a new row
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items      WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                             WHERE media_album_itemID = '".$w3->getVariable('media_album_itemID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
	   $_FIELD['hits'] = $_FIELD['votes_counts'] = $_FIELD['votes_sum'] = $_FIELD['votes_average'] = 0;
       $_FIELD['ts']      = time();
       wm3Sql::saveAllTableFields('_media_albums_items',$_FIELD);
       wm3Sql::sqlQuery("UNLOCK TABLES");
       return wm3Sql::getLastInsertID();
      }
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function disableMediaAlbum($media_albumID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums SET enabled = '".WM3_cDISABLED."' WHERE media_albumID = '$media_albumID'"); }

   public static function enableMediaAlbum($media_albumID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums SET enabled = '".WM3_cENABLED."' WHERE media_albumID = '$media_albumID'"); }
   
   public static function deleteMediaAlbum($w3,$media_albumID) 
    {
	 $w3->getSectionObj()->deleteSubcategory($media_albumID,'media_albumID');
	 //wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums WHERE media_albumID = '$media_albumID'");
	}

   public static function getMediaAlbumItemName($w3,$media_album_itemID)
    {
     // Get media album item name
     $rs = wm3Sql::sqlQuery("SELECT title FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                             WHERE media_album_itemID = '$media_album_itemID'");
     if(mysql_num_rows($rs) != 1) return "";                             
     $row = mysql_fetch_object($rs);
     return $row->title;
    }

   public static function getMediaAlbumType($w3,$media_albumID)
    {
     // Get media album type
     $rs = wm3Sql::sqlQuery("SELECT media_album_type FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums
                             WHERE media_albumID = '$media_albumID'");
     if(mysql_num_rows($rs) != 1) return 0;                             
     $row = mysql_fetch_object($rs);
     return $row->media_album_type;
    }

   public static function getMediaAlbumName($w3,$media_albumID)
    {
     return $w3->getSectionObj()->getSubcategoryName($media_albumID,"title","media_albumID");
    }

   public static function getMediaAlbumCategoryID($w3,$media_albumID)
    {
     return $w3->getSectionObj()->getCategoryID($media_albumID,"media_albumID");
    }

   public static function getMediaAlbumItemList($w3,$currentID = 0,$admin = true,$media_search = false,$move = false)
    {
     // Get media album item list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $use_colors = false;
     if($admin) $items_per_row = 1; else $items_per_row = 4;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $media_albumID = $w3->getVariable('media_albumID','both');
     if($media_albumID && !$categoryID) // When make a search take only media_albumID (but need also categoryID)
      $categoryID = wm3MediaAlbum::getMediaAlbumCategoryID($w3,$media_albumID);
     if($media_albumID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID = '$media_albumID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND (".WM3_cCONFIG_DB_PREFIX."_media_albums_items.title LIKE '%$filter%'".
				                   " OR ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.alt LIKE '%$filter%')";
     	         }
     else        { if(!$media_albumID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title      = 60;
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 7; $buttons = 4;
				 if($move) $columns = 8;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title      = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.languageID='".$w3->getHomeLanguage()."'";
				 $columns = 4; $buttons = 0; // Will be displayed 4 media in a row 
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $id_link = "&categoryID=$categoryID&media_albumID=$media_albumID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.title DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID=".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'media_album_itemID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_media_album_search_form.inc");

     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(364)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     if($media_albumID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                                       ," $_PSEP ".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID)." ($total_items)");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                                       ," $_PSEP ".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID)." ($total_items)");
       if($admin) {
		           array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MEDIA_ALBUM_ITEM,"action_add.png","","",$w3->getWord(1342),0,16,16));
	               if($move) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM,"action_show.png","","",$w3->getWord(366),0,16,16));
				   else      array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_MOVE_MEDIA_ALBUM,"action_move.png","","",$w3->getWord(1421),0,16,16));
				  }
      }
     if(!$admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);
     if($move) {
                $move_form  = "<form name=\"wm3_form\" method=\"post\" action=\"$base_link$id_link$extra_link&action=".WM3_cACTION_MOVE_MEDIA_ALBUM_ITEM."\">";
                $move_form .= $w3->getWord(1424)." ".wm3MediaAlbum::selectMediaAlbum($w3,'to_media_albumID',$media_albumID,false,$admin)." ";
				$move_form .= "<input type=\"submit\" name=\"send\" value=\"".$w3->getWord(1422)."\">";
				$str .= wm3Section::makeHeaderList($w3,array($move_form),$columns,'',false);
                $move_form  = "<input type=\"hidden\" name=\"total_items\" value=\"$total_items\">";
				$move_form .= "<input type=\"button\" name=\"check_all\" value=\"".$w3->getWord(1308)."\" onClick=\"wm3_checkAll(this.form,'chk_item',1,$total_items);\"> <input type=\"button\" name=\"uncheck_all\" value=\"".$w3->getWord(1309)."\" onClick=\"wm3_checkAll(this.form,'chk_item',0,$total_items);\"> <input type=\"button\" name=\"invert_selection\" value=\"".$w3->getWord(1310)."\" onClick=\"wm3_invertSelection(this.form,'chk_item',$total_items);\">";
				$str .= wm3Section::makeHeaderList($w3,array($move_form),$columns,'',false);//TODO manca </form> alla fine
			   }

     // Create list caption
     if($admin) {
		         if($move) $str .= wm3Section::makeCaptionList($w3,array(0,0,$width_title,40,0),array(-1,194,1671,1407),$buttons);
	             else      $str .= wm3Section::makeCaptionList($w3,array(0,$width_title,40,0),array(194,1671,1407),$buttons);
			    }

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     $_CONTENTS = array(); $_WIDTHS = array();
     while($row = mysql_fetch_object($rs))
      {
       $link = $base_link.$id_link.$extra_link."&media_album_itemID=$row->media_album_itemID";
       if($allowed) $allowed_link = $base_allowed_link."&media_album_itemID=$row->media_album_itemID";
	   $_MIME_INFO = wm3Folder::getMimeInfoArray($w3,$row->media);
       $mime_icon = $_MIME_INFO['mime_icon'];
       if($media_albumID) {
                           if($admin) {
							           if($move) array_push($_CONTENTS,wm3Util::inputCheckbox('chk_item'.($p+1),$row->media_album_itemID));
							           array_push($_CONTENTS,"<a href=\"".WM3_cPATH_MEDIA_ALBUM."$row->media\" target=\"_blank\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>");
                        	           array_push($_CONTENTS,$mime_icon." ".$row->title."<br><i>".$row->alt."</i>");
									  }
                           else       {
							           if($filter)
									    {
									     $items_per_row = 1;
   									     $use_colors = true;
							             $picture = "<a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\"></a>";
									     array_push($_CONTENTS,$picture);
							             array_push($_CONTENTS,"$mime_icon <a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->title</a><br><i>".$row->alt."</i>");
									    }
									   else
									    {
							             if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)); else $button = "";
                           	             $picture_content = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"120\" height=\"90\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\"></a>";
                                         $title_content   = "$mime_icon <a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->title</a> $button";
                                         ob_start();
                                         require($w3->getSkinObj()->getFramePicture());
                                         $item_content = ob_get_contents();
                                         ob_end_clean();
                           	             array_push($_CONTENTS,$item_content);
									    }
                           	          }
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           array_push($_CONTENTS,"<a href=\"".WM3_cPATH_MEDIA_ALBUM."$row->media\" target=\"_blank\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>");
							           array_push($_CONTENTS,"$mime_icon $row->title<br><i>".$row->alt."</i><br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->media_albumID,'media_albumID')."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->media_albumID,'media_albumID'))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link&media_albumID=$row->media_albumID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">".wm3MediaAlbum::getMediaAlbumName($w3,$row->media_albumID)."</a>)");
									  }
                           else       {
							           if($media_search) $_PERMISSIONS = wm3MediaAlbum::getMediaAlbumPermissionsArray($w3,$row->media_albumID);
							           $items_per_row = 1;
									   $use_colors = true;
							           if($_PERMISSIONS['media_read'])
									    {
									     $picture = "<a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\"></a>";
										 $content = "$mime_icon <a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->title</a><br><i>".$row->alt."</i><br>(".$w3->getWord(659)."
                           	                         <a href=\"".$base_link.$page_link."&categoryID=".$w3->getSectionObj()->getCategoryID($row->media_albumID,'media_albumID')."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->media_albumID,'media_albumID'))."</a>
                           	                         $_PSEP <a href=\"".$base_link.$search_link.$page_link."&media_albumID=$row->media_albumID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">".wm3MediaAlbum::getMediaAlbumName($w3,$row->media_albumID)."</a>)";
										}
									   else
									    {
										 $picture = wm3Util::renderImg("misc_error_mini.png");
										 $content = "You can not see this media";
									    }
									   array_push($_CONTENTS,$picture);
							           array_push($_CONTENTS,$content);
									  }
                          }
       if($admin) {
		           if($move) array_push($_WIDTHS,0,0,$width_title);
				   else      array_push($_WIDTHS,0,$width_title);
			      }
       else
	    {
		 if($filter) array_push($_WIDTHS,0,100,0);
		 else        array_push($_WIDTHS,25);
		}
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag." $row->hits hits<br>".wm3Util::makeStars($w3,$row->votes_average)." $row->votes_average ($row->votes_counts voti)"); array_push($_WIDTHS,40);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_MEDIA_ALBUM_ITEM,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_MEDIA_ALBUM_ITEM,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_MEDIA_ALBUM_ITEM,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_MEDIA_ALBUM_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));         
        }
       else
        {
         if($filter) if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)));
        }
       $aux = ($p+1)%$items_per_row;
       if($aux == 0 || ($p+1+$pg*12) == $total_items)
        {
         if($admin) { $c = $p; $test = $row->media_album_itemID==$currentID; } else { if($use_colors) $c = $p; else $c = 0; $test = false; }
         if($aux != 0) // Incomplete row 
          for($i = $aux; $i < $items_per_row; $i++) 
           array_push($_CONTENTS,"");
         $str .= wm3Section::makeItemList($w3,$c,$_WIDTHS,$_CONTENTS,$test);
         $_CONTENTS = array(); $_WIDTHS = array();
        }
       $p++;
      }
	 if($move) $str .= "</form>"; // Close move form

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) {
		           if($move) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_MOVE_MEDIA_ALBUM.$id_link.$search_link);
	               else      $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM.$id_link.$search_link);
			      }
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkMediaAlbumItemError($w3,$media_album_type)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());

     $aux = time()."_".rand(1,99999); // Avoid overwritting the files
     if(!$_FIELD['title']) return 13;
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['media_from_local']['name']) $media_name = $aux.".".wm3Util::cutExtension($_FILES['media_from_local']['name']);
       else                                    $media_name = "";
       $error = wm3Folder::uploadFile("media_from_local",WM3_cPATH_MEDIA_ALBUM,$media_name,true,wm3MediaAlbum::getMimeTypeArray($media_album_type),0);//TODO prendere mimeType array corretto (in base a media_album_type)
       if($error) return $error;
      }
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL) if(!$_FIELD['media_from_external']) return 14; // External link

     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['thumbnail_from_local']['name']) $thumbnail_name = $aux."_t.".wm3Util::cutExtension($_FILES['thumbnail_from_local']['name']);
       else                                        $thumbnail_name = "";
       $error = wm3Folder::uploadFile("thumbnail_from_local",WM3_cPATH_MEDIA_ALBUM,$thumbnail_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error + 6;
      }
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL) if(!$_FIELD['thumbnail_from_external']) return 15; // External link
	 if(!$w3->getSectionObj()->existsSubcategory($_FIELD['media_albumID'],'media_albumID')) return 16;
     return 0; // Take file from remote folder (or no errors)
    }

   public static function addMediaAlbumItem($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 

     // Hide/Show correct field and error
     $_EXTRA_STYLE['media_from_local'] = $_EXTRA_STYLE['media_from_remote'] = $_EXTRA_STYLE['media_from_external'] = "style=\"display:none\"";
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_EXTRA_STYLE['media_from_local']    = "";
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['media_from_remote']   = "";
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_EXTRA_STYLE['media_from_external'] = "";
	 $_EXTRA_STYLE['thumbnail_from_local'] = $_EXTRA_STYLE['thumbnail_from_remote'] = $_EXTRA_STYLE['thumbnail_from_external'] = "style=\"display:none\"";
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_EXTRA_STYLE['thumbnail_from_local']    = "";
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['thumbnail_from_remote']   = "";
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_EXTRA_STYLE['thumbnail_from_external'] = "";

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']))     @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']);
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name'])) @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name']);
      }
     switch($error)
      {
       // Media error
       case 1: // Upload error
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']        = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 2: // File not allowed
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']        = WM3_cSKIN_ERROR;
         $form_title = "Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 3: // File already exist error
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']        = WM3_cSKIN_ERROR;
         $form_title = "File already exist (check overwrite box) $error";//$w3->getWord(29);
         break;
        }
       case 5: // File too big
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']        = WM3_cSKIN_ERROR;
         $form_title = "Too big $error";//$w3->getWord(29);
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']        = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       // Thumbnail error
       case 7: // Upload error
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']            = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 8: // File not allowed
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']            = WM3_cSKIN_ERROR;
         $form_title = "Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 9: // File already exist error
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']            = WM3_cSKIN_ERROR;
         $form_title = "File already exist (check overwrite box) $error";//$w3->getWord(29);
         break;
        }
       case 11: // File too big
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']            = WM3_cSKIN_ERROR;
         $form_title = "Too big $error";//$w3->getWord(29);
         break;
        }
       case 12: // Empty file given (no upload performed)
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']            = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       // Other errors
       case 13: // Empty title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error empty name$error";//$w3->getWord(29);
         break;
        }
       case 14: // Empty external link (media)
        {
         $_STYLE['media_from_external'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']           = WM3_cSKIN_ERROR;
         $form_title = "Error empty url $error";//$w3->getWord(29);
         break;
        }
       case 15: // Empty external link (thumbnail)
        {
         $_STYLE['thumbnail_from_external'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']              = WM3_cSKIN_ERROR;
         $form_title = "Error empty url $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']    = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['media_albumID'] = $w3->getVariable('media_albumID','get'); // Take media_albumID from get
         $_FIELD['enabled']       = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(351);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_MEDIA_ALBUM_ITEM;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_media_album_item_form.inc");
     return $content;
    }

   public static function editMediaAlbumItem($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                               WHERE media_album_itemID = '".$w3->getVariable('media_album_itemID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');

     // Hide/Show correct field and error
     $_EXTRA_STYLE['media_from_local'] = $_EXTRA_STYLE['media_from_remote'] = $_EXTRA_STYLE['media_from_external'] = "style=\"display:none\"";
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_EXTRA_STYLE['media_from_local']       = "";
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['media_from_remote']   = "";
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_EXTRA_STYLE['media_from_external'] = "";
	 $_EXTRA_STYLE['thumbnail_from_local'] = $_EXTRA_STYLE['thumbnail_from_remote'] = $_EXTRA_STYLE['thumbnail_from_external'] = "style=\"display:none\"";
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_EXTRA_STYLE['thumbnail_from_local']    = "";
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['thumbnail_from_remote']   = "";
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_EXTRA_STYLE['thumbnail_from_external'] = "";

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']))     @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']);
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name'])) @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name']);
      }
     switch($error)
      {
       // Media error
       case 1: // Upload error
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 2: // File not allowed
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = "Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 3: // File already exist error
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = "File already exist (check overwrite box) $error";//$w3->getWord(29);
         break;
        }
       case 5: // File too big
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = "Too big $error";//$w3->getWord(29);
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_STYLE['media_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       // Thumbnail error
       case 7: // Upload error
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']   = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 8: // File not allowed
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 9: // File already exist error
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "File already exist (check overwrite box) $error";//$w3->getWord(29);
         break;
        }
       case 11: // File too big
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "Too big $error";//$w3->getWord(29);
         break;
        }
       case 12: // Empty file given (no upload performed)
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       // Other errors
       case 13: // Empty title
        {
         $_STYLE['title']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error empty name$error";//$w3->getWord(29);
         break;
        }
       case 14: // Empty external link (media)
        {
         $_STYLE['media_from_external'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']      = WM3_cSKIN_ERROR;
         $form_title = "Error empty url $error";//$w3->getWord(29);
         break;
        }
       case 15: // Empty external link (thumbnail)
        {
         $_STYLE['thumbnail_from_external'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']          = WM3_cSKIN_ERROR;
         $form_title = "Error empty url $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_FIELD['media_from_local'] = $_FIELD['media_from_remote'] = $_FIELD['media_from_external'] = "";
         if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['media_from_remote']   = $_FIELD['media'];
	     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['media_from_external'] = $_FIELD['media'];
         $_FIELD['thumbnail_from_local'] = $_FIELD['thumbnail_from_remote'] = $_FIELD['thumbnail_from_external'] = "";
         if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['thumbnail_from_remote']   = $_FIELD['thumbnail'];
	     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['thumbnail_from_external'] = $_FIELD['thumbnail'];

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit download ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_MEDIA_ALBUM_ITEM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_media_album_item_form.inc");
     return $content;
    }

   public static function saveMediaAlbumItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),WM3_cQUOTE_DB);

     // Media
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['media'] = $_FILES['media_from_local']['name'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['media'] = $_FIELD['media_from_remote'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['media'] = $_FIELD['media_from_external'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_media'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_media" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // Thumbnail
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['thumbnail'] = $_FILES['thumbnail_from_local']['name'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_remote'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_external'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_thumbnail'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_thumbnail" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_media_albums_items',$_FIELD,array('media_from_local','media_from_remote','media_from_external','thumbnail_from_local','thumbnail_from_remote','thumbnail_from_external'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateMediaAlbumItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),WM3_cQUOTE_DB);

     // Media
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['media'] = $_FILES['media_from_local']['name'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['media'] = $_FIELD['media_from_remote'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['media'] = $_FIELD['media_from_external'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_media'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_media" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // Thumbnail
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['thumbnail'] = $_FILES['thumbnail_from_local']['name'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_remote'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_external'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_thumbnail'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_thumbnail" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // TODO Attenzionare campo categoryID
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       SET   media_albumID      = '".$_FIELD['media_albumID']."',
                             title              = '".$_FIELD['title']."',
                             alt                = '".$_FIELD['alt']."',
                             media              = '".$_FIELD['media']."',
                             thumbnail          = '".$_FIELD['thumbnail']."',
                             source_media       = '".$_FIELD['source_media']."',
                             source_thumbnail   = '".$_FIELD['source_thumbnail']."',
                             enabled            = '".$_FIELD['enabled']."',
                             languageID         = '".$_FIELD['languageID']."'
                       WHERE media_album_itemID = '".$_FIELD['media_album_itemID']."'");
     return $_FIELD['media_album_itemID'];
    }

   public static function disableMediaAlbumItem($media_album_itemID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items SET enabled = '".WM3_cDISABLED."' WHERE media_album_itemID = '$media_album_itemID'");
    }

   public static function enableMediaAlbumItem($media_album_itemID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items SET enabled = '".WM3_cENABLED."' WHERE media_album_itemID = '$media_album_itemID'");
    }

   public static function deleteMediaAlbumItem($media_album_itemID)
    {
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items WHERE media_album_itemID = '$media_album_itemID'");
    }

   public static function moveMediaAlbumItem($w3)
    {
	 // Move all selected media from a media album to another
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_media_albums       WRITE");
     $to_media_albumID = $w3->getVariable('to_media_albumID','post');
	 $total_items      = intval($w3->getVariable('total_items','post'));
	 if($w3->getSectionObj()->existsSubcategory($to_media_albumID,'media_albumID'))
	  {
	   for($i = 1; $i <= $total_items; $i++)
	    {
         $media_album_itemID = $w3->getVariable('chk_item'.$i,'post');
		 if($media_album_itemID)
		  {
           wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                             SET    media_albumID      = '$to_media_albumID'
                             WHERE  media_album_itemID = '$media_album_itemID'");
          }
        }
	  }
     wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function renderSingleMediaAlbumItem($w3,$admin = false)
    {
     // Get single media (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $media_albumID = $w3->getVariable('media_albumID','both');
     $media_album_itemID = $w3->getVariable('media_album_itemID','both');
     if($media_albumID && !$categoryID) // When make a search take only media_albumID (but need also categoryID)
      $categoryID = wm3MediaAlbum::getMediaAlbumCategoryID($w3,$media_albumID);
     if($media_albumID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID = '$media_albumID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link   = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";

     $pageID = $w3->getVariable('pageID','both');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.languageID='".$w3->getHomeLanguage()."'";
     $columns = 1; $buttons = 0; 

     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $id_link = "&categoryID=$categoryID&media_albumID=$media_albumID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID=".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.title DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_album_itemID = '$media_album_itemID'");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_media_album_search_form.inc");

     array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     if($media_albumID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                            ," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID)."</a>"
                            ," $_PSEP ".wm3MediaAlbum::getMediaAlbumItemName($w3,$media_album_itemID));
       array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create item
     $_CONTENTS = array(); $_WIDTHS = array();
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);
     $link = $base_link.$id_link.$search_link.$extra_link;
     if($allowed) $allowed_link = $base_allowed_link."&media_album_itemID=$row->media_album_itemID";

     require(WM3_cPATH_INCLUDE."home_media_album_item_rate_form.inc");
     $rating = $row->votes_average;
     $info = "<nobr>(Rating $rating ".wm3Util::makeStars($w3,$rating).") $row->votes_counts votes ($row->hits hits)</nobr>";
     $embed = false;
	 $_MIME_INFO = wm3Folder::getMimeInfoArray($w3,$row->media);
     $mime_icon = $_MIME_INFO['mime_icon'];
	 if($_MIME_INFO['mime_type'] == 'audio') { $embed = true; $width = $height = 0; }
	 if($_MIME_INFO['mime_type'] == 'video') { $embed = true; $width = 400; $height = 300; }
     if($embed)
	  $picture_content = "<object id       = \"mediaPlayer\"
	                              width    = \"$width\"
								  height   = \"$height\"
	                              classid  = \"CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95\"
								  codebase = \"http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701\"
								  standby  = \"Loading Media Player components...\"
								  type     = \"application/x-oleobject\">
                           <param name = \"fileName\"           value = \"".WM3_cPATH_MEDIA_ALBUM."$row->media\">
                           <param name = \"animationatStart\"   value = \"true\">
                           <param name = \"transparentatStart\" value = \"true\">
                           <param name = \"autoStart\"          value = \"true\">
                           <param name = \"showControls\"       value = \"true\">
                           <param name = \"loop\"               value = \"false\">
                           <embed type          = \"application/x-mplayer2\"
                                  pluginspage   = \"http://microsoft.com/windows/mediaplayer/en/download/\"
                                  id            = \"mediaPlayer\"
							      name          = \"mediaPlayer\"
								  displaysize   = \"4\"
								  autosize      = \"-1\" 
                                  bgcolor       = \"darkblue\"
								  showcontrols  = \"true\"
								  showtracker   = \"-1\" 
                                  showdisplay   = \"0\"
								  showstatusbar = \"-1\"
								  videoborder3d = \"-1\"
								  width         = \"$width\"
								  height        = \"$height\"
                                  src           = \"".WM3_cPATH_MEDIA_ALBUM."$row->media\"
								  autostart     = \"true\"
								  designtimesp  = \"5311\"
								  loop          = \"false\">
                                </embed>
                               </object>";
	 else
	  $picture_content = "<img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->media\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\">";
     if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)); else $button = "";
     $title_content   = "$mime_icon $row->title $button<br><br>$info<br><br>$home_content<br>";
     ob_start();
     require($w3->getSkinObj()->getFramePicture());
     $item_content = ob_get_contents();
     ob_end_clean();
     array_push($_CONTENTS,$item_content);

     array_push($_WIDTHS,100);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_MEDIA,$rs_aux,"media_album_itemID",$row->media_album_itemID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function selectMediaAlbumType($name,$value,$w3)
    {
     // Make media album file type to upload
     return wm3Util::selectArray($name,
                        array($w3->getWord(1364),$w3->getWord(1358),$w3->getWord(1359),$w3->getWord(1360),$w3->getWord(1361),$w3->getWord(1362),$w3->getWord(1363)),
                        array(WM3_cMEDIA_ALBUM_TYPE_ALL,WM3_cMEDIA_ALBUM_TYPE_PICTURES,WM3_cMEDIA_ALBUM_TYPE_VIDEO,WM3_cMEDIA_ALBUM_TYPE_AUDIO,WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO,WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO,WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO),
                        $value);
    }

   public static function getMediaAlbumPermissionsLegend($row)
    {
     if($row->visitors_read) $visitors_permissions = "read medias";
     else                    $visitors_permissions = "no access";
     if($row->users_read)    $users_permissions    = "read medias";
     else                    $users_permissions    = "no access";
     if($row->group_read)    $group_permissions    = "read medias";
     else                    $group_permissions    = "no access";
     $str = "Visitors: $visitors_permissions<br>
             Users: $users_permissions<br>
             Group: $group_permissions";
     return $str;
    }

   public static function rateMediaAlbumItem($w3)
    {
	 if(!$w3->getPreferences('anonymous_vote_media_albums') &&
	    !$w3->getAuthenticateAdminUserID()) return;
     $media_album_itemID = $w3->getVariable('media_album_itemID','post');
	 if(!wm3Session::mediaAlbumItemAllowed($media_album_itemID,WM3_cSESSION_RATE)) return;
	 else wm3Session::mediaAlbumItemProtect($media_album_itemID,WM3_cSESSION_RATE);
     $vote = $w3->getVariable('vote','post');
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       SET    votes_counts = votes_counts + 1,
                              votes_sum = votes_sum + $vote,
							  votes_average = votes_sum/votes_counts
                       WHERE  media_album_itemID = '$media_album_itemID'");
    }

   public static function hitMediaAlbumItem($w3)
    {
     $media_album_itemID = $w3->getVariable('media_album_itemID','get');
	 if(!wm3Session::mediaAlbumItemAllowed($media_album_itemID,WM3_cSESSION_HIT)) return;
	 else wm3Session::mediaAlbumItemProtect($media_album_itemID,WM3_cSESSION_HIT);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       SET    hits = hits + 1
                       WHERE  media_album_itemID = '$media_album_itemID'");
    }

   public static function renderMediaAlbumItemTopRating($w3,$order_by,$label,$by_rate,$by_hits,$by_votes,$max_items=15,$admin=false)
    {
     // Get media album top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $filter = ""; $categoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.languageID='".$w3->getHomeLanguage()."'";
     if($allowed) { if($by_rate) $columns = 6; else $columns = 5; $buttons = 1; } else { if($by_rate) $columns = 5; else $columns = 4; $buttons = 0; }

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID=".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     if($by_rate)
	  {
	   require(WM3_cPATH_INCLUDE."admin_media_album_search_form.inc");
       array_push($_CONTENTS,$w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
      }
	 else
	  {
	   $search_form = "";
	   array_push($_CONTENTS,$w3->getWord($label));
	  }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();      	
       //$id_link = "&categoryID=$row->categoryID&media_albumID=$row->media_albumID";
	   $id_link = "&media_albumID=$row->media_albumID";
       $link = $base_link.$page_link.$id_link."&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA;
       $n      = ($p+1).".";   
       $_PERMISSIONS = wm3MediaAlbum::getMediaAlbumPermissionsArray($w3,$row->media_albumID);
       if($_PERMISSIONS['media_read'])
	    {
         $image  = "<a href=\"$link\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>";
         $title  = "<a href=\"$link\">$row->title</a><br><i>".$row->alt."</i>";
		}
	   else
        {
		 $image = wm3Util::renderImg("misc_error_mini.png");
		 $title = "You can not see this media";
	    }	
       if($by_rate)
	    {
	     $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)."</nobr>";
         $value  = "<nobr>($row->votes_average)</nobr>";
	    }
	   else
	    {
         if($by_hits)  $value = "<nobr>$row->hits hits</nobr>";
		 if($by_votes) $value = "<nobr>$row->votes_counts votes</nobr>";
		}
       if($by_rate) array_push($_CONTENTS,$n,$image,$title,$rating,$value);
	   else         array_push($_CONTENTS,$n,$image,$title,$value);
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA;
         array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)));
        }
       if($by_rate)  array_push($_WIDTHS,0,0,85,10,5);
	   else          array_push($_WIDTHS,0,0,90,10);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function makeCounterMediaAlbumItems($w3,$media_albumID,$filter="")
    {
     // Get the number of items in a media album
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_media_albums_items","WHERE media_albumID = '$media_albumID' $filter");
     if($total == 1) $label = $w3->getWord(1684); else $label = $w3->getWord(1683);
     return " ($total $label)";
    }

   public static function getMimeTypeArray($media_album_type)
    {
     // Get the right mime type array
	 switch($media_album_type)
      {
       case WM3_cMEDIA_ALBUM_TYPE_ALL:            { return wm3Folder::mimeTypeImageAudioVideo(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES:       { return wm3Folder::mimeTypeImage(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_VIDEO:          { return wm3Folder::mimeTypeVideo(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO:          { return wm3Folder::mimeTypeAudio(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO: { return wm3Folder::mimeTypeImageVideo(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO: { return wm3Folder::mimeTypeImageAudio(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO:    { return wm3Folder::mimeTypeAudioVideo(); break; }
       default:                                   { return array(); }
	  }
    }

   public static function getMediaAlbumMimeIcons($media_album_type)
    {
     // Get media album mime icons
	 switch($media_album_type)
      {
 	   case WM3_cMEDIA_ALBUM_TYPE_ALL:           { $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_audio.png",'',24,24).wm3Util::renderImg("mime_video.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES:      { $icon = wm3Util::renderImg("mime_image.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_VIDEO:         { $icon = wm3Util::renderImg("mime_video.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO:         { $icon = wm3Util::renderImg("mime_audio.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO:{ $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_video.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO:{ $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_audio.png",'',24,24); braak; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO:   { $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_video.png",'',24,24);	break; }
	   default:                                  { $icon = ""; }
      }
	 return $icon;
    }

   public static function isUsedMediaAlbumItemPicture($file)
    {
	 // Return true if a picture its used in a row
	 $rs = wm3Sql::sqlQuery("SELECT media_albumID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
							 WHERE  media = '$file' OR  thumbnail = '$file'");
     if(mysql_num_rows($rs) == 0) return false;
	 else                         return true;
    }

  }

?>
