<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Panel
  {
   private $column_empty_left,$column_empty_right;
   private $_PANELS; // The class wm3Panel contains all the panels to be render
   
   function __construct()
    {
     $this->column_empty_left = $this->column_empty_right = false;
    }

   public static function getPanelFieldsArray()
    {
     return array('panelID','title','languageID','categoryID','enabled','position','align','extraID','render_mode','head','body','foot','expansion','ts');
    }

   public static function executeAction($w3)
    {
     $sep = "<br><br>";
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_PANEL:
        {
         wm3Panel::disablePanel($w3->getVariable('panelID','get'));
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT,  $w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT, $w3->getVariable('panelID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_PANEL:
        {
         wm3Panel::enablePanel($w3->getVariable('panelID','get'));
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT,  $w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT, $w3->getVariable('panelID','get'));
         break;
        }
       case WM3_cACTION_DELETE_PANEL:
        {
         wm3Panel::deletePanel($w3->getVariable('panelID','get'));
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT)  .$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT);
         break;
        }
       case WM3_cACTION_ADD_PANEL:
        {
         return wm3Panel::addPanel($w3);
         break;
        }
       case WM3_cACTION_SAVE_PANEL:
        {
         $error = wm3Panel::checkPanelError($w3);
         if(!$error)
          {
           $lastID = wm3Panel::savePanel($w3);
           // $msg= panel saved... //TODO
           return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT  ,$lastID).$sep.
                  wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$lastID).$sep.
                  wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT ,$lastID);
          }
         else return wm3Panel::addPanel($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_PANEL:
        {
         return wm3Panel::editPanel($w3);
         break;
        }
       case WM3_cACTION_UPDATE_PANEL:
        {
         $error = wm3Panel::checkPanelError($w3);
         if(!$error)
          {
           $lastID = wm3Panel::updatePanel($w3);
           // $msg= panel udated... //TODO
           return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT  ,$lastID).$sep.
                  wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$lastID).$sep.
                  wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT ,$lastID);
          }
         else return wm3Panel::editPanel($w3,$error);
         break;
        }
       case WM3_cACTION_SWAP_PANEL:
        {
         wm3Panel::swapPanel($w3);
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT  ,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT ,$w3->getVariable('panelID','get'));
         break;
        }
       default:
        {
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT)  .$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT);
        }
      }
    }

   public function createPanels($w3)
    {
     // Get panels from db and store it in the objects array
	 if(wm3Section::isActionPrintable($w3))
	  {
	   $this->column_empty_left = $this->column_empty_right = true;
	   return;
      }

     for($j = WM3_cPANEL_LEFT; $j <= WM3_cPANEL_RIGHT; $j++)
      {
       $i = 0;
       $align = $j;
       if(!$w3->getPageObj()->isColumnEmpty($j))
        {
         $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                                 WHERE align = '$align' AND enabled = '".WM3_cENABLED."' AND languageID = '".$w3->getHomeLanguage()."'
                                 ORDER BY position");
         while($row = mysql_fetch_object($rs))
          {
           $this->_PANELS[$align][$i] = new wm3Panel();

           //$this->_PANELS[$align][$i] = $row; TODO (i campi del db e le variabili devono avere lo stesso nome)
           // Per adesso faccio:
           $this->_PANELS[$align][$i]->panelID     = $row->panelID;
           $this->_PANELS[$align][$i]->title       = $row->title;
           $this->_PANELS[$align][$i]->categoryID  = $row->categoryID;
           $this->_PANELS[$align][$i]->extraID     = $row->extraID;
           $this->_PANELS[$align][$i]->render_mode = $row->render_mode;
           $this->_PANELS[$align][$i]->head        = $row->head;
           $this->_PANELS[$align][$i]->body        = $row->body;
           $this->_PANELS[$align][$i]->foot        = $row->foot;
           // ... eccetera
           $i++;
          }
        }
       if($i == 0)
        {
         if($align == WM3_cPANEL_LEFT)  $this->column_empty_left  = true;
         if($align == WM3_cPANEL_RIGHT) $this->column_empty_right = true;
        }
      }
    }

   public function getPanels($w3,$categoryID,$extraID,$panelID = 0)
    {
     // Get panel content ($extraID its used for certain panel's categories)
     switch($categoryID)
      {
       case WM3_cPANEL_CATEGORY_MESSAGES:
        {
         require(WM3_cPATH_INCLUDE."panel_message.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_LOGIN:
        {
         require(WM3_cPATH_INCLUDE."panel_login.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_CHANNELS:
        {
         require(WM3_cPATH_INCLUDE."panel_channels.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_SEARCH:
        {
         require(WM3_cPATH_INCLUDE."panel_search.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_HOROSCOPE:
        {
         require(WM3_cPATH_INCLUDE."panel_horoscope.inc");
         return $content;
         break;
        }        
       case WM3_cPANEL_CATEGORY_NEWSLETTER:
        {
         require(WM3_cPATH_INCLUDE."panel_newsletter.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_SEND_TO_FRIEND:
        {
         require(WM3_cPATH_INCLUDE."panel_send_to_friend.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_LANGUAGES:
        {
         require(WM3_cPATH_INCLUDE."panel_language.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_ECOMMERCE:
        {
         require(WM3_cPATH_INCLUDE."panel_ecommerce.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_SURVEY:
        {
         require(WM3_cPATH_INCLUDE."panel_survey.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_FORTUNE:
        {
         require(WM3_cPATH_INCLUDE."panel_fortune.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_RSS_FEEDS:
        {
         require(WM3_cPATH_INCLUDE."panel_rss_feed.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_BIRTHDAY:
        {
         require(WM3_cPATH_INCLUDE."panel_birthday.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_SPECIAL_OFFER:
        {
         require(WM3_cPATH_INCLUDE."panel_special_offer.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_EXPANSION:
        {
         require(WM3_cPATH_INCLUDE."panel_expansion.inc");
         return $content;
         break;         
        }
       default: // No panel category found
        {
         return "&nbsp;";
        }
      }
    }

   public function renderPanels($w3,$align)
    {
     // Render panels with $w3->_skin
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_PANELS); // Used to enable admin buttons
	 $w3->getSkinObj()->setCurrentSkinRender($align);// Set current skin render to panel render (left, center or right)
     if(isset($this->_PANELS[$align])) // If there are panels for this $align
      {
       for($i = 0; $i < sizeof($this->_PANELS[$align]); $i++)
        {
         // Enable admin button if allowed
         if($allowed) $edit_button = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PANELS."&action=".WM3_cACTION_EDIT_PANEL."&panelID=".$this->_PANELS[$align][$i]->panelID,"action_edit.png",$w3->getWord(178))." ";
         else         $edit_button = "";

         // Panel title      	
         $title = $edit_button.$this->_PANELS[$align][$i]->title;

         // Panel content
         if($this->_PANELS[$align][$i]->categoryID == WM3_cPANEL_CATEGORY_CUSTOM)
          $content = $this->_PANELS[$align][$i]->head.       
                     wm3Util::renderContent($w3,$this->_PANELS[$align][$i]->body,$this->_PANELS[$align][$i]->render_mode).
                     $this->_PANELS[$align][$i]->foot;
         else
          {
           $content = wm3Panel::getPanels($w3,$this->_PANELS[$align][$i]->categoryID,$this->_PANELS[$align][$i]->extraID,$this->_PANELS[$align][$i]->panelID);
           $content = $this->_PANELS[$align][$i]->head.$content.$this->_PANELS[$align][$i]->foot;
          }
         if($align == WM3_cPANEL_LEFT)   require($w3->getSkinObj()->getPanelLeft());
         if($align == WM3_cPANEL_CENTER) require($w3->getSkinObj()->getPanelCenter());
         if($align == WM3_cPANEL_RIGHT)  require($w3->getSkinObj()->getPanelRight());
         // TODO fare unset($this->_PANELS[$align][$i]); ???????
        }
      }
    }

   public static function getPositions($align)
    {
     // Create an array with panels position
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                             WHERE align = '$align'
                             ORDER BY position");
     $i = 1; $_PPOS['up'][0] = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_PPOS['up'][$i] = $_PPOS['down'][$i] = $row->panelID;
       $i++;
      }
     $m = $i-1; $_PPOS['down'][$i] = 0;
     for($i = $m;$i >= 1; $i--) $_PPOS['up'][$i]   = $_PPOS['up'][$i-1];
     for($i = 1;$i <= $m; $i++) $_PPOS['down'][$i] = $_PPOS['down'][$i+1];
     return $_PPOS;
    }

   public static function getPosition($panelID)
    {
     // Get the position of a panel
     $rs = wm3Sql::sqlQuery("SELECT position FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                             WHERE panelID = '$panelID'");
     $row = mysql_fetch_object($rs);
     if($row) return $row->position;
    }

   public static function getPanelList($w3,$align,$currentID = 0)
    {
     // Get panels list for $align
     $columns = 8; $buttons = 3;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
     $query ="SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
              WHERE align = '$align'
              ORDER BY position";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     $align_label = $w3->getWord(461 + $align);
     array_push($_CONTENTS,"$align_label ".$w3->getWord(146));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption
	 $str .= wm3Section::makeCaptionList($w3,array(0,60,40,0),array(543,194,1407),$buttons,false,array(3));

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items     
     $i = 1; $p = 0;
     $_PPOS = wm3Panel::getPositions($align);
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link."&panelID=$row->panelID";
       if($row->categoryID == 0) $type_label = $w3->getWord(544); // Custom panel
       else                      $type_label = $w3->getLanguageObj()->translate(wm3Panel::getPanelCategoryName($row->categoryID));

       // Move panels up and down buttons and panel info
       array_push($_CONTENTS,$row->position);
       if($_PPOS['up'][$i]   == 0) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">");
       else                        array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_PANEL."&swapID=".$_PPOS['up'][$i],"action_up.png",$w3->getWord(1273)));
       if($_PPOS['down'][$i] == 0) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">");
       else                        array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_PANEL."&swapID=".$_PPOS['down'][$i],"action_down.png",$w3->getWord(1274)));
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
       array_push($_CONTENTS,$row->title);
       array_push($_CONTENTS,"$lang_flag ($align_label, $type_label)");
       $i++;

       array_push($_WIDTHS,0,0,0,60,40);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_PANEL,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_PANEL,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_PANEL,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_PANEL,"action_delete.png",$w3->getWord(179),$w3->getWord(710)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->panelID==$currentID);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function checkPanelError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray());
     if(!$_FIELD['title']) return 1;
     if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY && !$_FIELD['extraID']) return 2;
     return 0;
    }

   public static function addPanel($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Panel::getPanelFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray());

     // Hide/Show correct field and error
     $_EXTRA_STYLE['extraID'] = $_EXTRA_STYLE['expansion'] = $_EXTRA_STYLE['body'] = "style=\"display:none\"";
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY)    $_EXTRA_STYLE['extraID']   = "";
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_EXPANSION) $_EXTRA_STYLE['expansion'] = "";
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_CUSTOM)    $_EXTRA_STYLE['body']      = "";

     switch($error)
      {
       case 1: // No title 
        {
         $_STYLE['title']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // No survey when select panel survey type
        {
         $_STYLE['extraID']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error No survey";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;
		 $_EXTRA_STYLE['body'] = "";
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(144);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_PANEL; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_panel_form.inc");
     return $content;
    }

   public static function editPanel($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                               WHERE panelID = '".$w3->getVariable('panelID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Panel::getPanelFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Panel::getPanelFieldsArray());

     // Hide/Show correct field and error
     $_EXTRA_STYLE['extraID'] = $_EXTRA_STYLE['expansion'] = $_EXTRA_STYLE['body'] = "style=\"display:none\"";
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY)    $_EXTRA_STYLE['extraID']   = "";
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_EXPANSION) $_EXTRA_STYLE['expansion'] = "";
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_CUSTOM)    $_EXTRA_STYLE['body']      = "";

     switch($error)
      {
       case 1: // No title 
        {
         $_STYLE['title']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // No survey when select panel survey type
        {
         $_STYLE['extraID']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error No survey";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Insert new panel"; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_PANEL;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_panel_form.inc");
     return $content;
    }

   public static function savePanel($w3)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");

     $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     if($_FIELD['position'] <= 0) $_FIELD['position'] = 1; // If position its <= 0 (invalid position) the position will be 1
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                       SET position = position + 1
                       WHERE position >= '".$_FIELD['position']."'");
     wm3Sql::saveAllTableFields('_panels',$_FIELD);

     wm3Sql::sqlQuery("UNLOCK TABLES");
     return wm3Sql::getLastInsertID();
    }

   public static function updatePanel($w3)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");

	 $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray(),WM3_cQUOTE_DB);
     wm3Panel::updatePanelPositions($_FIELD['panelID'],$_FIELD['position']);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                       SET title       = '".$_FIELD['title']."',
					       render_mode = '".$_FIELD['render_mode']."',
                           head        = '".$_FIELD['head']."',
                           body        = '".$_FIELD['body']."',
                           foot        = '".$_FIELD['foot']."',
						   expansion   = '".$_FIELD['expansion']."',
                           enabled     = '".$_FIELD['enabled']."',
                           position    = '".$_FIELD['position']."',
                           align       = '".$_FIELD['align']."',
                           categoryID  = '".$_FIELD['categoryID']."',
                           extraID     = '".$_FIELD['extraID']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE panelID   = '".$_FIELD['panelID']."'");

     wm3Sql::sqlQuery("UNLOCK TABLES");
     return $_FIELD['panelID'];
    }

   public static function swapPanel($w3)
    {
     // Swap two panels position (move up or down panels)
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");
     
     $panelID       = $w3->getVariable('panelID','get');
     $swapID        = $w3->getVariable('swapID','get');     
     $swap_position = wm3Panel::getPosition($swapID);
     $position      = wm3Panel::getPosition($panelID);

     if($position && $swap_position) // Swap effected only if the item exists (by checking the position)
      {
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                         SET position          = '$swap_position'
                         WHERE panelID = '$panelID'");
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                         SET position          = '$position'
                         WHERE panelID = '$swapID'");
      }

     wm3Sql::sqlQuery("UNLOCK TABLES");
     return $panelID;
    }

   public static function updatePanelPositions($panelID,$new_position)
    {
     // Update the right panel position when a panel position changed
     $position = wm3Panel::getPosition($panelID);

     if($position) // Update effected only if the item exists (by checking the position)
      {
       if($new_position > $position)
        {
         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position = position - 1
                           WHERE position > '$position' AND position <= '$new_position'");

         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position  = '$new_position'
                           WHERE panelID = '$panelID'");
        }
       else
        {
         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position = position + 1
                           WHERE position >= '$new_position' AND position < '$position'");

         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position  = '$new_position'
                           WHERE panelID = '$panelID'");
        }
      }
    }

   public static function disablePanel($panelID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels SET enabled = '".WM3_cDISABLED."' WHERE panelID = '$panelID'"); }

   public static function enablePanel($panelID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels SET enabled = '".WM3_cENABLED."'  WHERE panelID = '$panelID'"); }

   public static function deletePanel($panelID)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");

     $position = wm3Panel::getPosition($panelID);
     if($position) // Update positions only if the deleted item exists (by checking the position)
      {
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                         SET position = position - 1
                         WHERE position > '$position'");
      }
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_panels WHERE panelID = '$panelID'");

   	 wm3Sql::sqlQuery("UNLOCK TABLES");
   	}

   public static function selectPanelCategory($w3,$name,$categoryID,$js = "")
    {
     // Make panel categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                             ORDER BY position DESC, name");
     $i = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_LABEL[$i] = $w3->getLanguageObj()->translate($row->name);
       $_VALUE[$i] = $row->categoryID;
       $i++;
      }
     return wm3Util::selectArray($name,$_LABEL,$_VALUE,$categoryID,$js);
    }

   public static function selectPanelPosition($name,$position,$w3)
    {
     // Make panel position select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels");
     $str = "<select name=\"$name\">";
     $i = 1;
     while($row = mysql_fetch_object($rs))
      {
       if($position == $i) $str .= wm3Util::inputOption($i,$i,"selected");
       else                $str .= wm3Util::inputOption($i,$i);
       $i++;
      }
     if($w3->getAction() == WM3_cACTION_ADD_PANEL ||
        $w3->getAction() == WM3_cACTION_SAVE_PANEL)
      {
       if($position == $i) $str .= wm3Util::inputOption($i,$i,"selected");
       else                $str .= wm3Util::inputOption($i,$i);       
      }
     $str .= "</select>";
     return $str;
    }

   public static function getPanelCategoryName($categoryID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                             WHERE categoryID = '$categoryID'");
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function renderPanelExpansion($w3,$panelID)
    {
     $rs = wm3Sql::sqlQuery("SELECT expansion FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                             WHERE panelID = '$panelID' AND categoryID = '".WM3_cPANEL_CATEGORY_EXPANSION."'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     $expansion = $row->expansion;
	 $file = WM3_cPATH_EXPANSION.$expansion.'/index.php';
	 if(file_exists($file))
	  {
	   ob_start();
	   require_once($file);
	   $output = ob_get_contents();
	   ob_end_clean();
      }
     else return "<br><b>Error: file index.php file not found!</b><br>"; //TODO
	 return $output;
	}

   public function setColumnEmpty($align,$v)
    {
     if($align == WM3_cPANEL_LEFT)  $this->column_empty_left  = $v;
     if($align == WM3_cPANEL_RIGHT) $this->column_empty_right = $v;
    }    

   public function isColumnEmpty($align) 
    {
     if($align == WM3_cPANEL_LEFT)  return $this->column_empty_left;
     if($align == WM3_cPANEL_RIGHT) return $this->column_empty_right;
    }

  }

?>
