<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3User
  {

   function __construct() { }

   public static function getUserFieldsArray()
    {
     return array('userID','login','password','retype_password','groupID',
                  'name','surname','avatar','address','zip_code','city','stateID','countryID','phone','fax','cell','email','website','icq',
                  'birth_date','gender','birth_city','birth_stateID','birth_countryID',
                  'enabled','special','visible','deleted','f1','f2','f3','f4','f5','f6','f7','f8','notes',
                  'admin',
                  'af1' ,'af2' ,'af3' ,'af4' ,'af5' ,'af6' ,'af7' ,'af8' ,'af9' ,'af10',
                  'af11','af12','af13','af14','af15','af16','af17','af18','af19','af20',
                  'af21','af22','af23','af24','af25','af26','af27','af28','af29','af30',
                  'af31','af32','af33','af34','af35','af36','af37','af38','af39','af40',
                  'superuser','languageID','last_user_login_ts','previous_user_login_ts','last_admin_login_ts','previous_admin_login_ts','ts');
    }

   public static function getUserPasswordFieldsArray()
    {
     return array('old_password','password','retype_password','send_email');
    }

   public static function getGroupFieldsArray()
    {
     return array('groupID','name','description','enabled','icon','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SAVE_USER_REGISTRATION:
        {
         $error = wm3User::checkUserRegistrationError($w3);
         if(!$error)
          {
           $lastID = wm3User::saveUserRegistration($w3);
           // $msg= page saved... //TODO
           return wm3User::completeUserRegistration($w3,$lastID);
          }
         else return wm3User::addUserRegistration($w3,$error);
         break;
        }
       default:
        {
         return wm3User::addUserRegistration($w3);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {


       case WM3_cACTION_EDIT_PASSWORD_USER:
        {
         return wm3User::editUserPassword($w3);
         break;
        }
       case WM3_cACTION_UPDATE_PASSWORD_USER:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserPasswordError($w3,$w3->getVariable('userID','both'));
         if(!$error)
          {
           $lastID = wm3User::updateUserPassword($w3,$w3->getVariable('userID','both'));
           // $msg= user udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getUserList($w3,$w3->getVariable('userID','both'));
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::editUserPassword($w3,$error);
	      }
         break;
        }



       case WM3_cACTION_DISABLE_USER:
        {
		 if(wm3User::isSuperUser($w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         wm3User::disableUser($w3->getVariable('userID','get'));
         return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_USER:
        {
		 if(wm3User::isSuperUser($w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         wm3User::enableUser($w3->getVariable('userID','get'));
         return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         break;
        }
/*       case WM3_cACTION_DELETE_USER:
        {
		 if(wm3User::isSuperUser($w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         wm3User::deleteUser($w3->getVariable('userID','get'));
         return wm3User::getUserList($w3);
         break;
        }*/
		
       case WM3_cACTION_ADD_USER:
        {
         return wm3User::addUser($w3);
         break;
        }
       case WM3_cACTION_SAVE_USER:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserError($w3,0,true);
         if(!$error)
          {
           $lastID = wm3User::saveUser($w3);
           // $msg= page saved... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getUserList($w3,$lastID);
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::addUser($w3,$error);
	      }
         break;
        }
       case WM3_cACTION_EDIT_USER:
        {
		 if(wm3User::isSuperUser($w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));
         return wm3User::editUser($w3);
         break;
        }
       case WM3_cACTION_UPDATE_USER:
        {
		 if(wm3User::isSuperUser($w3->getVariable('userID','get')))
		  return wm3User::getUserList($w3,$w3->getVariable('userID','get'));			
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserError($w3,0,true);
         if(!$error)
          {
           $lastID = wm3User::updateUser($w3);
           // $msg= user udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getUserList($w3,$lastID);
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::editUser($w3,$error);
	      }
         break;
        }
       case WM3_cACTION_DELETE_GROUP:
        {
         wm3User::deleteGroup($w3->getVariable('groupID','get'));
         return wm3User::getGroupList($w3);
         break;
        }
       case WM3_cACTION_ADD_GROUP:
        {
         return wm3User::addGroup($w3);
         break;
        }
       case WM3_cACTION_SAVE_GROUP:
        {
         $error = wm3User::checkGroupError($w3);
         if(!$error)
          {
           $lastID = wm3User::saveGroup($w3);
           // $msg= page saved... //TODO
           return wm3User::getGroupList($w3,$lastID);
          }
         else return wm3User::addGroup($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_GROUP:
        {
         return wm3User::editGroup($w3);
         break;
        }
       case WM3_cACTION_UPDATE_GROUP:
        {
         $error = wm3User::checkGroupError($w3);
         if(!$error)
          {
           $lastID = wm3User::updateGroup($w3);
           // $msg= page udated... //TODO
           return wm3User::getGroupList($w3,$lastID);
          }
         else return wm3User::editGroup($w3,$error);
         break;
        }
       case WM3_cACTION_SHOW_GROUP:
        {
         return wm3User::getGroupList($w3);
        }
       default:
        {
         return wm3User::getUserList($w3);
        }
      }
    }

   public static function executeUserInformationUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_EDIT_USER:
        {
         return wm3User::editUserInformation($w3,0,false);
         break;
        }
       case WM3_cACTION_UPDATE_USER:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserError($w3,$w3->getAuthenticateUserID());
         if(!$error)
          {
           $lastID = wm3User::updateUserInformation($w3,false);
           // $msg= user udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateUserID());
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::editUserInformation($w3,$error,false);
	      }
         break;
        }


       case WM3_cACTION_EDIT_PASSWORD_USER:
        {
         return wm3User::editUserInformationPassword($w3,0,false);
         break;
        }
       case WM3_cACTION_UPDATE_PASSWORD_USER:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserPasswordError($w3,$w3->getAuthenticateUserID(),false);
         if(!$error)
          {
           $lastID = wm3User::updateUserInformationPassword($w3,$w3->getAuthenticateUserID());
           // $msg= user udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateUserID());
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::editUserInformationPassword($w3,$error,false);
	      }
         break;
        }


       default:
        {
         return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateUserID());
        }
      }
    }

   public static function executeUserInformationAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_EDIT_USER:
        {
         return wm3User::editUserInformation($w3);
         break;
        }
       case WM3_cACTION_UPDATE_USER:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserError($w3,$w3->getAuthenticateAdminID(),true);
         if(!$error)
          {
           $lastID = wm3User::updateUserInformation($w3);
           // $msg= user udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateAdminID());
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::editUserInformation($w3,$error);
	      }
         break;
        }


       case WM3_cACTION_EDIT_PASSWORD_USER:
        {
         return wm3User::editUserInformationPassword($w3);
         break;
        }
       case WM3_cACTION_UPDATE_PASSWORD_USER:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_users WRITE");
         $error = wm3User::checkUserPasswordError($w3,$w3->getAuthenticateAdminID(),false);
         if(!$error)
          {
           $lastID = wm3User::updateUserInformationPassword($w3,$w3->getAuthenticateAdminID());
           // $msg= user udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateAdminID());
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3User::editUserInformationPassword($w3,$error);
	      }
         break;
        }


       default:
        {
         return wm3User::getSingleUserInformation($w3,0,$w3->getAuthenticateAdminID());
        }
      }
    }

   public static function getSectionUserDataArray($w3)
    {
     $_DATA['img']     = array('icon_home_user.png','icon_news.png','','','icon_forum.png','icon_banners.png','icon_market.png',);
     $_DATA['alt']     = array($w3->getWord(501),$w3->getWord(511),'','',$w3->getWord(973),$w3->getWord(510),$w3->getWord(509));
	 // If render its enabled the icon will be render into the menu
     $_DATA['render']  = array(WM3_cENABLED,WM3_cENABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED);
	 // Section offsets (set correct section numbers for user side)
     $_DATA['section'] = array(WM3_cSECTION_HOME,WM3_cSECTION_NEWS,0,0,WM3_cSECTION_FORUMS,WM3_cSECTION_BANNERS,WM3_cSECTION_MARKET);
     return $_DATA;
    }

   public static function getSectionAdminDataArray($w3)
    {
     $_DATA['img']     = array('icon_home_admin.png','icon_news.png','icon_pages.png','icon_users.png','icon_menubar.png','icon_panels.png','icon_channels.png','icon_messages.png','icon_links.png','icon_faq.png','icon_searchengine.png','icon_newsletter.png','icon_surveys.png','icon_horoscope.png','icon_forum.png','icon_downloads.png','icon_albums.png','icon_directories.png','icon_ecommerce.png','icon_market.png','icon_banners.png','icon_webmail.png','icon_folders.png','icon_preferences.png','icon_metatags.png','icon_statistics.png','icon_languages.png');
     $_DATA['alt']     = array($w3->getWord(501),$w3->getWord(511),$w3->getWord(518),$w3->getWord(513),$w3->getWord(519),$w3->getWord(516),$w3->getWord(517),$w3->getWord(515),$w3->getWord(512),$w3->getWord(506),$w3->getWord(507),$w3->getWord(508),$w3->getWord(835),$w3->getWord(514),$w3->getWord(1375),$w3->getWord(1036),$w3->getWord(1335),$w3->getWord(1037),$w3->getWord(656),$w3->getWord(509),$w3->getWord(510),$w3->getWord(1454),$w3->getWord(1374),$w3->getWord(27),$w3->getWord(1373),$w3->getWord(54),$w3->getWord(1291));
	 // If render its enabled the icon will be render into the menu
	 $_DATA['render']  = array(WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cENABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cENABLED);
	 // Section offsets (set correct section numbers for user side)
	 $_DATA['section'] = array(WM3_cSECTION_HOME,WM3_cSECTION_NEWS,WM3_cSECTION_PAGES,WM3_cSECTION_USERS,WM3_cSECTION_MENU_BARS,WM3_cSECTION_PANELS,WM3_cSECTION_CHANNELS,WM3_cSECTION_MESSAGES,WM3_cSECTION_LINKS,WM3_cSECTION_FAQ,WM3_cSECTION_SEARCH_ENGINE,WM3_cSECTION_NEWSLETTER,WM3_cSECTION_SURVEYS,WM3_cSECTION_HOROSCOPE,WM3_cSECTION_FORUMS,WM3_cSECTION_DOWNLOADS,WM3_cSECTION_MEDIA_ALBUMS,WM3_cSECTION_DIRECTORIES,WM3_cSECTION_ECOMMERCE,WM3_cSECTION_MARKET,WM3_cSECTION_BANNERS,WM3_cSECTION_WEBMAIL,WM3_cSECTION_FOLDERS,WM3_cSECTION_PREFERENCES,WM3_cSECTION_METATAGS,WM3_cSECTION_STATISTICS,WM3_cSECTION_LANGUAGES);
     return $_DATA;
    }

   public static function setUserCookies()
    {
     // User authentication (return the userID of logged user)

     if(!isset($_COOKIE['user_login']) || !isset($_COOKIE['user_password']))
      {
       // Admin login or password cookies not set
       if(!isset($_POST['user_login']) || !isset($_POST['user_password'])) return WM3_cUSER_ANONYMOUS;
       if($_POST['user_login'] == "" || $_POST['user_password'] == "")     return WM3_cUSER_ANONYMOUS;

       if(md5($_POST['user_password']) == wm3User::getUserPassword($_POST['user_login']))
        {
         // Login and password check its passed, can set cookies and update login time stamp
         setcookie("user_login",    $_POST['user_login']);
         setcookie("user_password", md5($_POST['user_password']));
         $userID = wm3User::getUserIDFromLogin($_POST['user_login']);
         wm3User::setUserLastLoginTimeStamp($userID);
         return $userID;
        }
      }
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['user_password'] == wm3User::getUserPassword($_COOKIE['user_login'])) return wm3User::getUserIDFromLogin($_COOKIE['user_login']);
       else {
		     // Remove the bad cookie (useful when password changes)
			 setcookie("user_login",   "",time()-3600);
		     setcookie("user_password","",time()-3600);
	        }
      }
     return 0;
    } 

   public static function setAdminCookies()
    {
     // Admin authentication (return the userID of logged administrator)
     
     if(!isset($_COOKIE['admin_login']) || !isset($_COOKIE['admin_password']))
      {
       // Admin login or password cookies not set
       if(!isset($_POST['admin_login']) || !isset($_POST['admin_password'])) return WM3_cUSER_ANONYMOUS;
       if($_POST['admin_login'] == "" || $_POST['admin_password'] == "")     return WM3_cUSER_ANONYMOUS;

       if(md5($_POST['admin_password']) == wm3User::getAdminPassword($_POST['admin_login']))
        {
         // Login and password check its passed, can set cookies and update login time stamp
         setcookie("admin_login",    $_POST['admin_login']);
         setcookie("admin_password", md5($_POST['admin_password']));
         $userID = wm3User::getUserIDFromLogin($_POST['admin_login']);
         wm3User::setAdminLastLoginTimeStamp($userID);
         return $userID;
        }
      }
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['admin_password'] == wm3User::getAdminPassword($_COOKIE['admin_login'])) return wm3User::getUserIDFromLogin($_COOKIE['admin_login']);
       else {
		     // Remove the bad cookie (useful when password changes)
			 setcookie("admin_login",   "",time()-3600);
		     setcookie("admin_password","",time()-3600);
	        }
      }
     return 0;
    } 

   public static function checkUserAuthentication()
    {
     // Check User authentication cookies (return the userID of logged user)

     // User login or password cookies not set     
     if(!isset($_COOKIE['user_login']) || !isset($_COOKIE['user_password'])) return WM3_cUSER_ANONYMOUS;
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['user_password'] == wm3User::getUserPassword($_COOKIE['user_login'])) return wm3User::getUserIDFromLogin($_COOKIE['user_login']);
      }
     return WM3_cUSER_ANONYMOUS;
    }

   public static function checkAdminAuthentication()
    {
     // Check Admin authentication cookies (return the userID of logged administrator)

     // Admin login or password cookies not set     
     if(!isset($_COOKIE['admin_login']) || !isset($_COOKIE['admin_password'])) return WM3_cUSER_ANONYMOUS;
     else
      {
       // Cookies already set, check it and return logged userID if check passed
       if($_COOKIE['admin_password'] == wm3User::getAdminPassword($_COOKIE['admin_login'])) return wm3User::getUserIDFromLogin($_COOKIE['admin_login']);
      }
     return WM3_cUSER_ANONYMOUS;
    }

   public static function isSuperUser($userID)
    {
     // Check if the user its superuser
     $rs = wm3Sql::sqlQuery("SELECT superuser FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->superuser;
    }

   public static function getUserIDFromLogin($login)
    {
     // Return userID from login
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE login = '$login'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->userID;
    } 

   public static function getUserIDFromEmail($email)
    {
     // Return userID from email
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE email = '$email'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->userID;
    } 

   public static function getUserLogin($userID)
    {
     // Return login from userID
     $rs = wm3Sql::sqlQuery("SELECT login FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->login;
    }

   public static function getUserLastLoginTimeStamp($userID,$previous = false)
    {
     // Return last user login time stamp from userID
     $rs = wm3Sql::sqlQuery("SELECT last_user_login_ts,previous_user_login_ts FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) != 1) return 0; // Never logged
     $row = mysql_fetch_object($rs);
     if($previous) return $row->previous_user_login_ts;
	 else          return $row->last_user_login_ts;
    }

   public static function getAdminLastLoginTimeStamp($userID,$previous = false)
    {
     // Return last admin login time stamp from userID
     $rs = wm3Sql::sqlQuery("SELECT last_admin_login_ts,previous_admin_login_ts FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) != 1) return 0; // Never logged
     $row = mysql_fetch_object($rs);
     if($previous) return $row->previous_admin_login_ts;
	 else          return $row->last_admin_login_ts; 
    }

   public static function setUserLastLoginTimeStamp($userID)
    {
     // Update user login timestap when an user do the login
     $ts = time();
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET   previous_user_login_ts  = last_user_login_ts,
					         last_user_login_ts      = '$ts'
                       WHERE userID                  = '$userID'");
    }

   public static function setAdminLastLoginTimeStamp($userID)
    {
     // Update admin login timestap when an administrator do the login
     $ts = time();
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET   previous_admin_login_ts  = last_admin_login_ts,
					         last_admin_login_ts      = '$ts'
                       WHERE userID                   = '$userID'");
    }

   public static function logoutUser()
    {
     setcookie("user_login",   "",time()-3600);
     setcookie("user_password","",time()-3600);
     header("Location: ".WM3_cCONFIG_HOME_FILE); // Redirect to home page
     die;
    }

   public static function logoutAdmin()
    {
     setcookie("admin_login",   "",time()-3600);
     setcookie("admin_password","",time()-3600);
     header("Location: ".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN); // Redirect to admin login panel
     die;
    }

   public static function getUserPassword($login)
    {
     $rs = wm3Sql::sqlQuery("SELECT password FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE login = '".wm3Util::quoteDB($login)."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."'");
     if(mysql_num_rows($rs)!=0)
      {
       $row=mysql_fetch_object($rs);
       return $row->password;
      }
     return "";
    }

   public static function getAdminPassword($login)
    {
     $rs = wm3Sql::sqlQuery("SELECT password FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE login = '".wm3Util::quoteDB($login)."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."' AND admin = '".WM3_cENABLED."'");
     if(mysql_num_rows($rs)!=0)
      {
       $row=mysql_fetch_object($rs);
       return $row->password;
      }
     return "";
    }

   public static function getPageUserInfo($w3,$pageID)
    {
     // User info page content
     $userID = $w3->getVariable('userID','get');
     if($userID) return wm3User::getSingleUserInformation($w3,$pageID,$userID);
     else        return wm3User::getAllUsersInformation($w3,$pageID);
    }

   public static function getAllUsersInformation($w3,$pageID)
    {
     // Get users list (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS); // Used to enable admin buttons in home stage
     if($allowed) { $columns = 7; $buttons = 1; } else { $columns = 6; $buttons = 0; }
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE login LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     $search_form_link = WM3_cCONFIG_HOME_FILE."?pageID=$pageID";
	 $base_link = WM3_cCONFIG_HOME_FILE."?section=".$w3->getSection()."&pageID=$pageID";
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS;
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY userID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 /*if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'userID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }*/
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_user_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(-1)."Users list");
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array(0,15,15,15,25,30,0),array(403,-1,416,902,899,900),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
	 $_WIDTHS = array(0,15,15,15,25,30);
     while($row = mysql_fetch_object($rs))
      {
	   $_CONTENTS = array();
       $link = $base_link.$id_link."&userID=$row->userID";
	   if($allowed) $allowed_link = $base_allowed_link."&userID=$row->userID";
       $avatar = "<a href=\"$link\">".wm3Util::renderImg($row->avatar,'',36,36,WM3_cPATH_AVATARS,1)."</a>";
	   $group_name = wm3User::getGroupName($row->groupID);

	   if(wm3Session::getSessionIDFromUserID($row->userID)) $online = wm3Util::renderImg("misc_online.png")." online";
	   else                                                 $online = wm3Util::renderImg("misc_offline.png")." offline";
       $info = "<a href=\"$link\">$row->login</a> ($group_name)<br><br>$online";
       //if($row->userID == $currentID) $css_class = "listCurrent";
	   $last_user_login  = wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($row->userID),$w3->getAdminLanguage(),false,"Never logged")." (user)";
	   if($row->admin) $last_admin_login = wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($row->userID),$w3->getAdminLanguage(),false,"Never logged")." (admin)";
	   else            $last_admin_login = "";
	   $last_login = $last_user_login."<br>".$last_admin_login;
	   $rank       = wm3User::renderRank($w3,$row->userID);
   	   $admin_pic  = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if($row->admin)     $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if($row->superuser) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	   $rank = "<nobr>".$rank." ".$admin_pic."</nobr>";
	   $vitality = "<nobr>".wm3User::renderVitality($w3,$row->userID)."</nobr>";
       array_push($_CONTENTS,$avatar,$info,$rank,$vitality,$last_user_login,$last_login);
       // Buttons
	   if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
	   $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getSingleUserInformation($w3,$pageID,$userID,$bottom = true)
    {
	 // Prepare variables
 	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS); // Used to enable admin buttons in home stage
     if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }

/*     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE body LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     $search_form_link = WM3_cCONFIG_HOME_FILE;
     $pageID = $w3->getVariable('pageID','get');*/

     $base_link = WM3_cCONFIG_HOME_FILE."?section=".$w3->getSection();
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS;
     $id_link   = "";

     // Create header
     $_CONTENTS = array(); $search_form = "";
     ///require(WM3_cPATH_INCLUDE."admin_page_search_form.inc");
	 array_push($_CONTENTS,$w3->getWord(896));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,922);

     // User main info
	 $row = mysql_fetch_object($rs);
	 $_CONTENTS = array(); $_WIDTHS = array(10,90,0); $i = 0;
     $link = $base_link.$id_link;
	 if($allowed) $allowed_link = $base_allowed_link."&userID=$row->userID";
	 $group_name = wm3User::getGroupName($row->groupID);
	 $rank = wm3User::renderRank($w3,$row->userID);

     $admin_pic  = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
     if($row->admin)     $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
     if($row->superuser) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	 $rank     = "<nobr>".$rank." ".$admin_pic."</nobr>";
	 $vitality = "<nobr>".wm3User::renderVitality($w3,$row->userID,180)."</nobr>";
     if(wm3Session::getSessionIDFromUserID($row->userID)) $online = wm3Util::renderImg("misc_online.png")." online";
	 else                                                 $online = wm3Util::renderImg("misc_offline.png")." offline";
     $avatar   = "<img src=\"".WM3_cPATH_AVATARS."$row->avatar\" width=\"36\" height=\"36\" border=\"1\" align=\"absmiddle\"> ";

     $buttons = "";
	 if($w3->getAuthenticateUserID())
	  if(wm3User::checkUserPermission($w3,3) && $row->f3 == WM3_cENABLED)
	   $buttons = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_USER_MESSAGES."&action=".WM3_cACTION_ADD_USER_MESSAGE."&toID=".$row->userID,"action_newsletter.png",$w3->getWord(178),"","",0,16,16)." ";
	 if($w3->getAuthenticateAdminID())
	  if($row->f3 == WM3_cENABLED)
	   $buttons = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USER_MESSAGES."&action=".WM3_cACTION_ADD_USER_MESSAGE."&toID=".$row->userID,"action_newsletter.png",$w3->getWord(178),"","",0,16,16)." ";

     $pic      = $avatar."<br><br><nobr>$buttons</nobr><br>";
	 $member_from = "<i>".$w3->getWord(899)." ".wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage())."</i>";
	 //$login    = "<a href=\"$link&pageID=$pageID&userID=$row->userID\">$row->login</a> <b>($group_name)</b><br>$member_from<br><br>$rank<br><br>$vitality<br><br>$online<br><br>";
	 $login    = "$row->login <b>($group_name)</b><br>$member_from<br><br>$rank<br><br>$vitality<br><br>$online<br><br>";
	 array_push($_CONTENTS,$pic,$login);
	 if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178)));
	 $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false);

     // Extra info
     $_CONTENTS = array(); $i++;
	 $last_user_login  = wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($row->userID),$w3->getAdminLanguage(),false,"Never logged")." (user)";
	 if($row->admin) $last_admin_login = wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($row->userID),$w3->getAdminLanguage(),false,"Never logged")." (admin)";
	 else            $last_admin_login = "";
	 $label = "<b>".$w3->getWord(900)."</b>";
	 if($row->admin == WM3_cENABLED) $last_login = wm3Util::renderImg("misc_log.png")." $last_user_login<br><br>".wm3Util::renderImg("misc_log_admin.png")." $last_admin_login";
	 else                            $last_login = wm3Util::renderImg("misc_log.png")." $last_user_login";
	 array_push($_CONTENTS,$label,$last_login."<br><br>");
     $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false,array(1,$columns-1));

     if($row->visible == WM3_cENABLED)
	  {
       $_CONTENTS = array(); $i++;
	   $label  = "<b>".$w3->getWord(189)."</b>";
	   if($row->gender == 'M') $gender = wm3Util::renderImg("misc_male.png");
	   else                    $gender = wm3Util::renderImg("misc_female.png");
	   $name   = "$row->name $row->surname $gender";
	   array_push($_CONTENTS,$label,$name."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false,array(1,$columns-1));

       $_CONTENTS = array(); $i++;
	   $label   = "<b>".$w3->getWord(260)."</b>";
	   $address = wm3Util::renderImg("misc_home.png")." $row->address - $row->zip_code $row->city ($row->stateID)<br><br>".wm3Util::renderImg(wm3Statistic::getCountryFlag($row->countryID),'',20,13,WM3_cPATH_FLAGS)." ".wm3Statistic::getCountryName($w3,$row->countryID);
	   array_push($_CONTENTS,$label,$address."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false,array(1,$columns-1));

       $_CONTENTS = array(); $i++;
	   $label    = "<b>".$w3->getWord(-1)."Contacts...</b>";
	   $contacts = wm3Util::renderImg("misc_phone.png")." $row->phone<br><br>".wm3Util::renderImg("misc_fax.png")." $row->fax<br><br>".wm3Util::renderImg("misc_cell.png")." $row->cell";
	   array_push($_CONTENTS,$label,$contacts."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false,array(1,$columns-1));

       $_CONTENTS = array(); $i++;
	   $label = "<b>".$w3->getWord(-1)."Web info...</b>";
	   $web   = "<a href=\"$row->website\" target=\"_blank\">".wm3Util::renderImg("misc_world.png")." $row->website</a><br><br><a href=\"mailto:$row->email\">".wm3Util::renderImg("misc_email.png")." $row->email</a><br><br>".wm3Util::renderImg("misc_icq.png")." $row->icq";
	   array_push($_CONTENTS,$label,$web."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false,array(1,$columns-1));

       $_CONTENTS = array(); $i++;
	   $label = "<b>".$w3->getWord(-1)."Other info...</b>";
	   $other = wm3Util::renderImg("misc_birthday.png")." $row->birth_city ($row->birth_stateID), ".wm3Util::renderDate($w3,$row->birth_date,$w3->getAdminLanguage(),false,"No date TODO")."<br><br>".wm3Util::renderImg(wm3Statistic::getCountryFlag($row->birth_countryID),'',20,14,WM3_cPATH_FLAGS)." ".wm3Statistic::getCountryName($w3,$row->birth_countryID);
	   array_push($_CONTENTS,$label,$other."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$i,$_WIDTHS,$_CONTENTS,false,array(1,$columns-1));
      }

     // Create list bottom
     $bottom_content = "";
     //if($total_items > $max_page_items)
      {
       if($bottom) $bottom_content = "<a href=\"$link&pageID=$pageID\">< ".$w3->getWord(923)."</a>";
       //else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_FAQ.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkUserPasswordError($w3,$userID,$admin = true)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray());
	 if($admin) // Errors for an admin that change a password for an user
	  {
       if($_FIELD['password'] != $_FIELD['retype_password']) return 1;
	  }
	 else
	  {
	   if(md5($_FIELD['old_password']) != wm3User::getUserPassword(wm3User::getUserLogin($userID))) return 1;
	   if(!$_FIELD['password']) return 2;
	   if($_FIELD['password'] != $_FIELD['retype_password']) return 3;
      }
     return 0;
    }

   public static function editUserInformationPassword($w3,$error = 0,$admin = true)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
	   if($admin) $userID = $w3->getAuthenticateAdminID();
	   else       $userID = $w3->getAuthenticateUserID();
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '$userID'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserPasswordFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getUserPasswordFieldsArray());

     switch($error)
      {
       case 1: // Old password invalid
        {
         $_STYLE['old_password'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']    = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376);
         break;
        }
       case 2: // Empty password
        {
         $_STYLE['password']  = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(122);
         break;
        }
       case 3: // Password do not match
        {
         $_STYLE['password']        = WM3_cSKIN_ERROR;
         $_STYLE['retype_password'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(122);
         break;
        }		
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Change password..."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_PASSWORD_USER;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_user_information_password_form.inc");
     return $content;
    }

   public static function updateUserInformationPassword($w3,$userID)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET password = '".md5($_FIELD['password'])."'
                       WHERE userID = '".$userID."'");
     return $userID;
    }

   public static function editUserInformation($w3,$error = 0,$admin = true)
    {
     // Take variables value from db and set correct form style
	 if($admin) $userID = $w3->getAuthenticateAdminID();
	 else       $userID = $w3->getAuthenticateUserID();
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     $row = mysql_fetch_object($rs);
	 if(!$row) return wm3Section::makeNotFoundItem($w3);
     if(!$error) $_FIELD = webmatic3::getRowValueArray(wm3User::getUserFieldsArray(),$row);
     else        $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getUserFieldsArray());

     switch($error)
      {
       case 1: // Invalid name
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid name";
         break;
        }
       case 2: // Invalid surname
        {
         $_STYLE['surname']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid surname";
         break;
        }



       case 2: // Invalid surname
        {
         $_STYLE['surname']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid surname";
         break;
        }

       case 5: // Invalid address
        {
         $_STYLE['address']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid address";
         break;
        }
       case 7: // Invalid city
        {
         $_STYLE['city']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid city";
         break;
        }
       case 8: // Invalid phone
        {
         $_STYLE['phone']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid phone";
         break;
        }
       case 9: // Invalid fax
        {
         $_STYLE['fax']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid fax";
         break;
        }
       case 10: // Invalid cell
        {
         $_STYLE['cell']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid cell";
         break;
        }
       case 11: // Invalid website url
        {
         $_STYLE['website']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid website url";
         break;
        }
       case 12: // Invalid icq number
        {
         $_STYLE['icq']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid icq number";
         break;
        }
       case 14: // Invalid birth city
        {
         $_STYLE['birth_city'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid birth city";
         break;
        }
       case 3: // Invalid email
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }
       case 4: // Email exists
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." Already exists \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }		
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit user..."; //$w3->getWord(29);
       	}
      }

	 if($row->superuser == WM3_cENABLED) $_EXTRA['groupID'] = wm3Section::makeFormItem($w3,$_STYLE['groupID'],$w3->getWord(1249),wm3User::selectGroup($w3,'groupID',$_FIELD['groupID']));
     else                                $_EXTRA['groupID'] = "";
     $preview_image     = $_FIELD['avatar'];
     $next_action       = WM3_cACTION_UPDATE_USER;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_user_information_form.inc");
     return $content;
    }

   public static function updateUserInformation($w3,$admin = true)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
	 if($admin) $userID = $w3->getAuthenticateAdminID();
	 else       $userID = $w3->getAuthenticateUserID();	 
	 if(wm3User::isSuperUser($userID)) $_EXTRA['groupID'] = "groupID = '".$_FIELD['groupID']."',";
	 else                              $_EXTRA['groupID'] = "";
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET   name            = '".$_FIELD['name']."',
                             surname         = '".$_FIELD['surname']."',
                             address         = '".$_FIELD['address']."',
                             zip_code        = '".$_FIELD['zip_code']."',
                             city            = '".$_FIELD['city']."',
                             stateID         = '".$_FIELD['stateID']."',
                             countryID       = '".$_FIELD['countryID']."',
                             phone           = '".$_FIELD['phone']."',
                             fax             = '".$_FIELD['fax']."',
                             cell            = '".$_FIELD['cell']."',
                             icq             = '".$_FIELD['icq']."',
                             email           = '".$_FIELD['email']."',
						     ".$_EXTRA['groupID']."
                             website         = '".$_FIELD['website']."',
                             birth_date      = '".$_FIELD['birth_date']."',
                             birth_date      = '".$_FIELD['birth_date']."',
                             birth_city      = '".$_FIELD['birth_city']."',
                             birth_stateID   = '".$_FIELD['birth_stateID']."',
                             birth_countryID = '".$_FIELD['birth_countryID']."',
                             gender          = '".$_FIELD['gender']."',
                             avatar          = '".$_FIELD['avatar']."'
                       WHERE userID          = '$userID'");
     return $userID;
    }

   public static function getUserList($w3,$currentID = 0,$admin = true)
    {
     // Get users list

     // Prepare variables to create the list
     $max_page_items = 12;
	 $columns = 7; $buttons = 4;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE login LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY userID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'userID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_user_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1022));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(25,40,35,0),array(1240,1407,900),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&userID=$row->userID";
	   $admin_pic = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if($row->admin)     $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if($row->superuser) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	   $last_user_login  = wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($row->userID),$w3->getAdminLanguage(),false,"Never logged")." (user)";
	   $last_admin_login = wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($row->userID),$w3->getAdminLanguage(),false,"Never logged")." (administrator)";
       array_push($_CONTENTS,"$admin_pic <a href=\"mailto:$row->email\">$row->login</a>");
       array_push($_CONTENTS,"$row->name $row->surname");
       array_push($_CONTENTS,"$last_user_login<br>$last_admin_login");
       array_push($_WIDTHS,25,40,35);
       // Buttons
	   if(!$row->superuser)
	    {
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_USER,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_USER,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178)));
		 array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_PASSWORD_USER,"action_password.png",$w3->getWord(-1)."Change password"));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_USER,"action_delete.png",$w3->getWord(179),$w3->getWord(696)));
		}
	   else array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_disable_inactive.png\"",
	                              "<img src=\"".WM3_cPATH_DATA."action_edit_inactive.png\"",
								  "<img src=\"".WM3_cPATH_DATA."action_password_inactive.png\"",
								  "<img src=\"".WM3_cPATH_DATA."action_delete_inactive.png\"");
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->userID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);


     return $str;
    }

   public static function getGroupList($w3,$currentID = 0,$admin = true)
    {
     // Get groups list
     $columns = 6; $buttons = 3;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_groups
                        ORDER BY groupID";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord(1249));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(25,45,30,0),array(1240,227,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link."&groupID=$row->groupID";
       if($row->groupID == '1') $label_default = "(".$w3->getWord(647).")"; else $label_default = "";
       array_push($_CONTENTS,$row->name);
       array_push($_CONTENTS,$row->description);
       array_push($_CONTENTS,wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage(),false)." $label_default");
       array_push($_WIDTHS,25,45,30);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_GROUP,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_GROUP,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_GROUP,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_GROUP,"action_delete.png",$w3->getWord(179),$w3->getWord(1253)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->groupID==$currentID);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function checkUserRegistrationError($w3)
    {
     // Check form invalid inputs for user registration page (home side)
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());

	 if(!wm3Util::isLogin($_FIELD['login']))                       return 1;
	 if(wm3User::loginExists($w3,$_FIELD['login']))                return 2;
	 if(!$_FIELD['password'])                                      return 3;
	 if($_FIELD['password'] != $_FIELD['retype_password'])         return 4;
	 if(!wm3Util::isAlphanumeric($_FIELD['name'],1))               return 5;
	 if(!wm3Util::isAlphanumeric($_FIELD['surname'],1))            return 6;
	 if(!wm3Util::isAlphanumeric($_FIELD['address']))              return 7;
	 //TODO zip code
	 if(!wm3Util::isAlphanumeric($_FIELD['city']))                 return 9;
	 if(!wm3Util::isAlphanumeric($_FIELD['phone']))                return 10;
	 if(!wm3Util::isAlphanumeric($_FIELD['fax']))                  return 11;
	 if(!wm3Util::isAlphanumeric($_FIELD['cell']))                 return 12;
     if(!wm3Util::isEmail($_FIELD['email']))                       return 13;
	 if(wm3User::emailExists($w3,$_FIELD['email'],0))              return 14;
     if($_FIELD['website'] && !wm3Util::isURL($_FIELD['website'])) return 15;
     if(!wm3Util::isAlphanumeric($_FIELD['icq']))                  return 16;
     //TODO birth date
     if(!wm3Util::isAlphanumeric($_FIELD['birth_city']))           return 18;
	 if(wm3Captcha::canUseCaptcha())
	  if(!wm3Captcha::testPassedCaptcha($w3))                      return 19;
     return 0;
    }

   public static function addUserRegistration($w3,$error = 0)
    {
     // Take variables value and set correct form style for user registration page (home side)
     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getUserFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
     $_STYLE['captcha'] = 0;
     switch($error)
      {
       case 1: // Empty login
        {
         $_STYLE['login']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(123);
         break;
        }
       case 2: // Login exists
        {
         $_STYLE['login']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." Login already exists \"".$_FIELD['login']."\"".$w3->getWord(444);
         break;
        }
       case 3: // Empty password
        {
         $_STYLE['password']  = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(119);
         break;
        }
       case 4: // Password do not match
        {
         $_STYLE['password']        = WM3_cSKIN_ERROR;
		 $_STYLE['retype_password'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(122);
         break;
        }
       case 5: // Invalid name
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid name";
         break;
        }
       case 6: // Invalid surname
        {
         $_STYLE['surname']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid surname";
         break;
        }
       case 7: // Invalid address
        {
         $_STYLE['address']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid address";
         break;
        }
       case 9: // Invalid city
        {
         $_STYLE['city']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid city";
         break;
        }
       case 10: // Invalid phone
        {
         $_STYLE['phone']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid phone";
         break;
        }
       case 11: // Invalid fax
        {
         $_STYLE['fax']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid fax";
         break;
        }
       case 12: // Invalid cell
        {
         $_STYLE['cell']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid cell";
         break;
        }
       case 13: // Invalid email
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }
       case 14: // Email exists
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." Already exists \"".$_FIELD['email']."\"".$w3->getWord(444);
         break;
        }
       case 15: // Invalid website url
        {
         $_STYLE['website']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid website url";
         break;
        }
       case 16: // Invalid icq
        {
         $_STYLE['icq']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid icq number";
         break;
        }
       case 18: // Invalid birth city
        {
         $_STYLE['birth_city'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid birth city";
         break;
        }
       case 19: // Captcha check fails
        {
         $_STYLE['captcha']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Bad captcha";//$w3->getWord(444);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(121);
       	}
      }
     $_FIELD['pageID'] = $w3->getVariable('pageID','both'); // Take pageID from both
     $preview_image = $_FIELD['avatar']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_AVATARS); // Set due preview image
     $next_action       = WM3_cACTION_SAVE_USER_REGISTRATION; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."home_user_form.inc");
     return $home_content;
    }

   public static function saveUserRegistration($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));    	

       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['groupID'] = $w3->getPreferences('user_groupID');
       $_FIELD['f1'] = $w3->getPreferences('user_flag1');
       $_FIELD['f2'] = $w3->getPreferences('user_flag2');
       $_FIELD['f3'] = $w3->getPreferences('user_flag3');
       $_FIELD['f4'] = $w3->getPreferences('user_flag4');
       $_FIELD['f5'] = $w3->getPreferences('user_flag5');
       $_FIELD['f6'] = $w3->getPreferences('user_flag6');
       $_FIELD['f7'] = $w3->getPreferences('user_flag7');
       $_FIELD['f8'] = $w3->getPreferences('user_flag8');
       for($i = 1; $i <= 40; $i++) $_FIELD['af'.$i] = 0;
	   $_FIELD['special'] = $w3->getPreferences('user_special');
       $_FIELD['enabled'] = $w3->getPreferences('user_enabled');
       $_FIELD['deleted'] = $_FIELD['admin'] = $_FIELD['superuser'] = 0;
	   $_FIELD['password'] = md5($_FIELD['password']);
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_users',$_FIELD,array('retype_password'));
      }
     return wm3Sql::getLastInsertID();
    }

   public static function completeUserRegistration($w3,$lastID)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($lastID)
      {
       $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);

       $sender     = $w3->getPreferences('service_email');
       $subject    = $w3->getPreferencesContents('user_registration_email_subject');
       $email_body = "Registration to ".$w3->getPreferences('site_address')." successfully completed.\n\nThese are your registration data:\n\n- Login: ".$_FIELD['login']."\n- Password: ".wm3Util::renderContent($w3,$_FIELD['password'],WM3_cRENDER_MODE_PLAIN_TEXT)."\n\n".$w3->getPreferencesContents('user_registration_email_text');
       $to         = $_FIELD['email'];
       $sended     = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
	   $home_content = "Registration successfully completed.<br>These are your registration data:<br><br>- Login: <b>".$_FIELD['login']."</b><br>- Password: <b>".wm3Util::renderContent($w3,$_FIELD['password'],WM3_cRENDER_MODE_PLAIN_TEXT)."</b>";
	   if($sended) {
                    $home_content .= "<br><br>An email with your registration data sended to <b>".$_FIELD['email']."</b>";
                    $home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">Return to homepage</a>";
		           }
	   else        {
			        $home_content .= "<br><br>Email send error. Your registration data was not sended to your address <b>\"".$_FIELD['email']."\"</b> but registration its complete.";
					$home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">Return to homepage</a>";
		           }
      }
     else
      {
       $home_content = "Errore di registrazione.";//TODO o cosa??? (già registrato)
      }
     return $home_content;
    }

   public static function checkUserError($w3,$userID,$admin = false)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
     if($w3->getAction() == WM3_cACTION_SAVE_USER) // Admin create a new user
	  {
	   if(!wm3Util::isLogin($_FIELD['login']))                       return 1;
	   if(wm3User::loginExists($w3,$_FIELD['login']))                return 2;
	   if(!$_FIELD['password'])                                      return 3;
	   if($_FIELD['password'] != $_FIELD['retype_password'])         return 4;
	   if(!$_FIELD['name'])                                          return 5;
	   if(!$_FIELD['surname'])                                       return 6;
       if(!wm3Util::isEmail($_FIELD['email']))                       return 7;
	   if(wm3User::emailExists($w3,$_FIELD['email'],$userID))        return 8;
       if($_FIELD['website'] && !wm3Util::isURL($_FIELD['website'])) return 9;
      }
	 else // Admin modify an existing user or an admin/user update own informations
	  {
	   if($admin) // Admin edit an existing user or admin update own informations
	    {
	     if(!$_FIELD['name'])                                          return 1;
	     if(!$_FIELD['surname'])                                       return 2;
         if(!wm3Util::isEmail($_FIELD['email']))                       return 3;
	     if(wm3User::emailExists($w3,$_FIELD['email'],$userID))        return 4;
         if($_FIELD['website'] && !wm3Util::isURL($_FIELD['website'])) return 11;
	    }
	   else // User update own informations
	    {
	     if(!wm3Util::isAlphanumeric($_FIELD['name'],1))               return 1;
	     if(!wm3Util::isAlphanumeric($_FIELD['surname'],1))            return 2;
         if(!wm3Util::isAlphanumeric($_FIELD['address']))              return 5;
         //TODO zip code
	     if(!wm3Util::isAlphanumeric($_FIELD['city']))                 return 7;
	     if(!wm3Util::isAlphanumeric($_FIELD['phone']))                return 8;
	     if(!wm3Util::isAlphanumeric($_FIELD['fax']))                  return 9;
	     if(!wm3Util::isAlphanumeric($_FIELD['cell']))                 return 10;
         //TODO birth date
         if(!wm3Util::isAlphanumeric($_FIELD['birth_city']))           return 14;
         if(!wm3Util::isEmail($_FIELD['email']))                       return 3;
	     if(wm3User::emailExists($w3,$_FIELD['email'],$userID))        return 4;
         if($_FIELD['website'] && !wm3Util::isURL($_FIELD['website'])) return 11;
         if(!wm3Util::isAlphanumeric($_FIELD['icq']))                  return 12;
		}
	  }
     return 0;
    }

   public static function addUser($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getUserFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());
     switch($error)
      {
       case 1: // Empty login
        {
         $_STYLE['login']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(123);
         break;
        }
       case 2: // Login exists
        {
         $_STYLE['login']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." Login already exists \"".$_FIELD['login']."\"".$w3->getWord(444);
         break;
        }
       case 3: // Empty password
        {
         $_STYLE['password']  = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(119);
         break;
        }
       case 4: // Password do not match
        {
         $_STYLE['password']        = WM3_cSKIN_ERROR;
		 $_STYLE['retype_password'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(122);
         break;
        }
       case 5: // Empty name
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Empty name";
         break;
        }
       case 6: // Empty surname
        {
         $_STYLE['surname']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Empty surname";
         break;
        }
       case 7: // Invalid email
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }
       case 8: // Email exists
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." Already exists \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }
       case 9: // Invalid website url
        {
         $_STYLE['website']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid website url";
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(121);
       	}
      }
	 $_FIELD['password'] = $_FIELD['retype_password'] = '';
     $_EXTRA['login']           = wm3Section::makeFormItem($w3,$_STYLE['login'],$w3->getWord(255),wm3Util::inputText('login',$_FIELD['login'],30),10);
     $_EXTRA['password']        = wm3Section::makeFormItem($w3,$_STYLE['password'],$w3->getWord(256),wm3Util::inputPassword('password',$_FIELD['password'],30),10);
     $_EXTRA['retype_password'] = wm3Section::makeFormItem($w3,$_STYLE['retype_password'],$w3->getWord(257),wm3Util::inputPassword('retype_password',$_FIELD['retype_password'],30),10);
     $_DATA = wm3User::getSectionAdminDataArray($w3);
     $preview_image = $_FIELD['avatar']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_AVATARS); // Set due preview image
     $next_action       = WM3_cACTION_SAVE_USER; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_user_form.inc");
     return $content;
    }

   public static function editUser($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '".$w3->getVariable('userID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getUserFieldsArray());

     switch($error)
      {
       case 1: // Empty name
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Empty name";
         break;
        }
       case 2: // Empty surname
        {
         $_STYLE['surname']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Empty surname";
         break;
        }
       case 11: // Invalid website url
        {
         $_STYLE['website']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Invalid website url";
         break;
        }
       case 3: // Invalid email
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }
       case 4: // Email exists
        {
         $_STYLE['email']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." Already exists \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
         break;
        }		
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit user..."; //$w3->getWord(29);
       	}
      }
     $_EXTRA['login'] = wm3Section::makeFormItem($w3,$_STYLE['login'],$w3->getWord(255),"<b>".wm3User::getUserLogin($_FIELD['userID'])."</b>",10);
     $_EXTRA['password'] = $_EXTRA['retype_password'] = '';
     $_DATA = wm3User::getSectionAdminDataArray($w3);	  
     $preview_image = $_FIELD['avatar'];
     $next_action       = WM3_cACTION_UPDATE_USER;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_user_form.inc");
     return $content;
    }

   public static function saveUser($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['password'] = md5($_FIELD['password']);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_users',$_FIELD,array('retype_password'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateUser($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET groupID         = '".$_FIELD['groupID']."',
                           name            = '".$_FIELD['name']."',
                           surname         = '".$_FIELD['surname']."',
                           address         = '".$_FIELD['address']."',
                           zip_code        = '".$_FIELD['zip_code']."',
                           city            = '".$_FIELD['city']."',
                           stateID         = '".$_FIELD['stateID']."',
                           countryID       = '".$_FIELD['countryID']."',
                           phone           = '".$_FIELD['phone']."',
                           fax             = '".$_FIELD['fax']."',
                           cell            = '".$_FIELD['cell']."',
                           icq             = '".$_FIELD['icq']."',
                           email           = '".$_FIELD['email']."',
                           website         = '".$_FIELD['website']."',
                           birth_date      = '".$_FIELD['birth_date']."',
                           birth_date      = '".$_FIELD['birth_date']."',
                           birth_city      = '".$_FIELD['birth_city']."',
                           birth_stateID   = '".$_FIELD['birth_stateID']."',
                           birth_countryID = '".$_FIELD['birth_countryID']."',
                           gender          = '".$_FIELD['gender']."',
                           avatar          = '".$_FIELD['avatar']."',
                           special         = '".$_FIELD['special']."',
                           enabled         = '".$_FIELD['enabled']."',
                           visible         = '".$_FIELD['visible']."',
                           deleted         = '".$_FIELD['deleted']."',
                           admin           = '".$_FIELD['admin']."',
                           f1              = '".$_FIELD['f1']."',
                           f2              = '".$_FIELD['f2']."',
                           f3              = '".$_FIELD['f3']."',
                           f4              = '".$_FIELD['f4']."',
                           f5              = '".$_FIELD['f5']."',
                           f6              = '".$_FIELD['f6']."',
                           f7              = '".$_FIELD['f7']."',
                           f8              = '".$_FIELD['f8']."',
                           af1             = '".$_FIELD['af1']."',
                           af2             = '".$_FIELD['af2']."',
                           af3             = '".$_FIELD['af3']."',
                           af4             = '".$_FIELD['af4']."',
                           af5             = '".$_FIELD['af5']."',
                           af6             = '".$_FIELD['af6']."',
                           af7             = '".$_FIELD['af7']."',
                           af8             = '".$_FIELD['af8']."',
                           af9             = '".$_FIELD['af9']."',
                           af10            = '".$_FIELD['af10']."',
                           af11            = '".$_FIELD['af11']."',
                           af12            = '".$_FIELD['af12']."',
                           af13            = '".$_FIELD['af13']."',
                           af14            = '".$_FIELD['af14']."',
                           af15            = '".$_FIELD['af15']."',
                           af16            = '".$_FIELD['af16']."',
                           af17            = '".$_FIELD['af17']."',
                           af18            = '".$_FIELD['af18']."',
                           af19            = '".$_FIELD['af19']."',
                           af20            = '".$_FIELD['af20']."',
                           af21            = '".$_FIELD['af21']."',
                           af22            = '".$_FIELD['af22']."',
                           af23            = '".$_FIELD['af23']."',
                           af24            = '".$_FIELD['af24']."',
                           af25            = '".$_FIELD['af25']."',
                           af26            = '".$_FIELD['af26']."',
                           af27            = '".$_FIELD['af27']."',
                           af28            = '".$_FIELD['af28']."',
                           af29            = '".$_FIELD['af29']."',
                           af30            = '".$_FIELD['af30']."',
                           af31            = '".$_FIELD['af31']."',
                           af32            = '".$_FIELD['af32']."',
                           af33            = '".$_FIELD['af33']."',
                           af34            = '".$_FIELD['af34']."',
                           af35            = '".$_FIELD['af35']."',
                           af36            = '".$_FIELD['af36']."',
                           af37            = '".$_FIELD['af37']."',
                           af38            = '".$_FIELD['af38']."',
                           af39            = '".$_FIELD['af39']."',
                           af40            = '".$_FIELD['af40']."',
                           notes           = '".$_FIELD['notes']."'
                       WHERE userID        = '".$_FIELD['userID']."'");
     return $_FIELD['userID'];
    }

   public static function editUserPassword($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '".$w3->getVariable('userID','both')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getUserPasswordFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getUserPasswordFieldsArray());

     switch($error)
      {
       case 1: // Password do not match
        {
		 $_FIELD['userID'] = $w3->getVariable('userID','both'); // Take userID from both (TODO aggiustare meglio)
         $_STYLE['old_password']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376);
         break;
        }
       default:
        {
		 // Default values for the form
         $_FIELD['userID']     = $w3->getVariable('userID','both'); // Take userID from both
		 $_FIELD['send_email'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Change password..."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_PASSWORD_USER;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_user_password_form.inc");
     return $content;
    }

   public static function updateUserPassword($w3,$userID)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserPasswordFieldsArray(),WM3_cQUOTE_DB);
	 if(wm3User::isSuperUser($userID)) return 0;
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                       SET password = '".md5($_FIELD['password'])."'
                       WHERE userID = '".$userID."'");
     return $userID;
    }

   public static function disableUser($userID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET enabled = '".WM3_cDISABLED."' WHERE userID = '$userID'"); }

   public static function enableUser($userID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET enabled = '".WM3_cENABLED."'  WHERE userID = '$userID'"); }

//   public static function deleteUser($pageID)  { wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'"); }

   public static function checkGroupError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray());
     if(!$_FIELD['name']) return 1;
     return 0;
    }

   public static function addGroup($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getGroupFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray());
     switch($error)
      {
       case 1: // No name
        {
         $_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(118);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1246);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_GROUP; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_group_form.inc");
     return $content;
    }

   public static function editGroup($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_groups
                               WHERE groupID = '".$w3->getVariable('groupID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3User::getGroupFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3User::getGroupFieldsArray());

     switch($error)
      {
       case 1: // No name
        {
         $_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(118);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit group..."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_GROUP;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_group_form.inc");
     return $content;
    }

   public static function saveGroup($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_groups',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateGroup($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getGroupFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_groups
                       SET name        = '".$_FIELD['name']."',
                           description = '".$_FIELD['description']."',
                           enabled     = '".$_FIELD['enabled']."'
                       WHERE groupID   = '".$_FIELD['groupID']."'");
     return $_FIELD['groupID'];
    }

   public static function deleteGroup($groupID)
    {
     if($groupID != 1) // Default group (with groupID = 1) can not be deleted TODO fare come campo default in database???
      {
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_groups WHERE groupID = '$groupID'");
       // Update also all the tables that have groupID as field
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages set groupID = '1' WHERE groupID = '$groupID'");
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users set groupID = '1' WHERE groupID = '$groupID'");
      }
    }

   public static function writeSuperUser($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3User::getUserFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::sqlQuery("INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_users
                       VALUES ('',
                               '1',
							   '0','0','0','0',
                               '".$_FIELD['login']."',
                               '".md5($_FIELD['password'])."',
                               '".$_FIELD['name']."',
                               '".$_FIELD['surname']."',
                               '','','','0','0','','',
                               '".$_FIELD['email']."',
                               '','0','','M','tux.png',
                               '1','1','0','0','1','1',
                               '1','1','1','1','1','1','1','1',
                               '0','0',
                               '1','1','1','1','1','1','1','1','1','1',
                               '1','1','1','1','1','1','1','1','1','1',
                               '1','1','1','1','1','1','1','1','1','1',
                               '1','1','1','1','1','1','1','1','1','1',
                               '0','0','','".WM3_cLANGUAGE_ALL."','".$_FIELD['ts']."')");
     return wm3Sql::getLastInsertID();
    }

   public static function existSuperUser()
    {
     // Return true if exist the super user (user with superuser = 1)
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE superuser = '1'");
     if(mysql_num_rows($rs) == 1) return true; else return false;
    } 

   public static function existUser($userID)
    {
     // Return true if exist the user with userID
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) == 1) return true; else return false;
    }

   public static function checkUserPermission($w3,$fl)
    {
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '".$w3->getAuthenticateUserID()."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."'");
     if(mysql_num_rows($rs) != 1) return false;
     $row = mysql_fetch_object($rs);
     $field = "f$fl";
     if($row->$field) return true; else return false;
    }

   public static function checkAdminPermission($w3,$fl)
    {
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '".$w3->getAuthenticateAdminID()."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."' AND admin = '".WM3_cENABLED."'");
     if(mysql_num_rows($rs) != 1) return false;
     $row = mysql_fetch_object($rs);
     $field = "af$fl";
     if($row->$field) return true; else return false;
    }

   public static function selectState($name,$stateID,$w3)
    {
     // Make country select
     $rs = wm3Sql::sqlQuery("SELECT ".WM3_cCONFIG_DB_PREFIX."_states.*, ".WM3_cCONFIG_DB_PREFIX."_countries.name AS country_name
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_states, ".WM3_cCONFIG_DB_PREFIX."_countries
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_states.countryID = ".WM3_cCONFIG_DB_PREFIX."_countries.countryID
                             ORDER BY countryID, ".WM3_cCONFIG_DB_PREFIX."_countries.name, ".WM3_cCONFIG_DB_PREFIX."_states.name");

     $str = "<select name=\"$name\">";
     $str .= wm3Util::inputOption($w3->getWord(913),'0');
     while($row = mysql_fetch_object($rs))
      {
       if($row->stateID == $stateID) $str .= wm3Util::inputOption($row->name." ($row->country_name)",$row->stateID,"selected");
       else                          $str .= wm3Util::inputOption($row->name." ($row->country_name)",$row->stateID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectCountry($name,$countryID,$w3)
    {
     // Make country select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_countries
                             ORDER BY name");
     $str = "<select name=\"$name\">";
     $str .= wm3Util::inputOption($w3->getWord(914),'0');
     while($row = mysql_fetch_object($rs))
      {
       if($row->countryID == $countryID) $str .= wm3Util::inputOption($row->name,$row->countryID,"selected");
       else                              $str .= wm3Util::inputOption($row->name,$row->countryID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectUser($name,$userID)
    {
     // Make users select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users ORDER BY superuser DESC, login");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->userID == $userID) $str .= wm3Util::inputOption($row->login,$row->userID,"selected");
       else                        $str .= wm3Util::inputOption($row->login,$row->userID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectGroup($w3,$name,$groupID,$any = false,$any_label = '')
    {
     // Make user groups select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_groups");
     $str = "<select name=\"$name\">";
	 if($any) $str .= wm3Util::inputOption($w3->getWord($any_label),0);
     while($row = mysql_fetch_object($rs))
      {
       if($row->groupID == $groupID) $str .= wm3Util::inputOption($row->name,$row->groupID,"selected");
       else                          $str .= wm3Util::inputOption($row->name,$row->groupID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function getGroupName($groupID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_groups
                             WHERE groupID = '$groupID'");
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function getGroupID($userID)
    {
	 // Return the groupID from userID
     $rs = wm3Sql::sqlQuery("SELECT groupID FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) != 1) return 0; // No groupID found
     $row = mysql_fetch_object($rs);
     return $row->groupID;
    }

   public function setName($name) { $this->name = $name; }
    
   public function getName() { return $this->name; }
   
   public static function getAvatar($userID)
    {
     $rs = wm3Sql::sqlQuery("SELECT avatar FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     if(mysql_num_rows($rs) != 1) return WM3_cPATH_DATA."misc_anonymous.png";
     $row = mysql_fetch_object($rs);
     return WM3_cPATH_AVATARS.$row->avatar;
    }
 
   public static function renderUserLogin($w3)
    {
     // Render login panel in home page
     $columns = 2; $buttons = 0;
     $link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER;

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Create login panel
     if(!$w3->getAuthenticateUserID()) // No user logged (TODO farlo piu' sicuro con query che controlla $w3->getAuthenticateUserID() == $row->userID ???)
      {
       $label_login    = $w3->getWord(1240);
       $label_password = $w3->getWord(1461);
       $label_email    = $w3->getWord(221);
       $login    = wm3Util::inputText('user_login','',14);
       $password = wm3Util::inputPassword('user_password','',14);
       $email    = wm3Util::inputText('email','',16);
       $button_login = "<div align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$w3->getWord(1240)."\"></div>";
       $button_email = "<div align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$w3->getWord(829)."\"></div>";      	
       $str .= "<form name=\"wm3_form\" method=\"post\" action=\"$link\">";
       $str .= wm3Section::makeItemList($w3,0,array(0,100),array($label_login,$login),false);
       $str .= wm3Section::makeItemList($w3,1,array(0,100),array($label_password,$password),false);
       $str .= wm3Section::makeItemList($w3,0,array(100),array($button_login),false,array(2));
	   $str .= "</form>";
	   $link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME;
	   $str .= "<form name=\"wm3_form\" method=\"post\" action=\"$link&action=".WM3_cACTION_RETRIEVE_PASSWORD."\">";
       $str .= wm3Section::makeItemList($w3,0,array(100),array("<br>".$w3->getWord(826)),false,array(2));
       $str .= wm3Section::makeItemList($w3,1,array(0,100),array($label_email,$email),false);
       $str .= wm3Section::makeItemList($w3,0,array(100),array($button_email),false,array(2));
	   $str .= "</form>";
      }
     else // User logged
      {
       $user_name = $w3->getWord(574)." <b>".wm3User::getUserLogin($w3->getAuthenticateUserID())."</b>";
       $user_link = "<a href=\"$link\">".$w3->getWord(575)."</a> ".$w3->getWord(576)." <a href=\"$link&action=".WM3_cACTION_LOGOUT."\">logout</a>.";
       $messages  = "<img src=\"".WM3_cPATH_DATA."misc_message.png\" width=\"15\" height=\"10\" border=\"0\"> You have <a href=\"$link\"> 0 ".$w3->getWord(890)."</a>";
       $str .= wm3Section::makeItemList($w3,0,array(100),array($user_name),false,array(2));
       $str .= wm3Section::makeItemList($w3,0,array(100),array($user_link),false,array(2));
       $str .= wm3Section::makeItemList($w3,0,array(100),array($messages),false,array(2));
      }

     // Total visitors/users logged
	 if($w3->getPreferences('show_online_users_visitors'))
	  {
       $total_visitors = "<br>".$w3->getWord(811)." ".wm3Session::getOnlineVisitors();
       $visitor_icon   = "<br>".wm3Util::renderImg('misc_visitor.png');
       $total_users    = $w3->getWord(812)." ".wm3Session::getOnlineUsers();
	   $user_icon      = wm3Util::renderImg('misc_user.png');
       $str .= wm3Section::makeItemList($w3,0,array(0,100),array($visitor_icon,$total_visitors),false);
       $str .= wm3Section::makeItemList($w3,0,array(0,100),array($user_icon,$total_users),false);
     
       if($w3->getAuthenticateAdminUserID()) // Users logged list (showed only if an user or administrator (TODO) its logged)
        {
         $label = $w3->getWord(813);
         $str .= wm3Section::makeItemList($w3,0,array(100),array($label),false,array(2));
	     $str .= wm3User::renderUserOnlineList($w3);
        }
	  }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str; 
    }
 
   public static function renderUserBirthday($w3)
    {
     // Render birthday panel in home page
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Do the query and take the total items number
     $ts = time();
     $birth_date = date("-m-d",$ts);
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                        WHERE birth_date LIKE '%$birth_date' AND visible = '".WM3_cENABLED."' AND deleted = '".WM3_cDISABLED."'
                        ORDER BY userID";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Create list caption
     //if($admin) $str .= wm3Section::makeCaptionList($w3,array(25,45,30,0),array(1240,1409,1409),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,1633);
     $str = $w3->getWord(1634)."<br><br>".$str;

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link."&userID=$row->userID";
       $age  = date("Y",$ts) - substr($row->birth_date,0,4);
       $cake = wm3Util::renderImg("misc_birthday.png");
       $name = "<a href=\"xxx\">$row->login</a> ($age ".$w3->getWord(1635).")";
       array_push($_CONTENTS,$cake,$name);
       array_push($_WIDTHS,0,100);
       // Buttons
       /*if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_USER,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_USER,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_USER,"action_delete.png",$w3->getWord(179),$w3->getWord(696)));*/
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }
     
     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function emailExists($w3,$email,$userID = 0)
    {
	 // Check if an email its already in the database
	 if($w3->getAction() == WM3_cACTION_UPDATE_USER)
	  {
	   if(!$userID) $userID = $w3->getVariable('userID','both');
	   $rs = wm3Sql::sqlQuery("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '$userID'");
       $row = mysql_fetch_object($rs);
  	   if($row) $old_email = $row->email; else $old_email = "";
	   if($old_email == $email) return false;
	  }
     $rs = wm3Sql::sqlQuery("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE email = '$email'");
     if(mysql_num_rows($rs) == 0) return false;
	 return true;
	}

   public static function loginExists($w3,$login)
    {
	 // Check if a login its already in the database
     $rs = wm3Sql::sqlQuery("SELECT login FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE login = '$login'");
     if(mysql_num_rows($rs) == 0) return false;
	 return true;
	}

   public static function renderRank($w3,$userID)
    {
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE userID = '$userID'");
     $row = mysql_fetch_array($rs);
	 $value = $row['admin'] + $row['special'];
	 for($i = 1; $i <= 8; $i++) $value += $row['f'.$i];
	 $str = wm3Util::makeStars($w3,$value/2);
	 return $str;
    }

   public static function renderVitality($w3,$userID,$width = 130,$height = 8)
    {//TODO prendere commenti e forum post
     $rs = wm3Sql::sqlQuery("SELECT COUNT(*) AS tot_news FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE userID = '$userID'");
     $row = mysql_fetch_object($rs);
	 $value = $row->tot_news/2;
	 if($value > 100) $value = 100;
	 $str = wm3Util::makePercentageBar($w3,$value,$width,$height)." ($value%)";
	 return $str;
    }

   public static function renderUserOnlineList($w3)
    {
     // Render online user list
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_sessions WHERE userID != 0");
	 $str = ""; $p = 0;
     while($row = mysql_fetch_object($rs))
      {
   	   $admin_pic = wm3Util::renderImg('misc_user.png',$w3->getWord(-1).'Standard user');
       if(wm3User::isSuperUser($row->userID)) $admin_pic = wm3Util::renderImg('misc_admin.png',$w3->getWord(998));
       if(wm3User::isSuperUser($row->userID)) $admin_pic = wm3Util::renderImg('misc_superuser.png',$w3->getWord(-1).'Superuser');
	   $login = wm3Util::makeLink($w3,WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$row->userID",wm3User::getUserLogin($row->userID));
       $str .= wm3Section::makeItemList($w3,$p,array(0,100),array($admin_pic,$login),false);
	   $p++;
      }
     return $str;
    }

   public static function renderRetrievePassword($w3)
    {
	 // Change and retrieve a new password for an user from email (home side)
	 $email  = $w3->getVariable('email','post');
     $userID = wm3User::getUserIDFromEmail(wm3Util::quoteDB($email));
	 $login  = wm3User::getUserLogin($userID);
     if($userID) {
		          // Send the password by email
				  $password   = wm3Util::generatePassword();
	              $sender     = $w3->getPreferences('service_email');
                  $subject    = "Your new password";
                  $email_body = "<html><head></head><body>Your new password for <a href=\"http://".$w3->getPreferences('site_address')."\">".$w3->getPreferences('site_address')."</a> is <b>$password</b><br><br>Please login and change it soon!</body></html>";
				  $to         = $email;
                  $sended = @mail($to,$subject,$email_body,"From: $sender\nContent-Type: text/html; charset=\"iso-8859-1\"Content-Transfer-Encoding: quoted-printable\"\nX-Mailer: PHP/".phpversion());
				  if($sended) {
					           wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET password = '".md5($password)."' WHERE userID = '".$userID."'");
					           $str = "Password changed for user <b>$login</b>.<br>The new password was send to <b>$email</b>.<br><br>Please login and change this new password soon.";
						      }
				  else        {
					           $str = "Sending email error, email not sendend and password not changed!";
						      }
				 }
	 else        {
		          // Email not found
				  if(!wm3Util::isEmail($email)) $str = $w3->getWord(1151);
				  else                          $str = "<b>$email</b> ".$w3->getWord(828);
				 }
	 return $str;
	}

  }

?>
