<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Setup
  {

   function __construct() { }

   public static function configNeeded($w3,$setup_on = 1)
    {
     if(!$setup_on) return 0; // Setup disabled

	 if(wm3Setup::checkSystemConfig() &&
	    wm3Setup::configFileExist()   &&
		wm3Sql::existsDatabase()      &&
		!wm3Setup::needUpdate()       &&
        wm3User::existSuperUser())    return 0; // No setup needed

	 $action = webmatic3::getVariable('action','both');
	 if($action == WM3_cACTION_SETUP_CHANGE_LANGUAGE) wm3Setup::changeSetupLanguage($w3);
	 if(!wm3Setup::checkSystemConfig() || !$action) return WM3_cSECTION_NEED_CONFIG_SYSTEM;
     if(!wm3Setup::configFileExist())   return WM3_cSECTION_NEED_CONFIG_FILE;
     if(!wm3Sql::existsDatabase())      return WM3_cSECTION_NEED_DATABASE;
     if(wm3Setup::needUpdate())         return WM3_cSECTION_NEED_UPDATE;
     if(!wm3User::existSuperUser())     return WM3_cSECTION_NEED_USER;
     return 0;
    }

   public static function getSystemConfigError($array = false)
    {
	 if($array) $_ARRAY = array('php_version'         => 0,
	                            'root_folder_write'   => 0,
								'temp_folder_write'   => 0,
								'mysql'               => 0,
								'imap'                => 0,
								'gd'                  => 0,
								'upload_foders_write' => 0);
	 // Errors
	 $error = 0;
	 if(!(intval(phpversion()) >= 5))                  { $error = 1; if($array) $_ARRAY['php_version']       = 1; }
	 if(!wm3Util::isFolderWritable('.'))               { $error = 2; if($array) $_ARRAY['root_folder_write'] = 1; }
	 if(!wm3Util::isFolderWritable(WM3_cPATH_TEMP))    { $error = 3; if($array) $_ARRAY['temp_folder_write'] = 1; }
	 if(!extension_loaded('mysql'))                    { $error = 4; if($array) $_ARRAY['mysql']             = 1; }

	 // Warnings
	 if($array)
	  {
	   if(!extension_loaded('imap')) $_ARRAY['imap'] = 1;
	   if(!extension_loaded('gd'))   $_ARRAY['gd']   = 1;
	   if(!wm3Util::isFolderWritable(WM3_cPATH_IMAGES)      ||
	      !wm3Util::isFolderWritable(WM3_cPATH_ECOMMERCE)   ||
		  !wm3Util::isFolderWritable(WM3_cPATH_MEDIA_ALBUM) ||
		  !wm3Util::isFolderWritable(WM3_cPATH_DOWNLOADS)) $_ARRAY['upload_foders_write'] = 1;
	  }
	 if($array) return $_ARRAY; else return $error;
	}

   public static function checkSystemConfig()
    {
     if(wm3Setup::getSystemConfigError()) return 0;
     return 1;
    }

   public static function configFileExist()
    {
     if(file_exists('wm3_config.php')) require_once('wm3_config.php'); else return 0;
     if(!defined('WM3_cCONFIG_DB_SERVER'))     return 0;
     if(!defined('WM3_cCONFIG_DB_USER'))       return 0;
     if(!defined('WM3_cCONFIG_DB_PASSWORD'))   return 0;
     if(!defined('WM3_cCONFIG_DB_NAME'))       return 0;
     if(!defined('WM3_cCONFIG_DB_PREFIX'))     return 0;
     if(!wm3Sql::checkConnection(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME)) return 0;
	 if(!wm3Sql::checkDatabaseServerVersion(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD)) return 0;
     return 1;
    }

   public static function needUpdate()
    {
     if(wm3Sql::getDBVersion() < WM3_cDB_VERSION ) return true;
     else                                          return false;
    }

   public static function executeSetup($w3,$setup_ip)
    {
	 if($setup_ip != '*')
	  if(getenv('REMOTE_ADDR') != $setup_ip)
	   wm3Util::dieMessage("Setup error","You can not do the setup from your ip: <b>".getenv('REMOTE_ADDR')."</b>"); // Let the setup only from a user defined ip ($setup_ip)

     $title      = ":: Webmatic ".WM3_cVERSION." ".$w3->getWord(1728)." ::";
     $skin       = "default";
     $setup_css  = WM3_cPATH_SKINS."$skin/$skin.css";
	 $setup_home = " : <a href=\"index.php\">Home</a>";
     switch(wm3Setup::configNeeded($w3))
      {
       case WM3_cSECTION_NEED_CONFIG_SYSTEM:
        {
         $subtitle = $w3->getWord(1711).$setup_home;
         $icon     = wm3Util::renderImg("big_icon_preferences.png",'',48,48);
         $label    = $w3->getWord(1728);
         $content  = wm3Setup::configSystemForm($w3,$skin); // System configuration form
         break;
        }
       case WM3_cSECTION_NEED_CONFIG_FILE:
        {
         $subtitle = $w3->getWord(1729).$setup_home;
         $icon     = wm3Util::renderImg("big_icon_preferences.png",'',48,48);
         $label    = $w3->getWord(1728);
         $content  = wm3Setup::configFileForm($w3,$skin); // Config file form
         break;
        }
       case WM3_cSECTION_NEED_DATABASE:
        {
         if(!wm3Setup::lockSetup()) wm3Util::dieMessage("Setup error","Database Locked, can not do the setup, to continue please remove the file \"lock_setup\" from Webmatic root folder");
         wm3Setup::resetDatabase(); // Create the database
         wm3Setup::unlockSetup();
         header("Location: index.php?action=".WM3_cACTION_SETUP_NEXT);
         break;
        }
       case WM3_cSECTION_NEED_UPDATE:
        {
		 if(wm3Sql::getDBVersion() >= 2.8)
		  {
           if(!wm3Setup::lockSetup()) wm3Util::dieMessage("Setup error","Database Locked, can not do the setup, to continue please remove the file \"lock_setup\" from Webmatic root folder");
		   if(wm3Sql::getDBVersion() == 2.8) wm3Setup::updateDatabase28to30(); // Update the database
           wm3Setup::unlockSetup();
	      }
		 else
		  {
		   wm3Util::dieMessage("Setup error","Minimum Webmatic version 2.8, can not update"); // Setup not complete, can not continue
		   break;
		  }
         header("Location: index.php?action=".WM3_cACTION_SETUP_NEXT);
         break;
        }
       case WM3_cSECTION_NEED_USER:
        {
         $subtitle = $w3->getWord(1744).$setup_home;
         $icon     = wm3Util::renderImg("big_icon_users.png",'',48,48);
         $label    = $w3->getWord(1728);
         $content  = wm3Setup::configUserForm($w3,$skin); // Superuser form
         break;
        }
       default: header("Location: index.php");
      }

     require(WM3_cPATH_SKINS."$skin/setup/setup_head.inc");
     require(WM3_cPATH_SKINS."$skin/setup/setup_page.inc");
     require(WM3_cPATH_SKINS."$skin/setup/setup_foot.inc");
    }

   public static function changeSetupLanguage($w3)
    {
     // Switch to another setup language and set cookie
     wm3Language::writeCookieAdminLanguageID($_GET['languageID'],true);
     $w3->setAdminLanguage($_GET['languageID']);
	 $action = $w3->getVariable('stepID','get');
	 if($action == WM3_cACTION_SETUP_CHANGE_LANGUAGE) $action = 0;
	 header("Location: index.php?action=$action");
	 die();
    }

   public static function renderSetupLanguageMenu($w3,$skin)
    {
     // Create setup language menu

     // Menu start
     require(WM3_cPATH_SKINS."$skin/menu/admin_menu_start.inc");

     $_DATA  = array('en','it','fr','de','es','nl');
     $_LABEL = array('English','Italiano','Franais','Deutsch','Espaol','Nederlands');
	 // Menu items
	 $menu_item = "<nobr>".$w3->getWord(1710)." ";
     for($i = 0; $i < count($_DATA); $i++)
      {
       // Menu items
	   $stepID = $w3->getVariable('action','both');
       $menu_item .= wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&action=".WM3_cACTION_SETUP_CHANGE_LANGUAGE."&stepID=$stepID&languageID=".($i+1),"flag_".$_DATA[$i].".png",$_LABEL[$i],"","",0,19,13)." ";
      }
	 $menu_item .= "</nobr>";
     require(WM3_cPATH_SKINS."$skin/menu/admin_menu_current.inc");

     // Menu end
	 require(WM3_cPATH_SKINS."$skin/menu/admin_menu_end.inc");
    }

   public static function configSystemForm($w3,$skin)
    {
     // System config form
	 $error  = wm3Setup::getSystemConfigError();
	 $_ERROR = wm3Setup::getSystemConfigError(true);
     $_ARRAY = array('php_version','mysql','root_folder_write','temp_folder_write','imap','gd','upload_foders_write');
     $_STYLE = wm3Skin::getFormStyleArray($_ARRAY);

     $_STYLE['php_version']         = "class=\"formEven\"";
     $_STYLE['mysql']               = "class=\"formOdd\"";
     $_STYLE['root_folder_write']   = "class=\"formEven\"";
     $_STYLE['temp_folder_write']   = "class=\"formOdd\"";
     $_STYLE['imap']                = "class=\"formEven\"";
     $_STYLE['gd']                  = "class=\"formOdd\"";
     $_STYLE['upload_foders_write'] = "class=\"formEven\"";	 
     $_STYLE['formTitle']           = "class=\"formTitle\"";
     $form_title = $w3->getWord(1727);
	 foreach($_ERROR as $key => $value)
	  {
	   if($_ERROR[$key]) {
		                  if($key == 'imap' || $key == 'gd' || $key == 'upload_foders_write')
						   {
							$_STYLE[$key] = "class=\"formWarning\"";
						    $_IMAGE[$key] = 'misc_warning.png';
						   }
						  else
						   {
							$_STYLE[$key] = "class=\"formError\"";
                            $_IMAGE[$key] = 'action_enable.png';
						   }
						  $_STYLE['formTitle'] = "class=\"formTitleError\"";
  				          $form_title = $w3->getWord(1709);
                          $next_action_label = $w3->getWord(1703);
                          $next_action       = 0;
	                     }
	   else              {
                          $_IMAGE[$key] = 'action_disable.png';
					     }
  	   if($_ERROR['php_version'])         $_FIELD['php_version']         = $w3->getWord(1705)." ".phpversion()." ".$w3->getWord(1722);
	   else                               $_FIELD['php_version']         = $w3->getWord(1705)." ".phpversion()." ".$w3->getWord(1723);
  	   if($_ERROR['mysql'])               $_FIELD['mysql']               = $w3->getWord(1707);
	   else                               $_FIELD['mysql']               = $w3->getWord(1708);
  	   if($_ERROR['root_folder_write'])   $_FIELD['root_folder_write']   = $w3->getWord(1713);
	   else                               $_FIELD['root_folder_write']   = $w3->getWord(1714);
  	   if($_ERROR['temp_folder_write'])   $_FIELD['temp_folder_write']   = $w3->getWord(1716)." (".WM3_cPATH_TEMP.")".$w3->getWord(1717);
	   else                               $_FIELD['temp_folder_write']   = $w3->getWord(1716)." (".WM3_cPATH_TEMP.")".$w3->getWord(1718);
  	   if($_ERROR['imap'])                $_FIELD['imap']                = $w3->getWord(1720);
	   else                               $_FIELD['imap']                = $w3->getWord(1721);
  	   if($_ERROR['gd'])                  $_FIELD['gd']                  = $w3->getWord(1755);
	   else                               $_FIELD['gd']                  = $w3->getWord(1756);
  	   if($_ERROR['upload_foders_write']) $_FIELD['upload_foders_write'] = $w3->getWord(1724)." (".WM3_cPATH_IMAGES.", ".WM3_cPATH_ECOMMERCE.", ".WM3_cPATH_MEDIA_ALBUM.", ".WM3_cPATH_DOWNLOADS.")".$w3->getWord(1725);
	   else                               $_FIELD['upload_foders_write'] = $w3->getWord(1724)." (".WM3_cPATH_IMAGES.", ".WM3_cPATH_ECOMMERCE.", ".WM3_cPATH_MEDIA_ALBUM.", ".WM3_cPATH_DOWNLOADS.")".$w3->getWord(1726);
      }
     if($error) {
                 require(WM3_cPATH_SKINS."$skin/setup/setup_config_system_form.inc");
			    }
     else       {
                 $next_action_label = $w3->getWord(1703);
                 $next_action       = WM3_cACTION_SETUP_NEXT;
                 require(WM3_cPATH_SKINS."$skin/setup/setup_config_system_form.inc");
                }
     return $content;
    }

   public static function configFileForm($w3,$skin)
    {
     // Config file form
     $error = 0;
     $_ARRAY = array('db_server','db_user','db_password','db_name','db_prefix','languageID');
     $_STYLE = wm3Skin::getFormStyleArray($_ARRAY);
     $_FIELD = webmatic3::getPostValueArray($_ARRAY);
     $_STYLE['db_server']   = "class=\"formEven\"";
     $_STYLE['db_user']     = "class=\"formOdd\"";
     $_STYLE['db_password'] = "class=\"formEven\"";
     $_STYLE['db_name']     = "class=\"formOdd\"";
     $_STYLE['db_prefix']   = "class=\"formEven\"";
     $_STYLE['languageID']  = "class=\"formOdd\"";	 
     $_STYLE['formTitle']   = "class=\"formTitle\"";
     $form_title = $w3->getWord(1729);

     switch($w3->getVariable('action','post'))
      {
       case WM3_cACTION_SETUP_SAVEDB:
      	{
		 if(!wm3Sql::checkDatabaseServerVersion($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password']))         $error = 2;
         if(!wm3Sql::checkConnection($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password'],$_FIELD['db_name'])) $error = 1;
         switch($error)
          {
           case 1:
            {
             $_STYLE['db_server']   = "class=\"formError\"";
             $_STYLE['db_user']     = "class=\"formError\"";
             $_STYLE['db_password'] = "class=\"formError\"";
             $_STYLE['db_name']     = "class=\"formError\"";
             $_STYLE['formTitle']   = "class=\"formTitleError\"";
             $form_title = $w3->getWord(1730);
             $next_action_label = $w3->getWord(1703);
             $next_action       = WM3_cACTION_SETUP_SAVEDB;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_database_form.inc");
             break;
            }
           case 2:
            {
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
             $form_title = $w3->getWord(557)." ".mysql_get_server_info().". ".$w3->getWord(555)." ".$w3->getWord(558);
             $next_action_label = $w3->getWord(1703);
             $next_action       = WM3_cACTION_SETUP_SAVEDB;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_database_form.inc");
             break;
            }
           default:
            {
             wm3Setup::writeConfig($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password'],$_FIELD['db_name'],$_FIELD['db_prefix'],$_FIELD['languageID']);
             header("Location: index.php?action=".WM3_cACTION_SETUP_NEXT);
            }
          }
         break;
      	}
       default:
        {          	
         $next_action_label = $w3->getWord(1703);
         $next_action       = WM3_cACTION_SETUP_SAVEDB;
         require(WM3_cPATH_SKINS."$skin/setup/setup_config_database_form.inc");
        }
      }
     return $content;
    }

   public static function configUserForm($w3,$skin)
    {
     // Superuser config form
     $error = 0;
     $_ARRAY = array('name','surname','login','password','ck_password','email');
     $_STYLE = wm3Skin::getFormStyleArray($_ARRAY);
     $_FIELD = webmatic3::getPostValueArray($_ARRAY);
     $_STYLE['name']        = "class=\"formEven\"";
     $_STYLE['surname']     = "class=\"formOdd\"";
     $_STYLE['login']       = "class=\"formEven\"";
     $_STYLE['password']    = "class=\"formOdd\"";
     $_STYLE['ck_password'] = "class=\"formEven\"";
     $_STYLE['email']       = "class=\"formOdd\"";	 
     $_STYLE['formTitle']   = "class=\"formTitle\"";
     $form_title = $w3->getWord(1744);

     switch($w3->getVariable('action','post'))
      {
       case WM3_cACTION_SETUP_SAVEUSER:
      	{
	     if(wm3User::emailExists($w3,$_FIELD['email'],0)) $error = 5;
         if(!wm3Util::isEmail($_FIELD['email']))          $error = 4;
         if(!$_FIELD['password'] || !$_FIELD['ck_password'] || $_FIELD['password'] != $_FIELD['ck_password']) $error = 3;
		 if(wm3User::loginExists($w3,$_FIELD['login']))   $error = 2;
         if(!wm3Util::isLogin($_FIELD['login']))          $error = 1;
         if(!$_FIELD['surname'])                          $error = 6;
         if(!$_FIELD['name'])                             $error = 7;
         switch($error)
          {
           case 1:
            {
             $_STYLE['login']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
             $form_title = "Login must be not empty...";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 2:
            {
             $_STYLE['login']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(-1)."Login already exists \"".$_FIELD['login']."\"".$w3->getWord(444);
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 3:
            {
             $_STYLE['password']    = "class=\"formError\"";
             $_STYLE['ck_password'] = "class=\"formError\"";
             $_STYLE['formTitle']   = "class=\"formTitleError\"";
             $form_title = "Password empty or do not mach";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 4:
            {
             $_STYLE['email']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
             $form_title = $w3->getWord(1151);
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 5:
            {
             $_STYLE['email']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(376)." Already exists \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 6:
            {
             $_STYLE['surname']   = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(-1)."Empty surname";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 7:
            {
             $_STYLE['name']      = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(-1)."Empty name";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           default:
            {
             wm3User::writeSuperUser($w3);
             header("Location: index.php");
            }
          }
         break;
      	}
       default:
        {          	
         $next_action_label = $w3->getWord(29);
         $next_action       = WM3_cACTION_SETUP_SAVEUSER;
         require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
        }
      }
     return $content;
    }

   public static function writeConfig($server,$user,$password,$name,$prefix,$languageID)
    {
     $str = "<?php

              // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
              // www.valarsoft.com
 
              defined('WM3_cEXEC') or die('Denied');
 
              // Database settings
              define('WM3_cCONFIG_DB_SERVER',   '$server');
              define('WM3_cCONFIG_DB_USER',     '$user');
              define('WM3_cCONFIG_DB_PASSWORD', '$password');
              define('WM3_cCONFIG_DB_NAME',     '$name');
              define('WM3_cCONFIG_DB_PREFIX',   '$prefix');
 
              // FTP settings
              //define('WM3_cCONFIG_FTP_SERVER',   'localhost');
              //define('WM3_cCONFIG_FTP_USER',     'ftpuser');
              //define('WM3_cCONFIG_FTP_PASSWORD', 'ftppass');
              //define('WM3_cCONFIG_FTP_PORT',     '21');
			  //define('WM3_cCONFIG_FTP_FOLDER',   '');
			  //define('WM3_cCONFIG_FTP_PASV',     '0');
 
              // WEBMATIC3 settings
              //define('WM3_cCONFIG_ADMIN_LOGIN',       'admin');
              //define('WM3_cCONFIG_ADMIN_PASSWORD',    'pass');
              define('WM3_cCONFIG_STARTING_LANGUAGE', '$languageID'); // 1=English, 2=Italiano, 3=Franais, 4=Deutsch, 5=Espaol, 6=Nederlands
  
             ?>";
     // Open file and save configuration
     $fd = fopen("wm3_config.php",'w');
     fwrite($fd,$str);
     fclose($fd);
    }

   public static function lockSetup()
    {
     // Create setup lock file used to avoid error in database creation/update
	 $fd = @fopen("lock_setup",'r'); if($fd) { fclose($fd); return false; }// Setup not locked (access to setup denied)
     $fd = @fopen("lock_setup",'w'); if($fd) { fclose($fd); return true;  }// Setup locked (access to setup granted)
     return false; // Setup not locked (access to setup denied)
	}

   public static function unlockSetup()
    {
     // Delete setup lock file
	 @unlink("lock_setup");
	}

   public static function resetDatabase()
    {
	 // Reset/Setup query
	 $setup_ts = time();

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_banners
                       (
                        bannerID    bigint(20) primary key auto_increment,
                        title       char(255),
                        banner      text,
                        banner_type int(5),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                       (
                        bannerID      bigint(20) primary key auto_increment,
                        userID        bigint(20),
                        title         char(255),
                        banner_alt    char(255),
                        banner_url    char(255),
                        banner_image  char(255),
                        impressions   bigint(20) unsigned,
                        clicks        bigint(20) unsigned,
                        banner_source int(5),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits
                       (
                        banner_exchange_creditID bigint(20) primary key auto_increment,
                        userID                   bigint(20),
                        credits                  bigint(20) unsigned,
                        unlimited_credits        int(1),
                        ts                       int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                       (
                        blockID       bigint(20) primary key auto_increment,
                        subcategoryID bigint(20),
                        linkID        bigint(20),
                        title         char(255),
                        block_type    int(5),
                        picture       char(255),
                        picture_align int(5),
                        alt           char(255),
                        description   text,
                        render_mode   int(5),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                       (
                        subcategoryID bigint(20) primary key auto_increment,
                        categoryID    bigint(20),
                        name          char(255),
                        icon          char(255),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                       (
                        chatroomID bigint(20) primary key auto_increment,
                        name       char(255),
                        topic      text,
                        visibility int(5),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
                       (
                        sentenceID bigint(20) primary key auto_increment,
                        chatroomID bigint(20),
                        userID bigint(20),
                        nickname char(255),
                        sentence text,
                        enabled int(1),
                        languageID bigint(20),
                        ts int(16),
                        KEY ts (ts)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_counters
                       (
                        total_visitors     bigint(20) unsigned,
                        total_signalations bigint(20) unsigned,
                        max_visitors       int(16),
                        max_users          int(16),
                        last_user_ip       char(255),
                        last_user_dns      char(255),
                        last_userID        bigint(20),
                        last_user_ts       int(16),
                        installation_ts    int(16)
                       )";
     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_counters VALUES (0, 0, 0, 0, '', '', 0, 0, '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_countries
                       (
                        countryID bigint(20) primary key auto_increment,
                        code      char(8)    unique,
                        name      char(255),
                        hits      int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_countries VALUES
                       ('', 'ad', 'Andorra',                                      0),
                       ('', 'ae', 'United arab emirates',                         0),
                       ('', 'af', 'Afghanistan',                                  0),
                       ('', 'ag', 'Antigua and barbuda',                          0),
                       ('', 'ai', 'Anguilla',                                     0),
                       ('', 'al', 'Albania',                                      0),
                       ('', 'am', 'Armenia',                                      0),
                       ('', 'an', 'Netherlands antilles',                         0),
                       ('', 'ao', 'Angola',                                       0),
                       ('', 'aq', 'Antarctica',                                   0),
                       ('', 'ar', 'Argentina',                                    0),
                       ('', 'as', 'American samoa',                               0),
                       ('', 'at', 'Austria',                                      0),
                       ('', 'au', 'Australia',                                    0),
                       ('', 'aw', 'Aruba',                                        0),
                       ('', 'az', 'Azerbaijan',                                   0),
                       ('', 'ba', 'Bosnia and herzegovina',                       0),
                       ('', 'bb', 'Barbados',                                     0),
                       ('', 'bd', 'Bangladesh',                                   0),
                       ('', 'be', 'Belgium',                                      0),
                       ('', 'bf', 'Burkina faso',                                 0),
                       ('', 'bg', 'Bulgaria',                                     0),
                       ('', 'bh', 'Bahrain',                                      0),
                       ('', 'bi', 'Burundi',                                      0),
                       ('', 'bj', 'Benin',                                        0),
                       ('', 'bm', 'Bermuda',                                      0),
                       ('', 'bn', 'Brunei darussalam',                            0),
                       ('', 'bo', 'Bolivia',                                      0),
                       ('', 'br', 'Brazil',                                       0),
                       ('', 'bs', 'Bahamas',                                      0),
                       ('', 'bt', 'Bhutan',                                       0),
                       ('', 'bv', 'Bouvet island',                                0),
                       ('', 'bw', 'Botswana',                                     0),
                       ('', 'by', 'Belarus',                                      0),
                       ('', 'bz', 'Belize',                                       0),
                       ('', 'ca', 'Canada',                                       0),
                       ('', 'cc', 'Cocos (keeling) islands',                      0),
                       ('', 'cd', 'Congo, the democratic republic of the',        0),
                       ('', 'cf', 'Central african republic',                     0),
                       ('', 'cg', 'Congo',                                        0),
                       ('', 'ch', 'Switzerland',                                  0),
                       ('', 'ci', 'Cote d\'ivoire',                               0),
                       ('', 'ck', 'Cook islands',                                 0),
                       ('', 'cl', 'Chile',                                        0),
                       ('', 'cm', 'Cameroon',                                     0),
                       ('', 'cn', 'China',                                        0),
                       ('', 'co', 'Colombia',                                     0),
                       ('', 'cr', 'Costa rica',                                   0),
                       ('', 'cu', 'Cuba',                                         0),
                       ('', 'cv', 'Cape verde',                                   0),
                       ('', 'cx', 'Christmas island',                             0),
                       ('', 'cy', 'Cyprus',                                       0),
                       ('', 'cz', 'Czech republic',                               0),
                       ('', 'de', 'Germany',                                      0),
                       ('', 'dj', 'Djibouti',                                     0),
                       ('', 'dk', 'Denmark',                                      0),
                       ('', 'dm', 'Dominica',                                     0),
                       ('', 'do', 'Dominican republic',                           0),
                       ('', 'dz', 'Algeria',                                      0),
                       ('', 'ec', 'Ecuador',                                      0),
                       ('', 'ee', 'Estonia',                                      0),
                       ('', 'eg', 'Egypt',                                        0),
                       ('', 'eh', 'Western sahara',                               0),
                       ('', 'er', 'Eritrea',                                      0),
                       ('', 'es', 'Spain',                                        0),
                       ('', 'et', 'Ethiopia',                                     0),
                       ('', 'fi', 'Finland',                                      0),
                       ('', 'fj', 'Fiji',                                         0),
                       ('', 'fk', 'Falkland islands (malvinas)',                  0),
                       ('', 'fm', 'Micronesia, federated states of',              0),
                       ('', 'fo', 'Faroe islands',                                0),
                       ('', 'fr', 'France',                                       0),
                       ('', 'ga', 'Gabon',                                        0),
                       ('', 'gb', 'United kingdom',                               0),
                       ('', 'gd', 'Grenada',                                      0),
                       ('', 'ge', 'Georgia',                                      0),
                       ('', 'gf', 'French guiana',                                0),
                       ('', 'gh', 'Ghana',                                        0),
                       ('', 'gi', 'Gibraltar',                                    0),
                       ('', 'gl', 'Greenland',                                    0),
                       ('', 'gm', 'Gambia',                                       0),
                       ('', 'gn', 'Guinea',                                       0),
                       ('', 'gp', 'Guadeloupe',                                   0),
                       ('', 'gq', 'Equatorial guinea',                            0),
                       ('', 'gr', 'Greece',                                       0),
                       ('', 'gs', 'South georgia and the south sandwich islands', 0),
                       ('', 'gt', 'Guatemala',                                    0),
                       ('', 'gu', 'Guam',                                         0),
                       ('', 'gw', 'Guinea-bissau',                                0),
                       ('', 'gy', 'Guyana',                                       0),
                       ('', 'hk', 'Hong kong',                                    0),
                       ('', 'hm', 'Heard island and mcdonald islands',            0),
                       ('', 'hn', 'Honduras',                                     0),
                       ('', 'hr', 'Croatia',                                      0),
                       ('', 'ht', 'Haiti',                                        0),
                       ('', 'hu', 'Hungary',                                      0),
                       ('', 'id', 'Indonesia',                                    0),
                       ('', 'ie', 'Ireland',                                      0),
                       ('', 'il', 'Israel',                                       0),
                       ('', 'in', 'India',                                        0),
                       ('', 'io', 'British indian ocean territory',               0),
                       ('', 'iq', 'Iraq',                                         0),
                       ('', 'ir', 'Iran, islamic republic of',                    0),
                       ('', 'is', 'Iceland',                                      0),
                       ('', 'it', 'Italy',                                        0),
                       ('', 'jm', 'Jamaica',                                      0),
                       ('', 'jo', 'Jordan',                                       0),
                       ('', 'jp', 'Japan',                                        0),
                       ('', 'ke', 'Kenya',                                        0),
                       ('', 'kg', 'Kyrgyzstan',                                   0),
                       ('', 'kh', 'Cambodia',                                     0),
                       ('', 'ki', 'Kiribati',                                     0),
                       ('', 'km', 'Comoros',                                      0),
                       ('', 'kn', 'Saint kitts and nevis',                        0),
                       ('', 'kp', 'Korea, democratic people\'s republic of',      0),
                       ('', 'kr', 'Korea, republic of',                           0),
                       ('', 'kw', 'Kuwait',                                       0),
                       ('', 'ky', 'Cayman islands',                               0),
                       ('', 'kz', 'Kazakstan',                                    0),
                       ('', 'la', 'Lao people\'s democratic republic',            0),
                       ('', 'lb', 'Lebanon',                                      0),
                       ('', 'lc', 'Saint lucia',                                  0),
                       ('', 'li', 'Liechtenstein',                                0),
                       ('', 'lk', 'Sri lanka',                                    0),
                       ('', 'lr', 'Liberia',                                      0),
                       ('', 'ls', 'Lesotho',                                      0),
                       ('', 'lt', 'Lithuania',                                    0),
                       ('', 'lu', 'Luxembourg',                                   0),
                       ('', 'lv', 'Latvia',                                       0),
                       ('', 'ly', 'Libyan arab jamahiriya',                       0),
                       ('', 'ma', 'Morocco',                                      0),
                       ('', 'mc', 'Monaco',                                       0),
                       ('', 'md', 'Moldova, republic of',                         0),
                       ('', 'mg', 'Madagascar',                                   0),
                       ('', 'mh', 'Marshall islands',                             0),
                       ('', 'mk', 'Macedonia, the former yugoslav republic of',   0),
                       ('', 'ml', 'Mali',                                         0),
                       ('', 'mm', 'Myanmar',                                      0),
                       ('', 'mn', 'Mongolia',                                     0),
                       ('', 'mo', 'Macau',                                        0),
                       ('', 'mp', 'Northern mariana islands',                     0),
                       ('', 'mq', 'Martinique',                                   0),
                       ('', 'mr', 'Mauritania',                                   0),
                       ('', 'ms', 'Montserrat',                                   0),
                       ('', 'mt', 'Malta',                                        0),
                       ('', 'mu', 'Mauritius',                                    0),
                       ('', 'mv', 'Maldives',                                     0),
                       ('', 'mw', 'Malawi',                                       0),
                       ('', 'mx', 'Mexico',                                       0),
                       ('', 'my', 'Malaysia',                                     0),
                       ('', 'mz', 'Mozambique',                                   0),
                       ('', 'na', 'Namibia',                                      0),
                       ('', 'nc', 'New caledonia',                                0),
                       ('', 'ne', 'Niger',                                        0),
                       ('', 'nf', 'Norfolk island',                               0),
                       ('', 'ng', 'Nigeria',                                      0),
                       ('', 'ni', 'Nicaragua',                                    0),
                       ('', 'nl', 'Netherlands',                                  0),
                       ('', 'no', 'Norway',                                       0),
                       ('', 'np', 'Nepal',                                        0),
                       ('', 'nr', 'Nauru',                                        0),
                       ('', 'nu', 'Niue',                                         0),
                       ('', 'nz', 'New zealand',                                  0),
                       ('', 'om', 'Oman',                                         0),
                       ('', 'pa', 'Panama',                                       0),
                       ('', 'pe', 'Peru',                                         0),
                       ('', 'pf', 'French polynesia',                             0),
                       ('', 'pg', 'Papua new guinea',                             0),
                       ('', 'ph', 'Philippines',                                  0),
                       ('', 'pk', 'Pakistan',                                     0),
                       ('', 'pl', 'Poland',                                       0),
                       ('', 'pm', 'Saint pierre and miquelon',                    0),
                       ('', 'pn', 'Pitcairn',                                     0),
                       ('', 'pr', 'Puerto rico',                                  0),
                       ('', 'ps', 'Palestinian territory, occupied',              0),
                       ('', 'pt', 'Portugal',                                     0),
                       ('', 'pw', 'Palau',                                        0),
                       ('', 'py', 'Paraguay',                                     0),
                       ('', 'qa', 'Qatar',                                        0),
                       ('', 're', 'Reunion',                                      0),
                       ('', 'ro', 'Romania',                                      0),
                       ('', 'ru', 'Russian federation',                           0),
                       ('', 'rw', 'Rwanda',                                       0),
                       ('', 'sa', 'Saudi arabia',                                 0),
                       ('', 'sb', 'Solomon islands',                              0),
                       ('', 'sc', 'Seychelles',                                   0),
                       ('', 'sd', 'Sudan',                                        0),
                       ('', 'se', 'Sweden',                                       0),
                       ('', 'sg', 'Singapore',                                    0),
                       ('', 'sh', 'Saint helena',                                 0),
                       ('', 'si', 'Slovenia',                                     0),
                       ('', 'sj', 'Svalbard and jan mayen',                       0),
                       ('', 'sk', 'Slovakia',                                     0),
                       ('', 'sl', 'Sierra leone',                                 0),
                       ('', 'sm', 'San marino',                                   0),
                       ('', 'sn', 'Senegal',                                      0),
                       ('', 'so', 'Somalia',                                      0),
                       ('', 'sr', 'Suriname',                                     0),
                       ('', 'st', 'Sao tome and principe',                        0),
                       ('', 'sv', 'El salvador',                                  0),
                       ('', 'sy', 'Syrian arab republic',                         0),
                       ('', 'sz', 'Swaziland',                                    0),
                       ('', 'tc', 'Turks and caicos islands',                     0),
                       ('', 'td', 'Chad',                                         0),
                       ('', 'tf', 'French southern territories',                  0),
                       ('', 'tg', 'Togo',                                         0),
                       ('', 'th', 'Thailand',                                     0),
                       ('', 'tj', 'Tajikistan',                                   0),
                       ('', 'tk', 'Tokelau',                                      0),
                       ('', 'tm', 'Turkmenistan',                                 0),
                       ('', 'tn', 'Tunisia',                                      0),
                       ('', 'to', 'Tonga',                                        0),
                       ('', 'tp', 'East timor',                                   0),
                       ('', 'tr', 'Turkey',                                       0),
                       ('', 'tt', 'Trinidad and tobago',                          0),
                       ('', 'tv', 'Tuvalu',                                       0),
                       ('', 'tw', 'Taiwan, province of china',                    0),
                       ('', 'tz', 'Tanzania, united republic of',                 0),
                       ('', 'ua', 'Ukraine',                                      0),
                       ('', 'ug', 'Uganda',                                       0),
                       ('', 'um', 'United states minor outlying islands',         0),
                       ('', 'us', 'United states',                                0),
                       ('', 'uy', 'Uruguay',                                      0),
                       ('', 'uz', 'Uzbekistan',                                   0),
                       ('', 'va', 'Holy see (vatican city state)',                0),
                       ('', 'vc', 'Saint vincent and the grenadines',             0),
                       ('', 've', 'Venezuela',                                    0),
                       ('', 'vg', 'Virgin islands, british',                      0),
                       ('', 'vi', 'Virgin islands, u.s.',                         0),
                       ('', 'vn', 'Viet nam',                                     0),
                       ('', 'vu', 'Vanuatu',                                      0),
                       ('', 'wf', 'Wallis and futuna',                            0),
                       ('', 'ws', 'Samoa',                                        0),
                       ('', 'ye', 'Yemen',                                        0),
                       ('', 'yt', 'Mayotte',                                      0),
                       ('', 'yu', 'Yugoslavia',                                   0),
                       ('', 'za', 'South africa',                                 0),
                       ('', 'zm', 'Zambia',                                       0),
                       ('', 'zw', 'Zimbabwe',                                     0)";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_database
                       (
                        database_version char(255)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_database VALUES ('3.0')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_directories
                       (
                        directoryID    bigint(20) primary key auto_increment,
                        parentID       bigint(20),
                        name           char(255),
                        description    char(255),
                        icon           char(255),
                        directory_type int(5),
                        enabled        int(1),
                        languageID     bigint(20),
                        ts             int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       (
                        directory_itemID  bigint(20) primary key auto_increment,
                        directoryID       bigint(20),
                        userID            bigint(20),
                        pageID            bigint(20),
                        hits              int(16),
                        title             char(255),
                        description       text,
                        render_mode       int(5),
                        icon              char(255),
                        home_url          char(255),
                        download_url      char(255),
                        votes_counts      int(16),
                        votes_sum         int(16),
                        votes_average     float,
                        source            int(5),
                        directory_item_ts int(16),
                        enabled           int(1),
                        languageID        bigint(20),
                        ts                int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads
                       (
                        downloadID    bigint(20) primary key auto_increment,
                        subcategoryID bigint(20),
                        name          char(255),
                        description   text,
                        render_mode   int(5),
                        hits          int(16),
                        download      char(255),
                        source        int(5),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
                       (
                        categoryID  bigint(20) primary key auto_increment,
                        name        char(255),
                        description char(255),
                        icon        char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
                       (
                        subcategoryID bigint(20) primary key auto_increment,
                        categoryID    bigint(20),
                        name          char(255),
                        description   char(255),
                        icon          char(255),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                       (
                        cart_itemID         bigint(20) primary key auto_increment,
                        productID           bigint(20),
                        userID              bigint(20),
                        orderID             bigint(20),
                        product_code        char(255),
                        product_name        char(255),
                        product_description char(255),
                        options             text,
                        quantity            int(16),
                        price               double,
                        discount            int(5),
                        enabled             int(1),
                        languageID          bigint(20),
                        ts                  int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                       (
                        dataID     bigint(20) primary key auto_increment,
                        productID  bigint(20),
                        fieldID    bigint(20),
                        value      char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                       (
                        fieldID    bigint(20) primary key auto_increment,
                        type       int(5),
                        size       int(16),
                        show_in    int(5),
                        required   int(1),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
                       (
                        labelID    bigint(20) primary key auto_increment,
                        fieldID    bigint(20),
                        label      char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                       (
                        orderID       bigint(20) primary key auto_increment,
                        userID        bigint(20),
                        order_ts      int(16),
                        status        int(5),
                        shipping_cost double,
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                       (
                        productID         bigint(20) primary key auto_increment,
                        subcategoryID     bigint(20),
                        userID            bigint(20),
                        code              char(255),
                        name              char(255),
                        description       char(255),
                        full_description  text,
                        render_mode       int(5),
                        align             int(5),
                        price             double,
                        price_description char(255),
                        discount          int(5),
                        special           int(1),
                        stock             int(16),
                        availability      int(5),
                        options           text,
                        enabled           int(1),
                        languageID        bigint(20),
                        ts                int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                       (
                        pictureID   bigint(20) primary key auto_increment,
                        productID   bigint(20),
                        picture     char(255),
                        thumbnail   char(255),
                        description char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
                       (
                        subcategoryID bigint(20) primary key auto_increment,
                        categoryID    bigint(20),
                        name          char(255),
                        icon          char(255),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_faqs
                       (
                        faqID       bigint(20) primary key auto_increment,
                        categoryID  bigint(20),
                        question    char(255),
                        answer      text,
                        render_mode int(5),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_forums
                       (
                        forumID        bigint(20) primary key auto_increment,
                        categoryID     bigint(20),
                        userID         bigint(20),
                        title          char(255),
                        topic          char(255),
                        group_open     int(1),
                        users_read     int(1),
                        users_write    int(1),
                        users_open     int(1),
                        visitors_read  int(1),
                        visitors_write int(1),
                        visitors_open  int(1),
                        expire_days    int(16),
                        denied_words   text,
                        enabled        int(1),
                        languageID     bigint(20),
                        ts             int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                       (
                        categoryID  bigint(20) primary key auto_increment,
                        name        char(255),
                        description char(255),
                        icon        char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                       (
                        postID       bigint(20) primary key auto_increment,
                        discussionID bigint(20),
                        forumID      bigint(20),
                        quoteID      bigint(20),
                        userID       bigint(20),
                        title        char(255),
                        post         text,
                        render_mode  int(5),
                        locked       int(1),
                        hits         int(16),
                        enabled      int(1),
                        languageID   bigint(20),
                        ts           int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                       (
                        readID  bigint(20) primary key auto_increment,
                        userID  bigint(20),
                        postID  bigint(20),
                        read_ts int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_groups
                       (
                        groupID     bigint(20) primary key auto_increment,
                        name        char(255),
                        description text,
                        icon        char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_groups VALUES ('', 'Default', 'Default', '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                       (
                        messageID   bigint(20) primary key auto_increment,
                        guestbookID bigint(20),
                        countryID   bigint(20),
                        name        char(255),
                        email       char(255),
                        message     text,
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                       (
                        horoscopeID bigint(20) primary key auto_increment,
                        message     text,
                        render_mode int(5),
                        p1          int(1),
                        p2          int(1),
                        p3          int(1),
                        p4          int(1),
                        p5          int(1),
                        p6          int(1),
                        p7          int(1),
                        p8          int(1),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies
                       (
                        horoscope_dailyID bigint(20) primary key auto_increment,
                        horoscopeID       bigint(20),
                        sign              int(5),
                        expire_ts         int(16),
                        enabled           int(1),
                        languageID        bigint(20),
                        ts                int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_languages
                       (
                        languageID bigint(20) primary key auto_increment,
                        name       char(255),
                        flag       char(255),
                        file       char(255),
                        enabled    int(1),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_languages VALUES
                       ('', 'English',    'flag_en.png', 'language_en.php', ".WM3_cENABLED.", '".$setup_ts."'),
                       ('', 'Italiano',   'flag_it.png', 'language_it.php', ".WM3_cENABLED.", '".$setup_ts."'),
                       ('', 'Franais',   'flag_fr.png', 'language_fr.php', ".WM3_cENABLED.", '".$setup_ts."'),
                       ('', 'Deutsch',    'flag_de.png', 'language_de.php', ".WM3_cENABLED.", '".$setup_ts."'),
                       ('', 'Espaol',    'flag_es.png', 'language_es.php', ".WM3_cENABLED.", '".$setup_ts."'),
                       ('', 'Nederlands', 'flag_nl.png', 'language_nl.php', ".WM3_cENABLED.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_links
                       (
                        linkID      bigint(20) primary key auto_increment,
						categoryID  bigint(20),
                        url         char(255),
                        title       char(255),
                        description text,
                        render_mode int(5),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_links_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_logs
                       (
					    logID   bigint(20) primary key auto_increment,
                        referer char(255),
                        ip      char(255),
                        dns     char(255),
                        userID  bigint(20),
                        adminID bigint(20),
                        ts      int(16),
						KEY referer (referer)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                       (
                        announcementID    bigint(20) primary key auto_increment,
                        subcategoryID     bigint(20),
                        userID            bigint(20),
                        announcement      text,
                        render_mode       int(5),
                        title             char(255),
                        announcement_type int(5),
                        always_valid      int(1),
                        enabled           int(1),
                        languageID        bigint(20),
                        ts                int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_market_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
                       (
                        subcategoryID bigint(20) primary key auto_increment,
                        categoryID    bigint(20),
                        name          char(255),
                        icon          char(255),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                       (
                        media_albumID    bigint(20) primary key auto_increment,
                        userID           bigint(20),
                        categoryID       bigint(20),
                        title            char(255),
                        description      char(255),
                        icon             char(255),
                        media_album_type int(5),
                        group_read       int(1),
                        users_read       int(1),
                        visitors_read    int(1),
                        enabled          int(1),
                        languageID       bigint(20),
                        ts               int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                       (
                        categoryID  bigint(20) primary key auto_increment,
                        name        char(255),
                        description char(255),
                        icon        char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       (
                        media_album_itemID bigint(20) primary key auto_increment,
                        media_albumID      bigint(20),
                        title              char(255),
                        alt                char(255),
                        media              char(255),
                        thumbnail          char(255),
                        hits               int(16),
                        votes_counts       int(16),
                        votes_sum          int(16),
                        votes_average      float,
                        source_thumbnail   int(5),
                        source_media       int(5),
                        enabled            int(1),
                        languageID         bigint(20),
                        ts                 int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                       (
                        menu_bar_itemID bigint(20) primary key auto_increment,
                        linkID          bigint(20),
                        categoryID      bigint(20),
						title           char(255),
                        url             char(255),
                        target          char(255),
                        position        int(5),
                        enabled         int(1),
                        languageID      bigint(20),
                        ts              int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        position   int(5),
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories VALUES
                       ('', 0,    'MENU_BAR_ITEM_CHANNEL',  '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'MENU_BAR_ITEM_HOME',     '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'MENU_BAR_ITEM_ADMIN',    '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'MENU_BAR_ITEM_USER',     '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'MENU_BAR_ITEM_EXTERNAL', '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 1000, 'MENU_BAR_ITEM_CUSTOM',   '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_messages
                       (
                        messageID   bigint(20) primary key auto_increment,
						categoryID  bigint(20),
                        message     text,
                        render_mode int(5),
                        message_ts  int(16),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_metatags
                       (
                        author      text,
                        keywords    text,
                        description text,
                        languageID  bigint(20)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_metatags VALUES ('Webmatic Team', 'php, mysql, webportal, ecommerce, applets, java, forum, users manager, siti web, html, web application', 'Webportal or website creator, you can create your webportal in an easy way, Creatore di portali o siti web, crea il tuo sito semplicemente', ".WM3_cLANGUAGE_EN.")";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_news
                       (
                        newsID      bigint(20) primary key auto_increment,
                        categoryID  bigint(20),
                        userID      bigint(20),
                        title       char(255),
                        news        text,
                        render_mode int(5),
                        hits        int(16),						
                        news_ts     int(16),
						enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_news_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_news_comments
                       (
                        commentID   bigint(20) primary key auto_increment,
                        newsID      bigint(20),
                        userID      bigint(20),
                        comment     text,
                        render_mode int(5),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters
                       (
                        newsletterID        bigint(20) primary key auto_increment,
                        groupID             bigint(20),
                        newsletter_target   int(5),
                        user_gender         int(5),
                        ignore_disabled     int(1),
                        subject             char(255),
                        newsletter          text,
                        newsletter_use_foot int(1),
                        newsletter_format   int(5),
                        emails_sended       int(16),
						enabled             int(1),
                        languageID          bigint(20),
                        ts                  int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                       (
                        newsletter_itemID bigint(20) primary key auto_increment,
                        email             char(255)  unique,
                        enabled           int(1),
                        languageID        bigint(20),
                        ts                int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_pages
                       (
                        pageID               bigint(20) primary key auto_increment,
                        groupID              bigint(20),
                        categoryID           bigint(20),
                        backID               bigint(20),
                        title                char(255),
                        subtitle             char(255),
                        head                 text,
                        body                 text,
                        foot                 text,
						expansion            char(255),
                        render_mode          int(5),
                        visibility           int(5),
                        left_panels_enabled  int(1),
                        right_panels_enabled int(1),
                        page_type            int(5),
                        hits                 int(16),
                        enabled              int(1),
                        languageID           bigint(20),
                        ts                   int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        position   int(5),
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";
                      
     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_pages_categories VALUES
                       ('', 0,    'PAGE_MARKET',            '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_FAQ',               '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_SEARCH_ENGINE',     '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_USER_REGISTRATION', '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_LINKS',             '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_STATISTICS',        '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_USER_INFORMATIONS', '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_FORUMS',            '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_DOWNLOADS',         '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_GUESTBOOKS',        '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_DIRECTORIES',       '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_MEDIA_ALBUMS',      '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_CONTACT',           '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_CHAT',              '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PAGE_WEBMAIL',           '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 1000, 'PAGE_CUSTOM',            '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 500,  'PAGE_EXPANSION',         '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_panels
                       (
                        panelID     bigint(20) primary key auto_increment,
                        categoryID  bigint(20),
                        extraID     bigint(20),
                        title       char(255),
                        head        text,
                        body        text,
                        foot        text,
						expansion   char(255),
                        render_mode int(5),
                        position    int(5),
                        align       int(5),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_panels VALUES
                       ('', ".WM3_cPANEL_CATEGORY_LANGUAGES.", 0, 'Language:', 'Choose your language:', '', '', '', ".WM3_cRENDER_MODE_HTML.", 1, ".WM3_cALIGN_RIGHT.", ".WM3_cENABLED.", ".WM3_cLANGUAGE_EN.", '".$setup_ts."'),
                       ('', ".WM3_cPANEL_CATEGORY_LANGUAGES.", 0, 'Lingua:',   'Scegli la tua lingua:', '', '', '', ".WM3_cRENDER_MODE_HTML.", 2, ".WM3_cALIGN_RIGHT.", ".WM3_cENABLED.", ".WM3_cLANGUAGE_IT.", '".$setup_ts."'),
                       ('', ".WM3_cPANEL_CATEGORY_LANGUAGES.", 0, 'Language:', 'Choose your language:', '', '', '', ".WM3_cRENDER_MODE_HTML.", 3, ".WM3_cALIGN_RIGHT.", ".WM3_cENABLED.", ".WM3_cLANGUAGE_FR.", '".$setup_ts."'),
                       ('', ".WM3_cPANEL_CATEGORY_LANGUAGES.", 0, 'Language:', 'Choose your language:', '', '', '', ".WM3_cRENDER_MODE_HTML.", 4, ".WM3_cALIGN_RIGHT.", ".WM3_cENABLED.", ".WM3_cLANGUAGE_DE.", '".$setup_ts."'),
                       ('', ".WM3_cPANEL_CATEGORY_LANGUAGES.", 0, 'Language:', 'Choose your language:', '', '', '', ".WM3_cRENDER_MODE_HTML.", 5, ".WM3_cALIGN_RIGHT.", ".WM3_cENABLED.", ".WM3_cLANGUAGE_ES.", '".$setup_ts."'),
                       ('', ".WM3_cPANEL_CATEGORY_LANGUAGES.", 0, 'Language:', 'Choose your language:', '', '', '', ".WM3_cRENDER_MODE_HTML.", 6, ".WM3_cALIGN_RIGHT.", ".WM3_cENABLED.", ".WM3_cLANGUAGE_NL.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        position int(5),
                        name char(255),
                        icon char(255),
                        enabled int(1),
                        languageID bigint(20),
                        ts int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_panels_categories VALUES
                       ('', 0,    'PANEL_MESSAGES',       '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_LOGIN',          '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_CHANNELS',       '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_SEARCH',         '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_HOROSCOPE',      '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_NEWSLETTER',     '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_SEND_TO_FRIEND', '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_LANGUAGES',      '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_ECOMMERCE',      '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_SURVEY',         '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_FORTUNE',        '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_RSS_FEEDS',      '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_BIRTHDAY',       '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 0,    'PANEL_SPECIAL_OFFER',  '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 1000, 'PANEL_CUSTOM',         '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."'),
                       ('', 500,  'PANEL_EXPANSION',      '', ".WM3_cENABLED.", ".WM3_cLANGUAGE_ALL.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       (
                        banners_enabled                   int(1),
                        banner1ID                         bigint(20),
                        banner2ID                         bigint(20),
                        banner3ID                         bigint(20),
                        banner4ID                         bigint(20),
                        banner5ID                         bigint(20),
                        banner6ID                         bigint(20),
                        banner7ID                         bigint(20),
                        banner8ID                         bigint(20),
                        banner9ID                         bigint(20),
                        banners_exchange_enabled          int(1),
                        banners_exchange_ratio            int(16),
                        banners_exchange_extra_content    text,
                        banners_exchange_auto_enabled     int(1),
                        banners_exchange_starting_credits int(16),
                        logo                              char(255),
                        logo_width                        int(5),
                        logo_height                       int(5),
                        skin                              char(255),
                        site_address                      char(255),
                        foot_content                      int(5),
                        home_news_max                     int(16),
                        webmaster_email                   char(255),
                        service_email                     char(255),
						hide_left_panels_action_home      int(1),
						hide_right_panels_action_home     int(1),
                        show_home_channels                int(1),
                        show_home_news                    int(1),
                        show_full_news                    int(1),
                        enable_news_comments              int(1),
                        anonymous_news_comments           int(1),
                        anonymous_write_news              int(1),
                        anonymous_enabled_news            int(1),
                        anonymous_add_directories         int(1),
                        anonymous_enabled_directories     int(1),
                        anonymous_vote_directories        int(1),
                        anonymous_vote_media_albums       int(1),
                        show_total_newsletter             int(1),
                        show_total_signalations           int(1),
                        show_total_search_engine          int(1),
                        show_online_users_visitors        int(1),
                        ecommerce_credit_card_url         char(255),
                        ecommerce_variable_price          char(255),
                        ecommerce_variable_id             char(255),
                        ecommerce_currency                char(255),
                        ecommerce_type                    int(5),
                        ecommerce_show_catalogue_price    int(1),
                        ecommerce_show_extra              int(1),
                        ecommerce_payment_type            int(5),
                        ecommerce_cart_expire             int(16),
                        ecommerce_shipping_cost           double,
                        user_enabled                      int(1),
                        user_special                      int(1),
                        user_flag1                        int(1),
                        user_flag2                        int(1),
                        user_flag3                        int(1),
                        user_flag4                        int(1),
                        user_flag5                        int(1),
                        user_flag6                        int(1),
                        user_flag7                        int(1),
                        user_flag8                        int(1),
                        user_groupID                      bigint(20),
                        logging_enabled                   int(1),
                        ts                                int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_preferences VALUES (".WM3_cDISABLED.", 0, 0, 0, 0, 0, 0, 0, 0, 0, ".WM3_cDISABLED.", 5, '', ".WM3_cDISABLED.", 5000, 'webmatic1.gif', 32, 32, 'default', 'localhost', ".WM3_cPREFERENCES_FOOT_COUNTER_DATE.", 10, 'products@valarsoft.com', 'dontreply@service_email.com', ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cENABLED.", ".WM3_cENABLED.", ".WM3_cENABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", 'cc_url', 'n1', 'n2', 'Euro', ".WM3_cPREFERENCES_ECOMMERCE_CATALOGUE_ONLY.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", 0, 5, 0, ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", ".WM3_cDISABLED.", 1, ".WM3_cENABLED.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                       (
                        preferences_contentID           bigint(20) primary key auto_increment,
                        browser_bar_title               char(255),
                        title                           char(255),
                        head                            text,
                        home                            text,
                        foot                            text,
                        staff_name                      char(255),
                        special_user_label              char(255),
                        signalation_email_subject       char(255),
                        signalation_email_text          text,
                        user_registration_email_subject char(255),
                        user_registration_email_text    text,
                        languageID                      bigint(20),
                        ts                              int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_preferences_contents VALUES
                       ('', 'Webmatic', 'Welcome to Webmatic',   '', '<b>Webmatic its now correctly installed, thanks!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Now you can:<br><br><nobr>- Start to modify your website by click on <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">admin</a>;</nobr><br><nobr>- Read Webmatic <a href=\"".WM3_cPATH_DOCS."en\" target=\"_blank\">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>',                                                                     '', 'Webmatic editorial staff', 'Special user',    'Subject', 'text',  'Subject', 'text',  ".WM3_cLANGUAGE_EN.", '".$setup_ts."'),
                       ('', 'Webmatic', 'Benvenuti in Webmatic', '', '<b>Webmatic e\' stato correttamente installato, grazie!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Adesso e\' possibile:<br><br><nobr>- Iniziare a modificare il sito web cliccando su <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">amministrazione</a>;</nobr><br><nobr>- Consultare la <a href=\"".WM3_cPATH_DOCS."it\" target=\"_blank\">documentazione</a> di Webmatic;</nobr><br><nobr>- Scaricare l\'ultima versione di Webmatic dal sito <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>Per ogni For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>', '', 'Redazione Webmatic',       'Utente speciale', 'Oggetto', 'testo', 'Oggetto', 'testo', ".WM3_cLANGUAGE_IT.", '".$setup_ts."'),
                       ('', 'Webmatic', 'Welcome to Webmatic',   '', '<b>Webmatic its now correctly installed, thanks!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Now you can:<br><br><nobr>- Start to modify your website by click on <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">admin</a>;</nobr><br><nobr>- Read Webmatic <a href=\"".WM3_cPATH_DOCS."en\" target=\"_blank\">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>',                                                                     '', 'Webmatic editorial staff', 'Special user',    'Subject', 'text',  'Subject', 'text',  ".WM3_cLANGUAGE_FR.", '".$setup_ts."'),
                       ('', 'Webmatic', 'Welcome to Webmatic',   '', '<b>Webmatic its now correctly installed, thanks!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Now you can:<br><br><nobr>- Start to modify your website by click on <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">admin</a>;</nobr><br><nobr>- Read Webmatic <a href=\"".WM3_cPATH_DOCS."en\" target=\"_blank\">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>',                                                                     '', 'Webmatic editorial staff', 'Special user',    'Subject', 'text',  'Subject', 'text',  ".WM3_cLANGUAGE_DE.", '".$setup_ts."'),
                       ('', 'Webmatic', 'Welcome to Webmatic',   '', '<b>Webmatic its now correctly installed, thanks!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Now you can:<br><br><nobr>- Start to modify your website by click on <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">admin</a>;</nobr><br><nobr>- Read Webmatic <a href=\"".WM3_cPATH_DOCS."en\" target=\"_blank\">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>',                                                                     '', 'Webmatic editorial staff', 'Special user',    'Subject', 'text',  'Subject', 'text',  ".WM3_cLANGUAGE_ES.", '".$setup_ts."'),
					   ('', 'Webmatic', 'Welcome to Webmatic',   '', '<b>Webmatic its now correctly installed, thanks!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Now you can:<br><br><nobr>- Start to modify your website by click on <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">admin</a>;</nobr><br><nobr>- Read Webmatic <a href=\"".WM3_cPATH_DOCS."en\" target=\"_blank\">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>',                                                                     '', 'Webmatic editorial staff', 'Special user',    'Subject', 'text',  'Subject', 'text',  ".WM3_cLANGUAGE_NL.", '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_quotes
                       (
                        quoteID     bigint(20) primary key auto_increment,
                        quote       text,
                        render_mode int(5),
                        author      char(255),
                        year        char(255),
                        occupation  char(255),
                        author_url  char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                       (
                        search_engine_itemID bigint(20) primary key auto_increment,
                        url                  char(255)  unique,
                        keywords             char(255),
                        description          char(255),
                        enabled              int(1),
                        languageID           bigint(20),
                        ts                   int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions
                       (
                        sessionID bigint(20) primary key auto_increment,
						userID    bigint(20),
                        hash      char(255),
                        ip        char(255),
                        expire_ts int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_actions
                       (
                        actionID  bigint(20) primary key auto_increment,
                        sessionID bigint(20),
                        action_ts int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange
                       (
                        banner_exchange_sessionID bigint(20) primary key auto_increment,
                        banner_exchangeID         bigint(20),
                        sessionID                 bigint(20),
                        userID                    bigint(20),
                        session_type              int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                       (
                        chatroom_sessionID bigint(20) primary key auto_increment,
                        chatroomID         bigint(20),
                        userID             bigint(20),
                        nickname           char(255),
                        ip                 char(255),
                        join_ts            int(16),
                        expire_ts          int(16),
                        KEY join_ts (join_ts)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items
                       (
                        directory_item_sessionID bigint(20) primary key auto_increment,
                        directory_itemID         bigint(20),
                        sessionID                bigint(20),
                        userID                   bigint(20),
                        session_type             int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads
                       (
                        download_sessionID bigint(20) primary key auto_increment,
                        downloadID         bigint(20),
                        sessionID          bigint(20),
                        userID             bigint(20),
                        session_type       int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts
                       (
                        forum_post_sessionID bigint(20) primary key auto_increment,
                        forum_postID         bigint(20),
                        sessionID            bigint(20),
                        userID               bigint(20),
                        session_type         int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items
                       (
                        media_album_item_sessionID bigint(20) primary key auto_increment,
                        media_album_itemID         bigint(20),
                        sessionID                  bigint(20),
                        userID                     bigint(20),
                        session_type               int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_news
                       (
                        news_sessionID bigint(20) primary key auto_increment,
                        newsID         bigint(20),
                        sessionID      bigint(20),
                        userID         bigint(20),
                        session_type   int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_pages
                       (
                        page_sessionID bigint(20) primary key auto_increment,
                        pageID         bigint(20),
                        sessionID      bigint(20),
                        userID         bigint(20),
                        session_type   int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                       (
                        survey_sessionID bigint(20) primary key auto_increment,
                        surveyID         bigint(20),
                        survey_itemID    bigint(20),
                        sessionID        bigint(20),
                        userID           bigint(20),
                        session_type     int(5)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_states
                       (
                        stateID   bigint(20) primary key auto_increment,
                        countryID bigint(20),
                        code      char(8),
                        name      char(255),
                        hits      int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_states VALUES
                       ('', 105, 'ag', 'Agrigento',             0),
                       ('', 105, 'al', 'Alessandria',           0),
                       ('', 105, 'an', 'Ancona',                0),
                       ('', 105, 'ao', 'Aosta',                 0),
                       ('', 105, 'ap', 'Ascoli Piceno',         0),
                       ('', 105, 'aq', 'L\'Aquila',             0),
                       ('', 105, 'ar', 'Arezzo',                0),
                       ('', 105, 'at', 'Asti',                  0),
                       ('', 105, 'av', 'Avellino',              0),
                       ('', 105, 'ba', 'Bari',                  0),
                       ('', 105, 'bg', 'Bergamo',               0),
                       ('', 105, 'bi', 'Biella',                0),
                       ('', 105, 'bl', 'Belluno',               0),
                       ('', 105, 'bn', 'Benevento',             0),
                       ('', 105, 'bo', 'Bologna',               0),
                       ('', 105, 'br', 'Brindisi',              0),
                       ('', 105, 'bs', 'Brescia',               0),
                       ('', 105, 'bz', 'Bolzano-Bozen',         0),
                       ('', 105, 'ca', 'Cagliari',              0),
                       ('', 105, 'cb', 'Campobasso',            0),
                       ('', 105, 'ce', 'Caserta',               0),
                       ('', 105, 'ch', 'Chieti',                0),
                       ('', 105, 'cl', 'Caltanissetta',         0),
                       ('', 105, 'cn', 'Cuneo',                 0),
                       ('', 105, 'co', 'Como',                  0),
                       ('', 105, 'cr', 'Cremona',               0),
                       ('', 105, 'cs', 'Cosenza',               0),
                       ('', 105, 'ct', 'Catania',               0),
                       ('', 105, 'cz', 'Catanzaro',             0),
                       ('', 105, 'en', 'Enna',                  0),
                       ('', 105, 'fe', 'Ferrara',               0),
                       ('', 105, 'fg', 'Foggia',                0),
                       ('', 105, 'fi', 'Firenze',               0),
                       ('', 105, 'fo', 'Forl-Cesena',          0),
                       ('', 105, 'fr', 'Frosinone',             0),
                       ('', 105, 'ge', 'Genova',                0),
                       ('', 105, 'go', 'Gorizia',               0),
                       ('', 105, 'gr', 'Grosseto',              0),
                       ('', 105, 'im', 'Imperia',               0),
                       ('', 105, 'is', 'Isernia',               0),
                       ('', 105, 'kr', 'Crotone',               0),
                       ('', 105, 'lc', 'Lecco',                 0),
                       ('', 105, 'le', 'Lecce',                 0),
                       ('', 105, 'li', 'Livorno',               0),
                       ('', 105, 'lo', 'Lodi',                  0),
                       ('', 105, 'lt', 'Latina',                0),
                       ('', 105, 'lu', 'Lucca',                 0),
                       ('', 105, 'mc', 'Macerata',              0),
                       ('', 105, 'me', 'Messina',               0),
                       ('', 105, 'mi', 'Milano',                0),
                       ('', 105, 'mn', 'Mantova',               0),
                       ('', 105, 'mo', 'Modena',                0),
                       ('', 105, 'ms', 'Massa-Carrara',         0),
                       ('', 105, 'mt', 'Matera',                0),
                       ('', 105, 'na', 'Napoli',                0),
                       ('', 105, 'no', 'Novara',                0),
                       ('', 105, 'nu', 'Nuoro',                 0),
                       ('', 105, 'or', 'Oristano',              0),
                       ('', 105, 'pa', 'Palermo',               0),
                       ('', 105, 'pc', 'Piacenza',              0),
                       ('', 105, 'pd', 'Padova',                0),
                       ('', 105, 'pe', 'Pescara',               0),
                       ('', 105, 'pg', 'Perugia',               0),
                       ('', 105, 'pi', 'Pisa',                  0),
                       ('', 105, 'pn', 'Pordenone',             0),
                       ('', 105, 'po', 'Prato',                 0),
                       ('', 105, 'pr', 'Parma',                 0),
                       ('', 105, 'ps', 'Pesaro e urbino',       0),
                       ('', 105, 'pt', 'Pistoia',               0),
                       ('', 105, 'pv', 'Pavia',                 0),
                       ('', 105, 'pz', 'Potenza',               0),
                       ('', 105, 'ra', 'Ravenna',               0),
                       ('', 105, 'rc', 'Reggio Calabria',       0),
                       ('', 105, 're', 'Reggio Emilia',         0),
                       ('', 105, 'rg', 'Ragusa',                0),
                       ('', 105, 'ri', 'Rieti',                 0),
                       ('', 105, 'rm', 'Roma',                  0),
                       ('', 105, 'rn', 'Rimini',                0),
                       ('', 105, 'ro', 'Rovigo',                0),
                       ('', 105, 'sa', 'Salerno',               0),
                       ('', 105, 'si', 'Siena',                 0),
                       ('', 105, 'so', 'Sondrio',               0),
                       ('', 105, 'sp', 'La Spezia',             0),
                       ('', 105, 'sr', 'Siracusa',              0),
                       ('', 105, 'ss', 'Sassari',               0),
                       ('', 105, 'sv', 'Savona',                0),
                       ('', 105, 'ta', 'Taranto',               0),
                       ('', 105, 'te', 'Teramo',                0),
                       ('', 105, 'tn', 'Trento',                0),
                       ('', 105, 'to', 'Torino',                0),
                       ('', 105, 'tp', 'Trapani',               0),
                       ('', 105, 'tr', 'Terni',                 0),
                       ('', 105, 'ts', 'Trieste',               0),
                       ('', 105, 'tv', 'Treviso',               0),
                       ('', 105, 'ud', 'Udine',                 0),
                       ('', 105, 'va', 'Varese',                0),
                       ('', 105, 'vb', 'Verbano-Cusio-Ossola',  0),
                       ('', 105, 'vc', 'Vercelli',              0),
                       ('', 105, 've', 'Venezia',               0),
                       ('', 105, 'vi', 'Vicenza',               0),
                       ('', 105, 'vr', 'Verona',                0),
                       ('', 105, 'vt', 'Viterbo',               0),
                       ('', 105, 'vv', 'Vibo Valentia',         0),
                       ('', 222, 'aa', 'AA',                    0),
                       ('', 222, 'ae', 'AE',                    0),
                       ('', 222, 'ak', 'Alaska',                0),
                       ('', 222, 'al', 'Alabama',               0),
                       ('', 222, 'ap', 'AP',                    0),
                       ('', 222, 'ar', 'Arkansas',              0),
                       ('', 222, 'az', 'Arizona',               0),
                       ('', 222, 'ca', 'California',            0),
                       ('', 222, 'co', 'Colorado',              0),
                       ('', 222, 'ct', 'Connecticut',           0),
                       ('', 222, 'dc', 'District Of Columbia',  0),
                       ('', 222, 'de', 'Delaware',              0),
                       ('', 222, 'fl', 'Florida',               0),
                       ('', 222, 'fp', 'FP',                    0),
                       ('', 222, 'ga', 'Georgia',               0),
                       ('', 222, 'hi', 'Hawaii',                0),
                       ('', 222, 'ia', 'Iowa',                  0),
                       ('', 222, 'id', 'Idaho',                 0),
                       ('', 222, 'il', 'Illinois',              0),
                       ('', 222, 'in', 'Indiana',               0),
                       ('', 222, 'ks', 'Kansas',                0),
                       ('', 222, 'ky', 'Kentucky',              0),
                       ('', 222, 'la', 'Louisiana',             0),
                       ('', 222, 'ma', 'Massachusetts',         0),
                       ('', 222, 'md', 'Maryland',              0),
                       ('', 222, 'me', 'Maine',                 0),
                       ('', 222, 'mi', 'Michigan',              0),
                       ('', 222, 'mn', 'Minnesota',             0),
                       ('', 222, 'mo', 'Missouri',              0),
                       ('', 222, 'ms', 'Mississippi',           0),
                       ('', 222, 'mt', 'Montana',               0),
                       ('', 222, 'nc', 'North Carolina',        0),
                       ('', 222, 'nd', 'North Dakota',          0),
                       ('', 222, 'ne', 'Nebraska',              0),
                       ('', 222, 'nh', 'New Hampshire',         0),
                       ('', 222, 'nj', 'New Jersey',            0),
                       ('', 222, 'nm', 'New Mexico',            0),
                       ('', 222, 'nv', 'Nevada',                0),
                       ('', 222, 'ny', 'New York',              0),
                       ('', 222, 'oh', 'Ohio',                  0),
                       ('', 222, 'ok', 'Oklahoma',              0),
                       ('', 222, 'or', 'Oregon',                0),
                       ('', 222, 'pa', 'Pennsylvania',          0),
                       ('', 222, 'ri', 'Rhode Island',          0),
                       ('', 222, 'sc', 'South Carolina',        0),
                       ('', 222, 'sd', 'South Dakota',          0),
                       ('', 222, 'tn', 'Tennessee',             0),
                       ('', 222, 'tx', 'Texas',                 0),
                       ('', 222, 'ut', 'Utah',                  0),
                       ('', 222, 'va', 'Virginia',              0),
                       ('', 222, 'vi', 'US Virgin Islands',     0),
                       ('', 222, 'vt', 'Vermont',               0),
                       ('', 222, 'wa', 'Washington',            0),
                       ('', 222, 'wi', 'Wisconsin',             0),
                       ('', 222, 'wv', 'West Virginia',         0),
                       ('', 222, 'wy', 'Wyoming',               0),
                       ('', 36,  'ab', 'Alberta',               0),
                       ('', 36,  'bc', 'British Columbia',      0),
                       ('', 36,  'mb', 'Manitoba',              0),
                       ('', 36,  'nb', 'New Brunswick',         0),
                       ('', 36,  'nf', 'Newfoundland',          0),
                       ('', 36,  'ns', 'Nova Scotia',           0),
                       ('', 36,  'nt', 'Northwest Territories', 0),
                       ('', 36,  'nu', 'Nunavut',               0),
                       ('', 36,  'on', 'Ontario',               0),
                       ('', 36,  'pe', 'Prince Edward Island',  0),
                       ('', 36,  'qc', 'Quebec',                0),
                       ('', 36,  'sk', 'Saskatchewan',          0),
                       ('', 36,  'yt', 'Yukon Territory',       0)";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers
                       (
                        browserID  bigint(20) primary key auto_increment,
                        name       char(255),
                        hits       bigint(20) unsigned,
                        icon       char(255),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers VALUES
                       ('', 'Other',             0, 'browser_other.png',         '".$setup_ts."'),
                       ('', 'Search engine',     0, 'browser_search_engine.png', '".$setup_ts."'),
                       ('', 'Internet explorer', 0, 'browser_ie.png',            '".$setup_ts."'),
                       ('', 'Mozilla',           0, 'browser_mozilla.png',       '".$setup_ts."'),
                       ('', 'Google chrome',     0, 'browser_chrome.png',        '".$setup_ts."'),
                       ('', 'Netscape',          0, 'browser_netscape.png',      '".$setup_ts."'),
                       ('', 'Opera',             0, 'browser_opera.png',         '".$setup_ts."'),
                       ('', 'Konqueror',         0, 'browser_konqueror.png',     '".$setup_ts."'),
                       ('', 'IBrowse',           0, 'browser_ibrowse.png',       '".$setup_ts."'),
                       ('', 'Lynx',              0, 'browser_lynx.png',          '".$setup_ts."'),
                       ('', 'WebTV',             0, 'browser_webtv.png',         '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_history
                       (
                        historyID       bigint(20) primary key auto_increment,
                        year            int(16),
                        month           int(2),
                        day             int(2),
                        hour            int(2),
                        day_of_the_week int(1),
                        hits            int(16),
                        ts              int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses
                       (
                        osID       bigint(20) primary key auto_increment,
                        name       char(255),
                        hits       bigint(20) unsigned,
                        icon       char(255),
                        ts         int(16)
                       )";

     $_QUERY_RST[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_statistics_oses VALUES
                       ('', 'Other',    0, 'os_other.png',   '".$setup_ts."'),
                       ('', 'Windows',  0, 'os_windows.png', '".$setup_ts."'),
                       ('', 'Linux',    0, 'os_linux.png',   '".$setup_ts."'),
                       ('', 'Mac OS',   0, 'os_macos.png',   '".$setup_ts."'),
                       ('', 'Sun OS',   0, 'os_sunos.png',   '".$setup_ts."'),
                       ('', 'Be OS',    0, 'os_beos.png',    '".$setup_ts."'),
                       ('', 'Amiga OS', 0, 'os_amigaos.png', '".$setup_ts."'),
                       ('', 'AIX',      0, 'os_aix.png',     '".$setup_ts."'),
                       ('', 'Free BSD', 0, 'os_freebsd.png', '".$setup_ts."'),
                       ('', 'Irix',     0, 'os_irix.png',    '".$setup_ts."'),
                       ('', 'OS 2',     0, 'os_os2.png',     '".$setup_ts."')";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_surveys
                       (
                        surveyID    bigint(20) primary key auto_increment,
                        title       char(255),
                        question    text,
                        render_mode int(5),
                        target_type int(5),
                        result_type int(5),
                        layout_type int(5),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                       (
                        survey_itemID bigint(20) primary key auto_increment,
                        surveyID      char(255),
                        answer        text,
                        render_mode   int(5),
                        votes         int(16),
                        enabled       int(1),
                        languageID    bigint(20),
                        ts            int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_users
                       (
                        userID              bigint(20) primary key auto_increment,
                        groupID             bigint(20),
                        countryID           bigint(20),
                        stateID             bigint(20),
                        birth_countryID     bigint(20),
                        birth_stateID       bigint(20),
                        login               char(255)  unique not null,
                        password            char(32),
                        name                char(255),
                        surname             char(255),
                        address             char(255),
                        zip_code            char(5),
                        city                char(255),
                        phone               char(255),
                        fax                 char(255),
                        cell                char(255),
                        icq                 char(255),
                        email               char(255)  unique,
                        website             char(255),
                        birth_date          date,
                        birth_city          char(255),
                        gender              char(1),
                        avatar              char(255),
                        special             int(1),
                        enabled             int(1),
                        visible             int(1),
                        deleted             int(1),
                        admin               int(1),
                        superuser           int(1),
                        f1                  int(1),
                        f2                  int(1),
                        f3                  int(1),
                        f4                  int(1),
                        f5                  int(1),
                        f6                  int(1),
                        f7                  int(1),
                        f8                  int(1),
                        last_user_login_ts     int(16),

                        previous_user_login_ts int(16),

                        af1                    int(1),
                        af2                 int(1),
                        af3                 int(1),
                        af4                 int(1),
                        af5                 int(1),
                        af6                 int(1),
                        af7                 int(1),
                        af8                 int(1),
                        af9                 int(1),
                        af10                int(1),
                        af11                int(1),
                        af12                int(1),
                        af13                int(1),
                        af14                int(1),
                        af15                int(1),
                        af16                int(1),
                        af17                int(1),
                        af18                int(1),
                        af19                int(1),
                        af20                int(1),
                        af21                int(1),
                        af22                int(1),
                        af23                int(1),
                        af24                int(1),
                        af25                int(1),
                        af26                int(1),
                        af27                int(1),
                        af28                int(1),
                        af29                int(1),
                        af30                int(1),
                        af31                int(1),
                        af32                int(1),
                        af33                int(1),
                        af34                int(1),
                        af35                int(1),
                        af36                int(1),
                        af37                int(1),
                        af38                int(1),
                        af39                int(1),
                        af40                int(1),
                        last_admin_login_ts     int(16),
						
                        previous_admin_login_ts int(16),
						
                        notes                   text,
                        languageID              bigint(20),
                        ts                      int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_users_messages
                       (
                        messageID             bigint(20) primary key auto_increment,
                        toID                  bigint(20),
                        fromID                bigint(20),
                        subject               char(255),
                        message               text,
                        message_read          int(1),
                        message_replied       int(1),
                        message_high_priority int(1),
                        enabled               int(1),
                        languageID            bigint(20),
                        ts                    int(16)
                       )";

     $_QUERY_RST[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                       (
                        serverID                bigint(20) primary key auto_increment,
                        name                    char(255),
                        in_suffix               char(255),
                        in_use_suffix           int(1),
                        in_address              char(255),
                        in_port                 int(16),
                        in_protocol             int(5),
                        out_login               char(255),
                        out_password            char(255),
                        out_address             char(255),
                        out_port                int(16),
                        out_authentication_type int(5),
                        out_use_internal        int(1),
                        visibility              int(5),
                        enabled                 int(1),
                        languageID              bigint(20),
                        ts                      int(16)
                       )";

     for($i = 0; $i < sizeof($_QUERY_RST); $i++) wm3Sql::sqlQuery($_QUERY_RST[$i]);
    }

   public static function deleteDatabase()
    {
     // Delete query (TODO)
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_ass";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_bar";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_blk";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_can";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_lin";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_mer";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_pag";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_not";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_assistenza";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_banners";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_barra";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_blocchi";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_blocchi_can";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_canali";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_counter";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_links";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_mercatino";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_messaggi";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_news_email";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_notizie";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_oroscopo";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_pagine";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_pref";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_morepref";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_ricerca";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_utenti";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_bbs";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_prod";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_subargomenti_prod";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_prodotti";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_carrello";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_ordini";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_br_stat";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_os_stat";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_country";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_sessions";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_survey";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_survey_item";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_survey_sess";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_province";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_time_stat";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_forum";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_forum_frasi";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_forum_reply";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_dow";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_download_sub";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_download";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_commenti";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_for";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_newsletters";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_gb_messaggi";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_directory";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_directory_item";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_directory_sess";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_metatags";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_banners_rot";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_log";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_gruppi";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_lingue";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_argomenti_alb";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_album";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_album_item";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_album_sess";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_chat_rooms";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_chat_speak";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_chat_sess";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_chat_roomsess";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_webmail_server";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_comm_userfld";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_comm_userlab";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_comm_userdat";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_prodotti_pic";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_fortune";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_forum_read";
     $_QUERY_DEL[] = "DROP TABLE IF EXISTS ".WM3_cCONFIG_DB_PREFIX."_wcm";
     
     for($i = 0; $i < sizeof($_QUERY_DEL); $i++) wm3Sql::sqlQuery($_QUERY_DEL[$i]);
    }

   public static function updateDatabase28to30()
    {
     // Update query (2.8 to 3.0)

     $update_ts = time();
	 $forums_posts_total         = wm3Sql::getNextAutoIncrementID(WM3_cCONFIG_DB_PREFIX."_forum_reply") - 1; // TODO Controllare permessi di mysql per questa operazione	 
	 $users_next_auto_increment  = wm3Sql::getNextAutoIncrementID(WM3_cCONFIG_DB_PREFIX."_utenti"); // TODO Controllare permessi di mysql per questa operazione
	 $dummy_market_subcategoryID = wm3Sql::getFirstRowField(WM3_cCONFIG_DB_PREFIX."_argomenti_mer","arg_merID"); // Exists at least one market subcategory

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_country
                      TO           ".WM3_cCONFIG_DB_PREFIX."_countries";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_province
                      TO           ".WM3_cCONFIG_DB_PREFIX."_states";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_states
                      CHANGE provinceID stateID bigint(20) auto_increment,
					  ADD    countryID          bigint(20) AFTER stateID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_states
                      SET   countryID    = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = 'us')
					  WHERE country_code = 'us'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_states
                      SET   countryID    = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = 'ca')
					  WHERE country_code = 'ca'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_states
                      SET   countryID    = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = 'it')
					  WHERE country_code = 'it'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_states
					  DROP COLUMN country_code";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_lingue
                      TO           ".WM3_cCONFIG_DB_PREFIX."_languages";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_languages
                      CHANGE linguaID languageID bigint(20) auto_increment,
                      CHANGE nome     name       char(255),
                      CHANGE attiva   enabled    int(1)";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_en.png',file = 'language_en.php' WHERE languageID = '".WM3_cLANGUAGE_EN."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_it.png',file = 'language_it.php' WHERE languageID = '".WM3_cLANGUAGE_IT."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_fr.png',file = 'language_fr.php' WHERE languageID = '".WM3_cLANGUAGE_FR."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_de.png',file = 'language_de.php' WHERE languageID = '".WM3_cLANGUAGE_DE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_es.png',file = 'language_es.php' WHERE languageID = '".WM3_cLANGUAGE_ES."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_nl.png',file = 'language_nl.php' WHERE languageID = '".WM3_cLANGUAGE_NL."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_blk
                      TO           ".WM3_cCONFIG_DB_PREFIX."_panels_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                      CHANGE arg_blockID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_pic     icon        char(255),
                      CHANGE ling        languageID  bigint(20),
                      ADD    enabled     int(1)      AFTER icon,
                      ADD    position    int(5)      AFTER categoryID,
                      ADD    ts          int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories
	                  SET ts = UNIX_TIMESTAMP(data), position = '0', enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels_categories
					  DROP COLUMN data,
					  DROP INDEX  arg_name";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_MESSAGES'       WHERE categoryID = '".WM3_cPANEL_CATEGORY_MESSAGES."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_LOGIN'          WHERE categoryID = '".WM3_cPANEL_CATEGORY_LOGIN."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_CHANNELS'       WHERE categoryID = '".WM3_cPANEL_CATEGORY_CHANNELS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SEARCH'         WHERE categoryID = '".WM3_cPANEL_CATEGORY_SEARCH."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_HOROSCOPE'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_HOROSCOPE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_NEWSLETTER'     WHERE categoryID = '".WM3_cPANEL_CATEGORY_NEWSLETTER."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SEND_TO_FRIEND' WHERE categoryID = '".WM3_cPANEL_CATEGORY_SEND_TO_FRIEND."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_LANGUAGES'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_LANGUAGES."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_ECOMMERCE'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_ECOMMERCE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SURVEY'         WHERE categoryID = '".WM3_cPANEL_CATEGORY_SURVEY."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_FORTUNE'        WHERE categoryID = '".WM3_cPANEL_CATEGORY_FORTUNE."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_RSS_FEEDS'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_RSS_FEEDS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_BIRTHDAY'       WHERE categoryID = '".WM3_cPANEL_CATEGORY_BIRTHDAY."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SPECIAL_OFFER'  WHERE categoryID = '".WM3_cPANEL_CATEGORY_SPECIAL_OFFER."'";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_panels_categories VALUES
					  ('','1000','PANEL_CUSTOM','','".WM3_cENABLED."','','$update_ts'),
					  ('','500','PANEL_EXPANSION','','".WM3_cENABLED."','','$update_ts')";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_pag
                      TO           ".WM3_cCONFIG_DB_PREFIX."_pages_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                      CHANGE arg_pagID   categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_pic     icon        char(255),
                      CHANGE ling        languageID  bigint(20),
					  ADD    enabled     int(1)      AFTER icon,
                      ADD    position    int(5)      AFTER categoryID,
                      ADD    ts          int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories
	                  SET ts = UNIX_TIMESTAMP(data), position = '0', enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages_categories
					  DROP COLUMN data,
					  DROP INDEX  arg_name";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_MARKET'            WHERE categoryID = '".WM3_cPAGE_CATEGORY_MARKET."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_FAQ'               WHERE categoryID = '".WM3_cPAGE_CATEGORY_FAQ."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_SEARCH_ENGINE'     WHERE categoryID = '".WM3_cPAGE_CATEGORY_SEARCH_ENGINE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_USER_REGISTRATION' WHERE categoryID = '".WM3_cPAGE_CATEGORY_USER_REGISTRATION."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_LINKS'             WHERE categoryID = '".WM3_cPAGE_CATEGORY_LINKS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_STATISTICS'        WHERE categoryID = '".WM3_cPAGE_CATEGORY_STATISTICS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_USER_INFORMATIONS' WHERE categoryID = '".WM3_cPAGE_CATEGORY_USER_INFORMATIONS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_FORUMS'            WHERE categoryID = '".WM3_cPAGE_CATEGORY_FORUMS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_DOWNLOADS'         WHERE categoryID = '".WM3_cPAGE_CATEGORY_DOWNLOADS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_GUESTBOOKS'        WHERE categoryID = '".WM3_cPAGE_CATEGORY_GUESTBOOKS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_DIRECTORIES'       WHERE categoryID = '".WM3_cPAGE_CATEGORY_DIRECTORIES."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_MEDIA_ALBUMS'      WHERE categoryID = '".WM3_cPAGE_CATEGORY_MEDIA_ALBUMS."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_CONTACT'           WHERE categoryID = '".WM3_cPAGE_CATEGORY_CONTACT."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_CHAT'              WHERE categoryID = '".WM3_cPAGE_CATEGORY_CHAT."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_WEBMAIL'           WHERE categoryID = '".WM3_cPAGE_CATEGORY_WEBMAIL."'";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_pages_categories VALUES
	                  ('','1000','PAGE_CUSTOM','','".WM3_cENABLED."','','$update_ts'),
					  ('','500','PAGE_EXPANSION','','".WM3_cENABLED."','','$update_ts')";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_bar
                      TO           ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                      CHANGE arg_barID   categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_pic     icon        char(255),
                      CHANGE ling        languageID  bigint(20),
					  ADD    enabled     int(1)      AFTER icon,
                      ADD    position    int(5)      AFTER categoryID,
                      ADD    ts          int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
	                  SET ts = UNIX_TIMESTAMP(data), position = '0', enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
					  DROP COLUMN data,
					  DROP INDEX  arg_name";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_CHANNEL'  WHERE categoryID = '".WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_HOME'     WHERE categoryID = '".WM3_cMENU_BAR_ITEM_CATEGORY_HOME."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_ADMIN'    WHERE categoryID = '".WM3_cMENU_BAR_ITEM_CATEGORY_ADMIN."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_USER'     WHERE categoryID = '".WM3_cMENU_BAR_ITEM_CATEGORY_USER."'";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_EXTERNAL' WHERE categoryID = '".WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL."'";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                      VALUES('','1000','MENU_BAR_ITEM_CUSTOM','','".WM3_cENABLED."','','$update_ts')";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_blocchi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_panels";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels
                      CHANGE blockID      panelID    bigint(20) auto_increment,
                      CHANGE titolo       title      char(255),
                      CHANGE testoup      head       text,
                      CHANGE testo        body       text,
                      CHANGE testodown    foot       text,
                      CHANGE posizione    position   int(5),
                      CHANGE allineamento align      int(5),
                      CHANGE ling         languageID bigint(20),
					  ADD    categoryID   bigint(20) AFTER panelID,
					  ADD    extraID      bigint(20) AFTER categoryID,
					  ADD    enabled      int(1)     AFTER tipo,
					  ADD    render_mode  int(5)     AFTER foot,
					  ADD    expansion    char(255)  AFTER foot,
                      ADD    ts           int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      categoryID  = argomento,
						  extraID     = extra,
						  expansion   = '',
					      enabled     = attivo,
	                      ts          = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels
					  DROP COLUMN data,
					  DROP COLUMN argomento,
					  DROP COLUMN extra,
					  DROP COLUMN attivo,
					  DROP COLUMN tipo";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                      SET   categoryID = '".WM3_cPANEL_CATEGORY_CUSTOM."'
                      WHERE categoryID = '0'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_pagine
                      TO           ".WM3_cCONFIG_DB_PREFIX."_pages";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages
                      CHANGE pagID       pageID               bigint(20) auto_increment,
                      CHANGE titolo      title                char(255),
                      CHANGE sottotitolo subtitle             char(255),
                      CHANGE testa       head                 text,
                      CHANGE html        body                 text,
                      CHANGE coda        foot                 text,
                      CHANGE visibilita  visibility           int(5),
                      CHANGE sin         left_panels_enabled  int(1),
                      CHANGE des         right_panels_enabled int(1),
                      CHANGE tipo        page_type            int(5),
                      CHANGE ling        languageID           bigint(20),
					  ADD    categoryID  bigint(20)           AFTER groupID,
					  ADD    backID      bigint(20)           AFTER categoryID,
					  ADD    enabled     int(1)               AFTER hits,
					  ADD    render_mode int(5)               AFTER foot,
					  ADD    expansion   char(255)            AFTER foot,
                      ADD    ts          int(16)              AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
	                  SET ts = UNIX_TIMESTAMP(data), categoryID = argomento, expansion = '', backID = '0', enabled = attivo, render_mode = '".WM3_cRENDER_MODE_HTML."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages
	                  DROP COLUMN data,
					  DROP COLUMN argomento,
					  DROP COLUMN attivo,
					  DROP COLUMN back,
					  DROP COLUMN bcanID,
					  DROP COLUMN arg_canID,
					  DROP COLUMN canID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   left_panels_enabled =  '".WM3_cDISABLED."'
                      WHERE left_panels_enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   right_panels_enabled =  '".WM3_cDISABLED."'
                      WHERE right_panels_enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   categoryID = '".WM3_cPAGE_CATEGORY_CUSTOM."'
                      WHERE categoryID = '0'";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_pages
                       (
                        page_sessionID bigint(20) primary key auto_increment,
                        pageID         bigint(20),
                        sessionID      bigint(20),
                        userID         bigint(20),
                        session_type   int(5)
                       )";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_barra
                      TO           ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      CHANGE barID     menu_bar_itemID bigint(20) auto_increment,
                      CHANGE link      linkID          bigint(20),
                      CHANGE argomento categoryID      bigint(20),
                      CHANGE pos       position        int(5),
                      CHANGE attivo    enabled         int(1),
                      CHANGE ling      languageID      bigint(20),
					  ADD    title     char(255)       AFTER categoryID,
                      ADD    ts        int(16)         AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
	                  SET ts    = UNIX_TIMESTAMP(data),
					      title = name";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
					  DROP COLUMN data,
					  DROP COLUMN name";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      SET   categoryID = '".WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM."'
                      WHERE categoryID = '0'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_utenti
                      TO           ".WM3_cCONFIG_DB_PREFIX."_users";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
                      CHANGE nome                    name        char(255),
                      CHANGE cognome                 surname     char(255),
                      CHANGE indirizzo               address     char(255),
                      CHANGE cap                     zip_code    char(5),
                      CHANGE citta                   city        char(255),
                      CHANGE tel                     phone       char(255),
                      CHANGE sitoweb                 website     char(255),
                      CHANGE natoil                  birth_date  date,
                      CHANGE natoa                   birth_city  char(255),
                      CHANGE sesso                   gender      char(1),
                      CHANGE foto                    avatar      char(255),
                      CHANGE socio                   special     int(1),
                      CHANGE attivo                  enabled     int(1),
                      CHANGE visibile                visible     int(1),
                      CHANGE cancellato              deleted     int(1),
                      CHANGE isadmin                 admin       int(1),
                      CHANGE ling                    languageID  bigint(20),
					  ADD    countryID               bigint(20)  AFTER groupID,
					  ADD    stateID                 bigint(20)  AFTER countryID,
					  ADD    birth_countryID         bigint(20)  AFTER stateID,
					  ADD    birth_stateID           bigint(20)  AFTER birth_countryID,
                      ADD    superuser               int(1)      AFTER admin,
					  ADD    ts                      int(16)     AFTER languageID,
                      ADD    last_user_login_ts      int(16)     AFTER f8,
					  ADD    previous_user_login_ts  int(16)     AFTER last_user_login_ts,
					  ADD    last_admin_login_ts     int(16)     AFTER af40,
					  ADD    previous_admin_login_ts int(16)     AFTER last_admin_login_ts,
					  ADD    notes                   text        AFTER previous_admin_login_ts,
                      DROP COLUMN                    ats,
					  DROP COLUMN                    prov_st,
					  DROP COLUMN                    natopr_st";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
	                  SET ts                      = UNIX_TIMESTAMP(data),
					      last_user_login_ts      = UNIX_TIMESTAMP(lastlog),
						  previous_user_login_ts  = UNIX_TIMESTAMP(lastlog),
						  last_admin_login_ts     = UNIX_TIMESTAMP(alastlog),
						  previous_admin_login_ts = UNIX_TIMESTAMP(alastlog),
						  notes                   = note,
						  countryID               = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = state),
						  birth_countryID         = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = bstate),
						  stateID                 = (SELECT stateID   FROM ".WM3_cCONFIG_DB_PREFIX."_states    WHERE code = prov
						                             AND countryID = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = state)),
						  birth_stateID           = (SELECT stateID   FROM ".WM3_cCONFIG_DB_PREFIX."_states    WHERE code = natopr
						                             AND countryID = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = bstate))";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
	                  DROP COLUMN newsletter,
					  DROP COLUMN data,
					  DROP COLUMN lastlog,
					  DROP COLUMN alastlog,
					  DROP COLUMN note,
					  DROP COLUMN state,
					  DROP COLUMN bstate,
					  DROP COLUMN prov,
					  DROP COLUMN natopr";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET countryID       = '0' WHERE countryID IS NULL";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET birth_countryID = '0' WHERE birth_countryID IS NULL";
	 $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET stateID         = '0' WHERE stateID IS NULL";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET birth_stateID   = '0' WHERE birth_stateID IS NULL";			  
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   special =  '".WM3_cDISABLED."'
                      WHERE special != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   visible =  '".WM3_cDISABLED."'
                      WHERE visible != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   deleted =  '".WM3_cDISABLED."'
                      WHERE deleted != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   admin =  '".WM3_cDISABLED."'
                      WHERE admin != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   superuser = '".WM3_cDISABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET password = MD5(password)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
                      CHANGE password password char(32)";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_bbs
                      TO           ".WM3_cCONFIG_DB_PREFIX."_users_messages";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users_messages
					  CHANGE bbsID           messageID             bigint(20) auto_increment,
                      CHANGE oggetto         subject               char(255),
                      CHANGE testo           message               text,
					  CHANGE flag            message_read          int(1),
					  CHANGE pri             message_high_priority int(1),
                      CHANGE attivo          enabled               int(1),
                      CHANGE ling            languageID            bigint(20),
					  ADD    ts              int(16)               AFTER languageID,
					  ADD    message_replied int(1)                AFTER message_read";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                  SET ts = UNIX_TIMESTAMP(data), message_replied = '".WM3_cDISABLED."', message_read = !message_read, enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users_messages
					  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_gruppi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_groups";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_groups
                      CHANGE nome        name        char(255),
                      CHANGE descrizione description text,
                      CHANGE pic         icon        char(255),
                      CHANGE attivo      enabled     int(1),
                      CHANGE ling        languageID  bigint(20),
					  CHANGE ts          temp        int(16),
					  CHANGE data        ts          int(16),
					  DROP COLUMN tipo";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_groups SET ts = temp";
     $_QUERY_UPD[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_groups DROP COLUMN temp";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_messaggi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_messages";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_messages
                      CHANGE msgID       messageID  bigint(20) auto_increment,
                      CHANGE testo       message    text,
                      CHANGE attivo      enabled    int(1),
                      CHANGE ling        languageID bigint(20),
					  ADD    categoryID  bigint(20) AFTER messageID,
					  ADD    render_mode int(5)     AFTER message,
					  ADD    message_ts  int(16)    AFTER render_mode,
                      ADD    ts          int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      categoryID  = argomento,
					      message_ts  = UNIX_TIMESTAMP(immesso),
					      ts          = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_messages
	                  DROP COLUMN immesso,
					  DROP COLUMN argomento,
					  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_oroscopo
                      TO           ".WM3_cCONFIG_DB_PREFIX."_horoscopes";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                      CHANGE orosID      horoscopeID bigint(20) auto_increment,
                      CHANGE testo       message     text,
                      CHANGE ling        languageID  bigint(20),
					  ADD    render_mode int(5)      AFTER message,
                      ADD    ts          int(16)     AFTER languageID,
                      ADD    enabled     int(1)      AFTER p8";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_horoscopes
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  enabled     = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_horoscopes
	                  DROP COLUMN lastuse,
					  DROP COLUMN data,
				      DROP COLUMN lastuserID";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies
                       (
                        horoscope_dailyID bigint(20) primary key auto_increment,
                        horoscopeID       bigint(20),
						sign              int(5),
                        expire_ts         int(16),
						enabled           int(1),
						languageID        bigint(20),
						ts                int(16)
                       )";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_fortune
                      TO           ".WM3_cCONFIG_DB_PREFIX."_quotes";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_quotes
                      CHANGE fortuneID  quoteID     bigint(20) auto_increment,
                      CHANGE testo      quote       text,
                      CHANGE autore     author      char(255),
                      CHANGE anno       year        char(255),
                      CHANGE mestiere   occupation  char(255),
                      CHANGE url_autore author_url  char(255),
                      CHANGE ling       languageID  bigint(20),
					  ADD    render_mode int(5)     AFTER quote,
                      ADD    ts         int(16)     AFTER languageID,
                      ADD    enabled    int(1)      AFTER author_url";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_quotes
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  enabled     = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_quotes
	                  DROP COLUMN lastuse,
					  DROP COLUMN data,
					  DROP COLUMN lastuserID";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_not
                      TO           ".WM3_cCONFIG_DB_PREFIX."_news_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news_categories
                      CHANGE arg_notID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE ling      languageID  bigint(20),
                      ADD    enabled   int(1)      AFTER icon,
					  ADD    ts        int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news_categories
					  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_notizie
                      TO           ".WM3_cCONFIG_DB_PREFIX."_news";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news
                      CHANGE notID       newsID     bigint(20) auto_increment,
                      CHANGE autore      userID     bigint(20),
                      CHANGE titolo      title      char(255),
                      CHANGE testo       news       text,
                      CHANGE ling        languageID bigint(20),
					  ADD    render_mode int(5)     AFTER news,
                      ADD    categoryID  bigint(20) AFTER newsID,
					  ADD    news_ts     int(16)    AFTER hits,
					  ADD    enabled     int(1)     AFTER news_ts,
					  ADD    ts          int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
	                  SET render_mode = '".WM3_cRENDER_MODE_PLAIN_TEXT."',
					      categoryID  = argomento,
						  enabled     = attiva,
					      news_ts     = UNIX_TIMESTAMP(CONCAT(data,' ',ora)),
					      ts          = UNIX_TIMESTAMP(CONCAT(data,' ',ora))";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news
	                  DROP COLUMN argomento,
					  DROP COLUMN attiva,
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                      SET   userID      = '$users_next_auto_increment',
					        render_mode = '".WM3_cRENDER_MODE_HTML."'
                      WHERE userID = '0'";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_news
                       (
                        news_sessionID bigint(20) primary key auto_increment,
                        newsID         bigint(20),
                        sessionID      bigint(20),
                        userID         bigint(20),
                        session_type   int(5)
                       )";

     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_newsletters
                      CHANGE oggetto             subject           char(255),
					  CHANGE testo               newsletter        text,
                      CHANGE formato             newsletter_format int(5),
                      CHANGE num_email           emails_sended     int(16),
                      CHANGE ling                languageID        bigint(20),
					  CHANGE ts                  temp              int(16),
					  CHANGE data                ts                int(16),
					  ADD    ignore_disabled     int(1)     AFTER  newsletterID,
					  ADD    user_gender         int(5)     AFTER  newsletterID,
					  ADD    newsletter_target   int(5)     AFTER  newsletterID,
					  ADD    newsletter_use_foot int(1)     AFTER  newsletter,
					  ADD    groupID             bigint(20) AFTER  newsletterID,
					  ADD    enabled             int(1)     AFTER  emails_sended,
					  DROP COLUMN simulazione";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters
	                  SET ignore_disabled     = '".WM3_cENABLED."',
					      newsletter_use_foot = '".WM3_cENABLED."',
						  user_gender         = '".WM3_cUSER_ALL."',
						  newsletter_target   = '".WM3_cNEWSLETTER_TARGET_MEMBERS."',
						  ts                  = temp,
						  groupID             = '0',
						  enabled             = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters DROP COLUMN temp";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_news_email
                      TO           ".WM3_cCONFIG_DB_PREFIX."_newsletters_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                      CHANGE nemailID newsletter_itemID bigint(20) auto_increment,
                      CHANGE ling     languageID  bigint(20),
                      ADD    ts       int(16)     AFTER languageID,
                      ADD    enabled  int(1)      AFTER email";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_ass
                      TO           ".WM3_cCONFIG_DB_PREFIX."_faqs_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
                      CHANGE arg_assID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE ling      languageID  bigint(20),
                      ADD    ts        int(16)     AFTER languageID,
                      ADD    enabled   int(1)      AFTER icon";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_assistenza
                      TO           ".WM3_cCONFIG_DB_PREFIX."_faqs";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs
                      CHANGE assID       faqID      bigint(20) auto_increment,
                      CHANGE domanda     question   char(255),
                      CHANGE risposta    answer     text,
                      CHANGE attivo      enabled    int(1),
                      CHANGE ling        languageID bigint(20),
					  ADD    render_mode int(5)     AFTER answer,
					  ADD    categoryID  bigint(20) AFTER faqID,
                      ADD    ts          int(16)    AFTER languageID,
					  DROP INDEX         domanda";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  categoryID  = argomento";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs
	                  DROP COLUMN data,
					  DROP COLUMN argomento";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_lin
                      TO           ".WM3_cCONFIG_DB_PREFIX."_links_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links_categories
                      CHANGE arg_linID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE ling      languageID  bigint(20),
                      ADD    ts        int(16)     AFTER languageID,
                      ADD    enabled   int(1)      AFTER icon";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_links_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links_categories
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links
                      CHANGE linID       linkID      bigint(20) auto_increment,
                      CHANGE titolo      title       char(255),
					  CHANGE url         url         char(255),
                      CHANGE descrizione description text,
                      CHANGE attivo      enabled     int(1),
                      CHANGE ling        languageID  bigint(20),
					  ADD    render_mode int(5)      AFTER description,
					  ADD    categoryID  bigint(20)  AFTER linkID,
                      ADD    ts          int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  categoryID  = argomento";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links
	                  DROP COLUMN data,
					  DROP COLUMN argomento";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_ricerca
                      TO           ".WM3_cCONFIG_DB_PREFIX."_search_engines_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                      CHANGE ricID       search_engine_itemID bigint(20) auto_increment,
                      CHANGE descrizione description          char(255),
                      CHANGE ling        languageID           bigint(20),
                      ADD    ts          int(16)              AFTER languageID,
                      ADD    enabled     int(1)               AFTER description";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_prod
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
                      CHANGE arg_prodID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name   name        char(255),
                      CHANGE arg_pic    icon        char(255),
                      CHANGE attivo     enabled     int(1),
                      CHANGE ling       languageID  bigint(20),
                      ADD    ts         int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_subargomenti_prod
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
                      CHANGE arg_subprodID subcategoryID bigint(20) auto_increment,
                      CHANGE arg_prodID    categoryID    bigint(20), 
                      CHANGE arg_name      name          char(255),
                      CHANGE arg_pic       icon          char(255),
                      CHANGE attivo        enabled       int(1),
                      CHANGE ling          languageID    bigint(20),
                      ADD    ts            int(16)       AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_prodotti
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      CHANGE prodID        productID         bigint(20) auto_increment,
                      CHANGE arg_subprodID subcategoryID     bigint(20),
                      CHANGE codice        code              char(255),
                      CHANGE nome          name              char(255),
                      CHANGE desc_breve    description       char(255),
                      CHANGE desc_lunga    full_description  text,
                      CHANGE posizione     align             int(5),
                      CHANGE prezzo        price             double,
                      CHANGE desc_prezzo   price_description char(255),
                      CHANGE sconto        discount          int(5),
                      CHANGE special       special           int(1),
                      CHANGE numero        stock             int(16),
                      CHANGE disp          availability      int(5),
                      CHANGE opzioni       options           text,
                      CHANGE attivo        enabled           int(1),
                      CHANGE ling          languageID        bigint(20),
					  ADD    render_mode   int(5)            AFTER full_description,
                      ADD    ts            int(16)           AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
	                  SET render_mode = '".WM3_cRENDER_MODE_PLAIN_TEXT."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      SET   special =  '".WM3_cDISABLED."'
                      WHERE special != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      SET   userID      = '$users_next_auto_increment',
					        render_mode = '".WM3_cRENDER_MODE_HTML."'
                      WHERE userID = '0'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_prodotti_pic
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      CHANGE ppicID pictureID   bigint(20) auto_increment,
                      CHANGE prodID productID   bigint(20),
                      CHANGE pic    picture     char(255),
                      CHANGE tpic   thumbnail   char(255),
                      CHANGE descr  description char(255),
                      CHANGE attivo enabled     int(1),
                      CHANGE ling   languageID  bigint(20),
                      ADD    ts     int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      SELECT '',productID,pic,tpic,alt,'".WM3_cENABLED."','0',ts
					  FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
	                  DROP COLUMN pic,
					  DROP COLUMN tpic,
					  DROP COLUMN alt";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_ordini
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                      CHANGE ordID         orderID    bigint(20) auto_increment,
					  CHANGE stato         status     int(5),
                      CHANGE ling          languageID bigint(20),
					  CHANGE ts_ordine     order_ts   int(16),
                      ADD    ts            int(16)    AFTER languageID,
					  ADD    enabled       int(1)     AFTER status,
					  ADD    shipping_cost double     AFTER status";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                  SET order_ts      = UNIX_TIMESTAMP(data),
					      ts            = UNIX_TIMESTAMP(data),
						  status        = status + 1,
						  shipping_cost = (SELECT spese_sped FROM ".WM3_cCONFIG_DB_PREFIX."_pref),
						  enabled       = '".WM3_cENABLED."',
						  languageID    = '".WM3_cLANGUAGE_EN."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
					  DROP COLUMN data,
					  DROP COLUMN carrID";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_carrello
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                      CHANGE carrID              cart_itemID bigint(20) auto_increment,
                      CHANGE prodID              productID   bigint(20),
					  CHANGE ordID               orderID     bigint(20),
                      CHANGE opzioni             options     text,
                      CHANGE quantita            quantity    int(16),
                      CHANGE prezzo              price       double,
                      CHANGE sconto              discount    int(5),
					  CHANGE attivo              enabled     int(1),
                      CHANGE ling                languageID  bigint(20),
					  ADD    product_description char(255)   AFTER orderID,
					  ADD    product_name        char(255)   AFTER orderID,
					  ADD    product_code        char(255)   AFTER orderID,
					  ADD    ts                  int(16)     AFTER data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
					  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                      SET   enabled =  '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                  SET product_code        = (SELECT code        FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.productID),
	                      product_name        = (SELECT name        FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.productID),
					      product_description = (SELECT description FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.productID)";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_comm_userfld
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                      CHANGE userfID      fieldID    bigint(20) auto_increment,
                      CHANGE tipo         type       int(5),
                      CHANGE lunghezza    size       int(16),
					  CHANGE appare       show_in    int(5),
					  CHANGE obbligatorio required   int(1),
					  CHANGE attivo       enabled    int(1),
                      CHANGE ling         languageID bigint(20),
                      ADD    ts           int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                      SET   required =  '".WM3_cDISABLED."'
                      WHERE required != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_comm_userlab
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
                      CHANGE userlID labelID    bigint(20) auto_increment,
					  CHANGE userfID fieldID    bigint(20),
					  CHANGE attivo  enabled    int(1),					  
                      CHANGE ling    languageID bigint(20),
                      ADD    ts      int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_comm_userdat
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                      CHANGE userdID dataID     bigint(20) auto_increment,
					  CHANGE prodID  productID  bigint(20),
					  CHANGE userfID fieldID    bigint(20),
					  CHANGE valore  value      char(255),					  
                      CHANGE ling    languageID bigint(20),
					  ADD    enabled int(1)     AFTER value,
                      ADD    ts      int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
	                  SET ts = UNIX_TIMESTAMP(data), enabled  = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_survey
                      TO           ".WM3_cCONFIG_DB_PREFIX."_surveys";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys
                      CHANGE surID       surveyID    bigint(20) auto_increment,
                      CHANGE titolo      title       char(255),
                      CHANGE domanda     question    text,
                      CHANGE target      target_type int(5),
                      CHANGE pubblico    result_type int(5),
                      CHANGE layout      layout_type int(5),
                      CHANGE attivo      enabled     int(1),
                      CHANGE ling        languageID  bigint(20),
					  ADD    render_mode int(5)      AFTER question,
                      ADD    ts          int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_survey_item
                      TO           ".WM3_cCONFIG_DB_PREFIX."_surveys_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                      CHANGE sitID       survey_itemID bigint(20) auto_increment,
                      CHANGE surID       surveyID      char(255),
                      CHANGE risposta    answer        text,
                      CHANGE attivo      enabled       int(1),
                      CHANGE ling        languageID    bigint(20),
					  CHANGE hits        votes         int(16),
					  ADD    render_mode int(5)        AFTER answer,
                      ADD    ts          int(16)       AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys_items
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_survey_sess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                      CHANGE sseID         survey_sessionID bigint(20) auto_increment,
					  ADD    survey_itemID bigint(20)       AFTER surveyID,
                      ADD    session_type  int(5)           AFTER userID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
	                  SET survey_itemID = surItemID,
					      session_type  = '".WM3_cSESSION_VOTE."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
					  DROP COLUMN surItemID";

     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_metatags
                      CHANGE ling languageID bigint(20)";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_webmail_server
                      TO           ".WM3_cCONFIG_DB_PREFIX."_webmail_servers";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      CHANGE nome       name                    char(255),
                      CHANGE suffix     in_suffix               char(255),
                      CHANGE usesuffix  in_use_suffix           int(1),
                      CHANGE address    in_address              char(255),
                      CHANGE port       in_port                 int(16),
                      CHANGE protocol   in_protocol             int(5),
                      CHANGE outlogin   out_login               char(255),
                      CHANGE outpwd     out_password            char(255),
                      CHANGE outaddress out_address             char(255),
                      CHANGE outport    out_port                int(16),
                      CHANGE outtipo    out_authentication_type int(5),
                      CHANGE outuse     out_use_internal        int(1),
                      CHANGE visibilita visibility              int(5),
                      CHANGE attivo     enabled                 int(1),
                      CHANGE ling       languageID              bigint(20),
                      ADD    ts         int(16)                 AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
	                  SET ts          = UNIX_TIMESTAMP(data),
					      in_protocol = '".WM3_cWEBMAIL_SERVER_PROTOCOL_POP3."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      SET   out_use_internal =  '".WM3_cDISABLED."'
                      WHERE out_use_internal != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      SET   in_use_suffix =  '".WM3_cDISABLED."'
                      WHERE in_use_suffix != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_can
                      TO           ".WM3_cCONFIG_DB_PREFIX."_channels_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                      CHANGE arg_canID categoryID bigint(20) auto_increment,
                      CHANGE arg_name  name       char(255),
                      CHANGE arg_pic   icon       char(255),
                      CHANGE attivo    enabled    int(1),
                      CHANGE ling      languageID bigint(20),
                      ADD    ts        int(16)    AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_canali
                      TO           ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                      CHANGE canID      subcategoryID bigint(20) auto_increment,
                      CHANGE pic        icon          char(255),
                      CHANGE attivo     enabled       int(1),
                      CHANGE ling       languageID    bigint(20),
					  ADD    categoryID bigint(20)    AFTER subcategoryID,
                      ADD    ts         int(16)       AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
	                  SET categoryID = argomento,
	                      ts         = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
	                  DROP COLUMN data,
					  DROP COLUMN argomento";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_blocchi_can
                      TO           ".WM3_cCONFIG_DB_PREFIX."_channels_blocks";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      CHANGE bcanID        blockID       bigint(20) auto_increment,
                      CHANGE tipo          block_type    int(5),
                      CHANGE titolo        title         char(255),
					  CHANGE alt           alt           char(255),
                      CHANGE testo         description   text,
                      CHANGE pic           picture       char(255),
                      CHANGE attivo        enabled       int(1),
                      CHANGE ling          languageID    bigint(20),
					  ADD    render_mode   int(5)        AFTER description,
					  ADD    picture_align int(5)        AFTER picture,
					  ADD    linkID        bigint(20)    AFTER blockID,
					  ADD    subcategoryID bigint(20)    AFTER blockID,
                      ADD    ts            int(16)       AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
	                  SET render_mode   = '".WM3_cRENDER_MODE_HTML."',
					      linkID        = link,
					      picture_align = posizione,
					      subcategoryID = canID,
					      ts            = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
	                  DROP COLUMN canID,
					  DROP COLUMN link,
	                  DROP COLUMN arg_canID,
					  DROP COLUMN posizione,
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      SET   picture_align = '".WM3_cNO_IMAGE."'
                      WHERE picture_align = '".WM3_cALIGN_RIGHT."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      SET   picture_align = '".WM3_cALIGN_RIGHT."'
                      WHERE picture_align = '".WM3_cALIGN_CENTER."'";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_market_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";
	 if($dummy_market_subcategoryID)
	  {
       $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_market_categories
	                    VALUES('','Temp category','bomb.png','".WM3_cENABLED."','".WM3_cLANGUAGE_EN."','$update_ts')";
	  }

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_mer
                      TO           ".WM3_cCONFIG_DB_PREFIX."_market_subcategories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
                      CHANGE arg_merID  subcategoryID bigint(20) auto_increment,                       
                      CHANGE arg_name   name       char(255),
                      CHANGE arg_pic    icon       char(255),
                      CHANGE ling       languageID bigint(20),
					  ADD    categoryID bigint(20) AFTER subcategoryID,
                      ADD    ts         int(16)    AFTER languageID,
                      ADD    enabled    int(1)     AFTER icon";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
	                  SET ts         = UNIX_TIMESTAMP(data),
					      categoryID = '1',
					      enabled    = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_mercatino
                      TO           ".WM3_cCONFIG_DB_PREFIX."_market_announcements";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                      CHANGE merID        announcementID    bigint(20) auto_increment,
                      CHANGE testo        announcement      text,
                      CHANGE tipo         announcement_type int(5),
					  CHANGE semprevalido always_valid      int(1),
                      CHANGE ling         languageID        bigint(20),
					  DROP COLUMN         nome,
					  DROP COLUMN         cognome,
					  DROP COLUMN         citta,
					  DROP COLUMN         prov,
					  DROP COLUMN         prov_st,
                      DROP COLUMN         sesso,
					  DROP COLUMN         email,
                      DROP COLUMN         state,
                      ADD  ts             int(16)           AFTER languageID,
					  ADD  title          char(255)         AFTER announcement,
					  ADD  render_mode    int(5)            AFTER announcement,
					  ADD  userID         bigint(20)        AFTER announcementID,
                      ADD  enabled        int(1)            AFTER always_valid,
                      ADD  subcategoryID  bigint(20)        AFTER announcementID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements
	                  SET render_mode   = '".WM3_cRENDER_MODE_PLAIN_TEXT."',
					      ts            = UNIX_TIMESTAMP(data),
					      subcategoryID = argomento,
					      title         = '',
						  enabled       = '".WM3_cENABLED."',
						  userID        = '$users_next_auto_increment'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_announcements
	                  DROP COLUMN argomento,
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_dow
                      TO           ".WM3_cCONFIG_DB_PREFIX."_downloads_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
                      CHANGE arg_downID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name   name        char(255),
                      CHANGE arg_desc   description char(255),
                      CHANGE arg_pic    icon        char(255),
                      CHANGE ling       languageID  bigint(20),
                      ADD    ts         int(16)     AFTER languageID,
                      ADD    enabled    int(1)      AFTER icon";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_download_sub
                      TO           ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
                      CHANGE sub_downID subcategoryID bigint(20) auto_increment,
                      CHANGE arg_downID categoryID    bigint(20),
                      CHANGE sub_name   name          char(255),
                      CHANGE sub_desc   description   char(255),
                      CHANGE ling       languageID    bigint(20),
                      ADD    ts         int(16)       AFTER languageID,
                      ADD    icon       char(255)     AFTER description,
                      ADD    enabled    int(1)        AFTER icon";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
	                  SET ts = UNIX_TIMESTAMP(data), icon = '', enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
	                  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_download
                      TO           ".WM3_cCONFIG_DB_PREFIX."_downloads";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads
                      CHANGE downID      downloadID    bigint(20) auto_increment,
                      CHANGE sub_downID  subcategoryID bigint(20),
                      CHANGE down_name   name          char(255),
                      CHANGE down_desc   description   text,
                      CHANGE link        download      char(255),
                      CHANGE tipo        source        int(5),                   
                      CHANGE attivo      enabled       int(1),
                      CHANGE ling        languageID    bigint(20),
					  ADD    render_mode int(5)        AFTER description,
                      ADD    ts          int(16)       AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads
	                  DROP COLUMN arg_downID,
	                  DROP COLUMN size,
					  DROP COLUMN usize,
	                  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   source = '0'
                      WHERE source = '".WM3_cUPLOAD_FROM_URL."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   source = '".WM3_cUPLOAD_FROM_URL."'
                      WHERE source = '".WM3_cUPLOAD_FROM_REMOTE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   source = '".WM3_cUPLOAD_FROM_REMOTE."'
                      WHERE source = '0'";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads
                       (
                        download_sessionID bigint(20) primary key auto_increment,
                        downloadID         bigint(20),
                        sessionID          bigint(20),
                        userID             bigint(20),
                        session_type       int(5)
                       )";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_commenti
                      TO           ".WM3_cCONFIG_DB_PREFIX."_news_comments";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news_comments
                      CHANGE comID       commentID  bigint(20) auto_increment,
                      CHANGE notID       newsID     bigint(20),
                      CHANGE testo       comment    text,
                      CHANGE attiva      enabled    int(1),
                      CHANGE ling        languageID bigint(20),
					  CHANGE ts          temp       int(16),
					  CHANGE data        ts         int(16),
					  ADD    render_mode int(5)     AFTER comment";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_comments
	                  SET render_mode = '".WM3_cRENDER_MODE_PLAIN_TEXT."', ts = temp";
     $_QUERY_UPD[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news_comments DROP COLUMN temp";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_comments
                      SET   userID      = '$users_next_auto_increment', 
					        render_mode = '".WM3_cRENDER_MODE_HTML."'
                      WHERE userID      = '-1'";

     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions
                      CHANGE sesID   sessionID  bigint(20) auto_increment,
                      CHANGE codice  hash       char(255),
                      CHANGE expire  expire_ts  int(16),
					  ADD    tempID  bigint(20) AFTER sessionID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions
	                  SET tempID = userID";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions
	                  DROP COLUMN userID";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions
                      CHANGE tempID userID bigint(20)";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_actions
                       (
                        actionID  bigint(20) primary key auto_increment,
                        sessionID bigint(20),
                        action_ts int(16)
                       )";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers
                       (
                        browserID  bigint(20) primary key auto_increment,
                        name       char(255),
                        hits       bigint(20) unsigned,
                        icon       char(255),
                        ts         int(16)
                       )";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers
                      VALUES ('','Other',            (SELECT altro     FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_other.png',        '$update_ts'),
                             ('','Search engine',    (SELECT ricerca   FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_search_engine.png','$update_ts'),
                             ('','Internet explorer',(SELECT ie        FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_ie.png',           '$update_ts'),
							 ('','Mozilla',          '0',                                                      'browser_mozilla.png',      '$update_ts'),
							 ('','Google chrome',    '0',                                                      'browser_chrome.png',       '$update_ts'),
                             ('','Netscape',         (SELECT netscape  FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_netscape.png',     '$update_ts'),
                             ('','Opera',            (SELECT opera     FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_opera.png',        '$update_ts'),
                             ('','Konqueror',        (SELECT konqueror FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_konqueror.png',    '$update_ts'),
                             ('','IBrowse',          (SELECT ibrowse   FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_ibrowse.png',      '$update_ts'),
                             ('','Lynx',             (SELECT lynx      FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_lynx.png',         '$update_ts'),
                             ('','WebTV',            (SELECT webtv     FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_webtv.png',        '$update_ts')";
     $_QUERY_UPD[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_br_stat";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses
                       (
                        osID       bigint(20) primary key auto_increment,
                        name       char(255),
                        hits       bigint(20) unsigned,
                        icon       char(255),
                        ts         int(16)
                       )";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_statistics_oses
                      VALUES ('','Other',   (SELECT altro   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_other.png',  '$update_ts'),
                             ('','Windows', (SELECT windows FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_windows.png','$update_ts'),
                             ('','Linux',   (SELECT linux   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_linux.png',  '$update_ts'),
                             ('','Mac OS',  (SELECT macos   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_macos.png',  '$update_ts'),
                             ('','Sun OS',  (SELECT sunos   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_sunos.png',  '$update_ts'),
                             ('','Be OS',   (SELECT beos    FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_beos.png',   '$update_ts'),
                             ('','Amiga OS',(SELECT amigaos FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_amigaos.png','$update_ts'),
                             ('','AIX',     (SELECT aix     FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_aix.png',    '$update_ts'),
                             ('','Free BSD',(SELECT freebsd FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_freebsd.png','$update_ts'),
                             ('','Irix',    (SELECT irix    FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_irix.png',   '$update_ts'),
                             ('','OS 2',    (SELECT os2     FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_os2.png',    '$update_ts')";
     $_QUERY_UPD[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_os_stat";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_for
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                      CHANGE arg_forumID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_desc    description char(255),                         
                      CHANGE arg_pic     icon        char(255),
                      CHANGE attivo      enabled     int(1),                         
                      CHANGE ling        languageID  bigint(20),
                      ADD    ts          int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories
	                  SET ts = UNIX_TIMESTAMP(CONCAT(data,' ',ora))";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_forum
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums
                      CHANGE titolo         title        char(255),
                      CHANGE attivo         enabled      int(1),
                      CHANGE ling           languageID   bigint(20),
                      CHANGE userID         temp_userID  bigint(20),
                      ADD    ts             int(16)      AFTER languageID,
                      ADD    visitors_open  int(1)       AFTER topic,
                      ADD    visitors_write int(1)       AFTER topic,
                      ADD    visitors_read  int(1)       AFTER topic,
                      ADD    users_open     int(1)       AFTER topic,
                      ADD    users_write    int(1)       AFTER topic,
                      ADD    users_read     int(1)       AFTER topic,
                      ADD    group_open     int(1)       AFTER topic,
					  ADD    categoryID     bigint(20)   AFTER forumID,
					  ADD    userID         bigint(20)   AFTER categoryID,
					  ADD    denied_words   text         AFTER visitors_open,
					  ADD    expire_days    int(16)      AFTER visitors_open";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
	                  SET ts             = UNIX_TIMESTAMP(CONCAT(data,' ',ora)),
					      visitors_open  = '".WM3_cENABLED."',
						  visitors_write = '".WM3_cENABLED."',
						  visitors_read  = '".WM3_cENABLED."',
						  users_open     = '".WM3_cENABLED."',
						  users_write    = '".WM3_cENABLED."',
						  users_read     = '".WM3_cENABLED."',
						  group_open     = '".WM3_cENABLED."',
						  categoryID     = arg_forumID,
						  userID         = temp_userID,
						  expire_days    = expiredays,
						  denied_words   = badwords";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   visitors_open = '".WM3_cDISABLED."'
                      WHERE write_dis != 1";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   visitors_write = '".WM3_cDISABLED."'
                      WHERE visibilita != 1";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   visitors_read = '".WM3_cDISABLED."'
                      WHERE visibilita = 3 OR visibilita > 4";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   users_open = '".WM3_cDISABLED."'
                      WHERE write_dis > 2";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   users_write = '".WM3_cDISABLED."'
                      WHERE visibilita > 4";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   users_read = '".WM3_cDISABLED."'
                      WHERE visibilita = 6";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   group_open = '".WM3_cDISABLED."'
                      WHERE write_dis > 3";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums
	                  DROP COLUMN arg_forumID,
					  DROP COLUMN temp_userID,
					  DROP COLUMN groupID,
					  DROP COLUMN expiredays,
					  DROP COLUMN badwords,
	                  DROP COLUMN visibilita,
                      DROP COLUMN write_dis,
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";

     $_QUERY_UPD[] = "DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forum_reply
                      WHERE  fraseID NOT IN (SELECT fraseID FROM ".WM3_cCONFIG_DB_PREFIX."_forum_frasi)";
     $_QUERY_UPD[] = "DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forum_read
                      WHERE  fraseID NOT IN (SELECT fraseID FROM ".WM3_cCONFIG_DB_PREFIX."_forum_frasi)";
     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_forum_reply
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums_posts";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      CHANGE replyID     postID       bigint(20) auto_increment,
					  CHANGE qreplyID    quoteID      bigint(20),
                      CHANGE testo       post         text,
                      CHANGE fraseID     discussionID bigint(20) AFTER postID,
                      CHANGE userID      userID       bigint(20) AFTER quoteID,
                      CHANGE forumID     forumID      bigint(20) AFTER discussionID,
					  ADD    title       char(255)    AFTER userID,
					  ADD    locked      int(1)       AFTER post,
					  ADD    render_mode int(5)       AFTER post,
                      ADD    hits        int(16)      AFTER locked,
                      ADD    enabled     int(1)       AFTER hits,
                      ADD    languageID  bigint(20)   AFTER enabled,
					  ADD    ts          int(16)      AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  SET render_mode = '".WM3_cRENDER_MODE_BB_CODE."',
					  ts              = UNIX_TIMESTAMP(CONCAT(data,' ',ora))";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  SET discussionID = (
					                      SELECT COUNT(*)
						                  FROM  ".WM3_cCONFIG_DB_PREFIX."_forum_frasi
						 				  WHERE ".WM3_cCONFIG_DB_PREFIX."_forum_frasi.fraseID <= discussionID
										 ) + $forums_posts_total";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  DROP COLUMN groupID,
					  DROP COLUMN censurato,
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      SELECT '','0',forumID,'0',userID,titolo,testo,'".WM3_cRENDER_MODE_BB_CODE."',locked,hits,'".WM3_cENABLED."','".WM3_cLANGUAGE_ALL."',UNIX_TIMESTAMP(CONCAT(data,' ',ora))
					  FROM   ".WM3_cCONFIG_DB_PREFIX."_forum_frasi
					  ORDER BY fraseID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  SET enabled = '".WM3_cENABLED."', languageID = '".WM3_cLANGUAGE_ALL."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET title  = ''                  WHERE title  IS NULL";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET hits   = '0'                 WHERE hits   IS NULL";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET locked = '".WM3_cDISABLED."' WHERE locked IS NULL";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '-1'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_forum_read
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
	                  ADD    readID  bigint(20) primary key auto_increment FIRST,
                      CHANGE fraseID postID bigint(20)";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '-1'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
	                  SET postID = (
					                SELECT COUNT(*)
						            FROM  ".WM3_cCONFIG_DB_PREFIX."_forum_frasi
						 		    WHERE ".WM3_cCONFIG_DB_PREFIX."_forum_frasi.fraseID <= postID
								   ) + $forums_posts_total";
     $_QUERY_UPD[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_forum_frasi";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts
                       (
                        forum_post_sessionID bigint(20) primary key auto_increment,
                        forum_postID         bigint(20),
                        sessionID            bigint(20),
                        userID               bigint(20),
                        session_type         int(5)
                       )";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_rooms
                      TO           ".WM3_cCONFIG_DB_PREFIX."_chatrooms";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                      CHANGE roomID       chatroomID  bigint(20) auto_increment,
                      CHANGE nome         name        char(255),
                      CHANGE descr        topic       text,
                      CHANGE visibilita   visibility  int(5),
                      CHANGE ling         languageID  bigint(20),
                      ADD    enabled      int(1)      AFTER visibility,
                      DROP COLUMN         data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                      SET    enabled = '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_speak
                      TO           ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
                      CHANGE roomID       chatroomID  bigint(20),
                      CHANGE nick         nickname    char(255),
                      CHANGE frase        sentence    text,
                      CHANGE ling         languageID  bigint(20),
					  ADD    enabled      int(1)      AFTER sentence,
					  ADD    sentenceID   bigint(20)  primary key auto_increment FIRST";
     $_QUERY_UPD[] = "TRUNCATE TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_roomsess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                      CHANGE roomID             chatroomID bigint(20),
                      CHANGE nick               nickname   char(255),
					  CHANGE ts                 join_ts    int(16),
					  ADD    chatroom_sessionID bigint(20) primary key auto_increment FIRST,
					  ADD    ip                 char(255)  AFTER nickname,
					  ADD    expire_ts          int(16)    AFTER join_ts,
					  DROP COLUMN               csessID,
					  DROP COLUMN               stato,
					  DROP INDEX ts,
					  ADD  INDEX (join_ts)";
     $_QUERY_UPD[] = "TRUNCATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms";
	 $_QUERY_UPD[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_sess";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_alb
                      TO           ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                      CHANGE arg_albID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_desc  description char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE attivo    enabled     int(1),
                      CHANGE ling      languageID  bigint(20),
                      ADD    ts        int(16)     AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
					  DROP COLUMN data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_album
                      TO           ".WM3_cCONFIG_DB_PREFIX."_media_albums";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      CHANGE albumID       media_albumID    bigint(20) auto_increment,
                      CHANGE titolo        title            char(255),
                      CHANGE argomento     categoryID       bigint(20),
                      CHANGE descr         description      char(255),
                      CHANGE pic           icon             char(255),
                      CHANGE tipo          media_album_type int(5),
                      CHANGE attivo        enabled          int(1), 
                      CHANGE ling          languageID       bigint(20),
                      ADD    visitors_read int(1)           AFTER visibilita,
					  ADD    users_read    int(1)           AFTER visibilita,
					  ADD    group_read    int(1)           AFTER visibilita";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
	                  SET ts            = UNIX_TIMESTAMP(data),
						  visitors_read = '".WM3_cENABLED."',
						  users_read    = '".WM3_cENABLED."',
						  group_read    = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   visitors_read = '".WM3_cDISABLED."'
                      WHERE visibilita > 1";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   users_read = '".WM3_cDISABLED."'
                      WHERE visibilita > 2";					  
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums
					  DROP COLUMN data,
					  DROP COLUMN visibilita";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_album_item
                      TO           ".WM3_cCONFIG_DB_PREFIX."_media_albums_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      CHANGE ialbumID    media_album_itemID bigint(20) auto_increment,
                      CHANGE albumID     media_albumID      bigint(20),
                      CHANGE titolo      title              char(255),
                      CHANGE media_t     thumbnail          char(255),
                      CHANGE nvoti       votes_counts       int(16),
                      CHANGE totvoti     votes_sum          int(16),
                      CHANGE mediavoti   votes_average      float,
                      CHANGE fonte       source_media       int(5),
                      CHANGE tipo        source_thumbnail   int(5),
                      CHANGE attivo      enabled            int(1), 
                      CHANGE ling        languageID         bigint(20),
                      DROP COLUMN        data";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   source_media     = '0',
					        source_thumbnail = '0'
                      WHERE source_media = '".WM3_cUPLOAD_FROM_URL."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   source_media     = '".WM3_cUPLOAD_FROM_URL."',
					        source_thumbnail = '".WM3_cUPLOAD_FROM_URL."'
                      WHERE source_media = '".WM3_cUPLOAD_FROM_REMOTE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   source_media     = '".WM3_cUPLOAD_FROM_REMOTE."',
					        source_thumbnail = '".WM3_cUPLOAD_FROM_REMOTE."'
                      WHERE source_media = '0'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
					  DROP COLUMN argomento,
					  DROP COLUMN userID";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_album_sess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items
                      CHANGE asessID media_album_item_sessionID bigint(20) auto_increment,
                      CHANGE aitemID media_album_itemID         bigint(20),
                      CHANGE tipo    session_type               int(5)";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items
                      SET   userID = '".WM3_cUSER_ANONYMOUS."'
                      WHERE userID = '-1'";

     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners
                      CHANGE banID       bannerID    bigint(20) auto_increment,
                      CHANGE nome        title       char(255),
                      CHANGE html        banner      text,
                      CHANGE tipo        banner_type int(5),
                      CHANGE ling        languageID  bigint(20),
                      ADD    ts          int(16)     AFTER languageID,
                      ADD    enabled     int(1)      AFTER banner_type";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners
					  DROP COLUMN data";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits
                       (
                        banner_exchange_creditID bigint(20) primary key auto_increment,
                        userID                   bigint(20),
                        credits                  bigint(20) unsigned,
						unlimited_credits        int(1),
                        ts                       int(16)
                       )";
     $_QUERY_UPD[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits
                      SELECT '',userID,SUM(impressions),IF(SUM(inf_impr) > 0,1,0),'".$update_ts."'
					  FROM   ".WM3_cCONFIG_DB_PREFIX."_banners_rot
					  GROUP BY userID";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_rot
                      TO           ".WM3_cCONFIG_DB_PREFIX."_banners_exchange";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      CHANGE rbanID    bannerID          bigint(20) auto_increment,
                      CHANGE nome      title             char(255),
					  CHANGE etichetta banner_alt        char(255),
					  CHANGE url       banner_url        char(255),
					  CHANGE pic       banner_image      char(255),
                      CHANGE tipo      banner_source     int(5),
                      CHANGE ling      languageID        bigint(20),
					  CHANGE attivo    enabled           int(1),
					  CHANGE ts        temp              int(16),
					  CHANGE data      ts                int(16),
                      DROP COLUMN      pic_url,
					  DROP COLUMN      impressions,
					  DROP COLUMN      inf_impr,
					  CHANGE hits      impressions       bigint(20) unsigned";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
	                  SET languageID = '".WM3_cLANGUAGE_ALL."' WHERE any_lang = '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET ts = temp";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
					  DROP COLUMN  any_lang,
					  DROP COLUMN  temp";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   banner_source = '".WM3_cUPLOAD_FROM_REMOTE."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   banner_source = '".WM3_cUPLOAD_FROM_URL."'
                      WHERE banner_image  = ''";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";

     $_QUERY_UPD[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange
                       (
                        banner_exchange_sessionID bigint(20) primary key auto_increment,
                        banner_exchangeID         bigint(20),
                        sessionID                 bigint(20),
                        userID                    bigint(20),
                        session_type              int(5)
                       )";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_pref
                      TO           ".WM3_cCONFIG_DB_PREFIX."_preferences";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences
                      CHANGE log_on      logging_enabled                   int(1),
                      CHANGE id_ban1     banner1ID                         bigint(20),
                      CHANGE id_ban2     banner2ID                         bigint(20),
                      CHANGE id_ban3     banner3ID                         bigint(20),
                      CHANGE id_ban4     banner4ID                         bigint(20),
                      CHANGE id_ban5     banner5ID                         bigint(20),
                      CHANGE id_ban6     banner6ID                         bigint(20),
                      CHANGE id_ban7     banner7ID                         bigint(20),
                      CHANGE id_ban8     banner8ID                         bigint(20),
                      CHANGE id_ban9     banner9ID                         bigint(20),
					  CHANGE logo        logo                              char(255),
                      CHANGE logox       logo_width                        int(5),
                      CHANGE logoy       logo_height                       int(5),
                      CHANGE site_addr   site_address                      char(255),
                      CHANGE wm_email    webmaster_email                   char(255),
                      CHANGE serv_email  service_email                     char(255),
                      CHANGE condat      foot_content                      int(5),
                      CHANGE num_notizie home_news_max                     int(16),
                      CHANGE usr_act     user_enabled                      int(1),
                      CHANGE usr_spe     user_special                      int(1),                      
                      CHANGE usr_fl1     user_flag1                        int(1),
                      CHANGE usr_fl2     user_flag2                        int(1),
                      CHANGE usr_fl3     user_flag3                        int(1),
                      CHANGE usr_fl4     user_flag4                        int(1),
                      CHANGE usr_fl5     user_flag5                        int(1),
                      CHANGE usr_fl6     user_flag6                        int(1),
                      CHANGE usr_fl7     user_flag7                        int(1),                                                                  
                      CHANGE usr_fl8     user_flag8                        int(1),
                      CHANGE usr_gID     user_groupID                      bigint(20),
                      CHANGE num_nl      show_total_newsletter             int(1),
                      CHANGE num_seg     show_total_signalations           int(1),
                      CHANGE num_mot     show_total_search_engine          int(1),
                      CHANGE num_vis_usr show_online_users_visitors        int(1),
                      CHANGE show_not    show_home_news                    int(1),
                      CHANGE full_not    show_full_news                    int(1),
                      CHANGE show_cnot   enable_news_comments              int(1),
                      CHANGE anon_cnot   anonymous_news_comments           int(1),
                      CHANGE show_hcan   show_home_channels                int(1),
                      CHANGE anon_post   anonymous_write_news              int(1),
                      CHANGE anon_postac anonymous_enabled_news            int(1),
                      CHANGE anon_diradd anonymous_add_directories         int(1),
                      CHANGE anon_diract anonymous_enabled_directories     int(1),
                      CHANGE anon_dirvot anonymous_vote_directories        int(1),
                      CHANGE anon_albvot anonymous_vote_media_albums       int(1),
					  CHANGE ecom_type   ecommerce_type                    int(5),
					  CHANGE cc_wmurl    ecommerce_credit_card_url         char(255),
			          CHANGE moneta      ecommerce_currency                char(255),
					  CHANGE spese_sped  ecommerce_shipping_cost           double,
					  CHANGE scad_cart   ecommerce_cart_expire             int(16),
					  CHANGE ecom_showpr ecommerce_show_catalogue_price    int(1),
                      CHANGE ecom_showex ecommerce_show_extra              int(1),
                      CHANGE tipo_pagam  ecommerce_payment_type            int(5),
					  CHANGE cc_wmprezzo ecommerce_variable_price          char(255),
                      CHANGE cc_wmID     ecommerce_variable_id             char(255),
					  CHANGE rban        banners_exchange_enabled          int(1),
					  CHANGE be_ratio    banners_exchange_ratio            int(16),
                      CHANGE be_extra    banners_exchange_extra_content    text,
                      CHANGE be_attivi   banners_exchange_auto_enabled     int(1),
                      CHANGE be_creini   banners_exchange_starting_credits int(16),
					  ADD    skin                          char(255) AFTER logo_height,
					  ADD    banners_enabled               int(1)    AFTER banner,
					  ADD    hide_left_panels_action_home  int(1)    AFTER service_email,
					  ADD    hide_right_panels_action_home int(1)    AFTER hide_left_panels_action_home,
					  ADD    ts                            int(16)   AFTER logging_enabled,
					  DROP COLUMN ftp_sub,
					  DROP COLUMN ftp_pas,
					  DROP COLUMN editlingua,
					  DROP COLUMN preflingua";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET ecommerce_payment_type        = '0',
                          ecommerce_cart_expire         = '5',
						  skin                          = file_css,
						  hide_left_panels_action_home  = '".WM3_cDISABLED."',
						  hide_right_panels_action_home = '".WM3_cDISABLED."',
						  ts                            = '$update_ts'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET   banners_enabled = '1'
                      WHERE banner          = 'ON'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET   banners_enabled = '0'
                      WHERE banner          = 'OFF'";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences
	                  DROP COLUMN banner,
					  DROP COLUMN file_css,
					  DROP COLUMN fl_home_off";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET banners_exchange_auto_enabled  = banners_exchange_auto_enabled - 1,
					      show_home_channels             = show_home_channels - 1,
						  show_home_news                 = show_home_news - 1,
						  show_full_news                 = show_full_news - 1,
						  enable_news_comments           = enable_news_comments -1,
						  anonymous_news_comments        = anonymous_news_comments - 1,
						  anonymous_write_news           = anonymous_write_news - 1,
						  anonymous_enabled_news         = anonymous_enabled_news - 1,
						  anonymous_add_directories      = anonymous_add_directories - 1,
						  anonymous_enabled_directories  = anonymous_enabled_directories -1,
						  anonymous_vote_directories     = anonymous_vote_directories -1,
						  anonymous_vote_media_albums    = anonymous_vote_media_albums - 1,
                          show_total_newsletter          = show_total_newsletter - 1,
                          show_total_signalations        = show_total_signalations - 1,
                          show_total_search_engine       = show_total_search_engine - 1,
                          show_online_users_visitors     = show_online_users_visitors - 1,
					      ecommerce_show_catalogue_price = ecommerce_show_catalogue_price - 1,
                          ecommerce_show_extra           = ecommerce_show_extra - 1,
                          user_enabled                   = user_enabled - 1,
                          user_special                   = user_special - 1,                      
                          user_flag1                     = user_flag1 - 1,
                          user_flag2                     = user_flag2 - 1,
                          user_flag3                     = user_flag3 - 1,
                          user_flag4                     = user_flag4 - 1,
                          user_flag5                     = user_flag5 - 1,
                          user_flag6                     = user_flag6 - 1,
                          user_flag7                     = user_flag7 - 1,                                                            
                          user_flag8                     = user_flag8 - 1";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_morepref
                      TO           ".WM3_cCONFIG_DB_PREFIX."_preferences_contents";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                      CHANGE mprefID    preferences_contentID           bigint(20) auto_increment,
                      CHANGE titolo     browser_bar_title               char(255),
                      CHANGE big_titolo title                           char(255),
                      CHANGE redazione  staff_name                      char(255),
                      CHANGE specialut  special_user_label              char(255),
                      CHANGE ogg_se     signalation_email_subject       char(255),
                      CHANGE mailse     signalation_email_text          text,
                      CHANGE ogg_ut     user_registration_email_subject char(255),
                      CHANGE mailut     user_registration_email_text    text,
                      CHANGE ling       languageID                      bigint(20),
					  ADD    temp       text                            AFTER head,
                      ADD    ts         int(16)                         AFTER languageID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
	                  SET temp = home,
					      ts   = UNIX_TIMESTAMP(data)";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
	                  DROP COLUMN home,
					  DROP COLUMN data";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                      CHANGE temp home text";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_gb_messaggi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      CHANGE gbmessaggioID messageID  bigint(20) auto_increment,
                      CHANGE nome          name       char(255),
					  CHANGE email         email      char(255),
                      CHANGE messaggio     message    text,
                      CHANGE attivo        enabled    int(1), 
                      CHANGE ling          languageID bigint(20),
					  CHANGE ts            temp       int(16),
					  CHANGE data          ts         int(16),
					  ADD    countryID     bigint(20) AFTER userID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      SET countryID = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = country)";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      SET countryID = '0' WHERE country = '00'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages SET ts = temp";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
					  DROP COLUMN country,
					  DROP COLUMN userID,
					  DROP COLUMN temp";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_counter
                      TO           ".WM3_cCONFIG_DB_PREFIX."_counters";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_counters
                      CHANGE nvis        total_visitors     bigint(20) unsigned,
                      CHANGE nseg        total_signalations bigint(20) unsigned,
                      CHANGE max_vis     max_visitors       int(16),
                      CHANGE lastusr_ip  last_user_ip       char(255),
                      CHANGE lastusr_dns last_user_dns      char(255),
                      CHANGE lastusr_ID  last_userID        bigint(20),
                      CHANGE lastusr_ts  last_user_ts       int(16),
					  ADD    installation_ts int(16),
					  ADD    max_users       int(16)        AFTER max_visitors";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                  SET installation_ts = start_ts,
					      max_users       = max_usr";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_counters
					  DROP COLUMN start_ts,
					  DROP COLUMN max_usr";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_directory
                      TO           ".WM3_cCONFIG_DB_PREFIX."_directories";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_directories
                      CHANGE dirID    directoryID    bigint(20) auto_increment,
                      CHANGE dir_name name           char(255),
					  CHANGE dir_desc description    char(255),
                      CHANGE dir_pic  icon           char(255),
                      CHANGE tipodir  directory_type int(5),
                      CHANGE attivo   enabled        int(1), 
                      CHANGE ling     languageID     bigint(20),
					  CHANGE ts       temp           int(16),
					  CHANGE data     ts             int(16),
					  ADD    parentID bigint(20)     AFTER directoryID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories
	                  SET    parentID = padreID,
					         ts = temp";
     $_QUERY_UPD[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories
	                  DROP COLUMN padreID,
					  DROP COLUMN temp";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_directory_item
                      TO           ".WM3_cCONFIG_DB_PREFIX."_directories_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      CHANGE ditemID           directory_itemID bigint(20) auto_increment,
					  CHANGE dirID             directoryID      bigint(20),
				      CHANGE pagID             pageID           bigint(20),
                      CHANGE titolo            title            char(255),
					  CHANGE descr             description      text,
					  CHANGE url1              home_url         char(255),
					  CHANGE url2              download_url     char(255),
                      CHANGE item_pic          icon             char(255),
                      CHANGE nvoti             votes_counts     int(16),
                      CHANGE totvoti           votes_sum        int(16),
                      CHANGE mediavoti         votes_average    float,					  
                      CHANGE tipoditem         source           int(5),
                      CHANGE attivo            enabled          int(1),
                      CHANGE ling              languageID       bigint(20),
					  CHANGE ts                temp             int(16),
					  CHANGE data              ts               int(16),
					  ADD    render_mode       int(5)           AFTER description,
					  ADD    directory_item_ts int(16)          AFTER source";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."', source = source - 1, ts = temp, directory_item_ts = tsupd";
     $_QUERY_UPD[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items DROP COLUMN temp";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      SET   userID = '".WM3_cUSER_ANONYMOUS."'
                      WHERE userID = '-1'";
     $_QUERY_UPD[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items
	                  DROP COLUMN tsupd";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_directory_sess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items
                      CHANGE dsessID directory_item_sessionID bigint(20) auto_increment,
                      CHANGE ditemID directory_itemID         bigint(20),
                      CHANGE tipo    session_type             int(5)";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items
                      SET   userID = '".WM3_cUSER_ANONYMOUS."'
                      WHERE userID = '-1'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_time_stat
                      TO           ".WM3_cCONFIG_DB_PREFIX."_statistics_history";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_statistics_history
                      CHANGE tstatID    historyID bigint(20) auto_increment,
                      CHANGE anno       year            int(16),
                      CHANGE mese       month           int(2),
					  CHANGE giorno     day             int(2),
					  CHANGE ora        hour            int(2),
					  CHANGE nomegiorno day_of_the_week int(1),
					  DROP COLUMN dataora,
					  DROP COLUMN data";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_log
                      TO           ".WM3_cCONFIG_DB_PREFIX."_logs";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_logs
	                  ADD logID   bigint(20) primary key auto_increment FIRST,
                      ADD adminID bigint(20) AFTER userID";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_logs SET adminID = '0'";

     $_QUERY_UPD[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_wcm
                      TO           ".WM3_cCONFIG_DB_PREFIX."_database";
     $_QUERY_UPD[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_database
	                  CHANGE wcm database_version char(255)";
     $_QUERY_UPD[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_database SET database_version = '".WM3_cDB_VERSION."'";

     for($i = 0; $i < sizeof($_QUERY_UPD); $i++) wm3Sql::sqlQuery($_QUERY_UPD[$i]);
    }

  }

?>
